# कोडिंग इंटरव्यू यूनिवर्सिटी

> मैंने मूल रूप से इसे एक सॉफ्टवेयर इंजीनियर बनने के लिए अध्ययन विषयों की एक छोटी टू-डू सूची के रूप में बनाया था,
> लेकिन यह उस बड़ी सूची तक बढ़ गया है जिसे आप आज देखते हैं। इस अध्ययन योजना को पढ़ने के बाद, [मुझे काम पर रखा गया
> Amazon में एक सॉफ्टवेयर डेवलपमेंट इंजीनियर के रूप में](https://startupnextdoor.com/ive-been-acquired-by-amazon/?src=ciu)!
> आपको शायद उतना अध्ययन नहीं करना पड़ेगा जितना मैंने किया था। वैसे भी, आपकी जरूरत की हर चीज यहां है।
>
> मैंने कई महीनों तक प्रतिदिन लगभग 8-12 घंटे अध्ययन किया। यह मेरी कहानी है: [मैंने एक Google साक्षात्कार के लिए 8 महीने तक पूर्णकालिक अध्ययन क्यों किया](https://medium.freecodecamp.org/why-i-studied-full-time-for-8-months-for-a -google-साक्षात्कार-cc662ce9bb13)
>
> **कृपया ध्यान दें:** आपको मेरे जितना अध्ययन करने की आवश्यकता नहीं होगी। मैंने उन चीजों पर बहुत समय बर्बाद किया जो मुझे जानने की जरूरत नहीं थी। उसके बारे में अधिक जानकारी नीचे। मैं आपका कीमती समय बर्बाद किए बिना वहां पहुंचने में आपकी मदद करूंगा।
>
> यहां सूचीबद्ध आइटम आपको किसी भी सॉफ्टवेयर कंपनी में तकनीकी साक्षात्कार के लिए अच्छी तरह से तैयार करेंगे,
> दिग्गजों सहित: अमेज़ॅन, फेसबुक, गूगल और माइक्रोसॉफ्ट।
>
> *आपको शुभकामनाएं!*

<details>
<summary>
अनुवाद:</summary>

- [中文版本](translations/README-cn.md)
- [Tiếng Việt - Vietnamese](translations/README-vi.md)
- [Español](translations/README-es.md)
- [Português Brasileiro](translations/README-ptbr.md)
- [Polish](translations/README-pl.md)
- [繁體中文](translations/README-tw.md)
- [Japanese (日本語)](translations/README-ja.md)
- [Russian](translations/README-ru.md)
- [German](translations/README-de.md)
- [Bahasa Indonesia](translations/README-id.md)
- [ខ្មែរ - Khmer](translations/README-kh.md)
- [Uzbek](translations/README-uz.md)
- [Bulgarian](translations/README-bg.md)
- [বাংলা - Bangla](translations/README-bn.md)

</details>

<details>
<summary>
अनुवाद जारी है:</summary>
- [עברית](https://github.com/jwasham/coding-interview-university/issues/82)
- [Arabic](https://github.com/jwasham/coding-interview-university/issues/98)
- [Arabic](https://github.com/jwasham/coding-interview-university/issues/98)
- [Turkish](https://github.com/jwasham/coding-interview-university/issues/90)
- [French](https://github.com/jwasham/coding-interview-university/issues/89)
- [Українська](https://github.com/jwasham/coding-interview-university/issues/106)
- [Korean(한국어)](https://github.com/jwasham/coding-interview-university/issues/118)
- [Telugu](https://github.com/jwasham/coding-interview-university/issues/117)
- [Urdu](https://github.com/jwasham/coding-interview-university/issues/519)
- [Thai](https://github.com/jwasham/coding-interview-university/issues/156)
- [Greek](https://github.com/jwasham/coding-interview-university/issues/166)
- [Malayalam](https://github.com/jwasham/coding-interview-university/issues/239)
- [Persian - Farsi](https://github.com/jwasham/coding-interview-university/issues/186)
- [Afrikaans](https://github.com/jwasham/coding-interview-university/issues/1164)

</details>

<div align="center">
	<hr />
    <p>
        <a href="https://github.com/sponsors/jwasham"><strong>प्रायोजक बनें</strong> 
और कोडिंग साक्षात्कार विश्वविद्यालय का समर्थन करें!</a>
    </p>
    <p>
        <strong>विशेष धन्यवाद:</strong>
    </p>
    <div>
        <a href="https://algo.monster/?utm_campaign=jwasham&utm_medium=referral&utm_content=coding-interview-university&utm_source=github">
            <div>
                <img src="https://d3j2pkmjtin6ou.cloudfront.net/sponsors/algo-monster.png" width="300" alt="AlgoMonster">
            </div>
            <div>
                <p>
                    <strong>Master the technical interview without endless grinding.</strong>
                </p>
            </div>
            <div>
                <sup>Created by ex-Google engineers, AlgoMonster will help you crush the technical interview in less time 
                and with fewer sleepless nights grinding away random problems. You will learn the key patterns necessary to solve 
                any interview question and gain the systematic knowledge you need to prove your expertise. Be more confident 
                as you walk into that interview!</sup>
            </div>
        </a>
    </div>
    <hr />
</div>

## यह क्या है?

![
व्हाइटबोर्ड पर कोडिंग - एचबीओ की सिलिकॉन वैली से](https://d3j2pkmjtin6ou.cloudfront.net/coding-at-the-whiteboard-silicon-valley.png)


एक बड़ी कंपनी के लिए सॉफ्टवेयर इंजीनियर बनने के लिए यह मेरी बहु-महीने की अध्ययन योजना है। 

**आवश्यक:** 

* कोडिंग के साथ थोड़ा अनुभव (चर, लूप, तरीके/कार्य, आदि)
* धैर्य
* समय
ध्यान दें कि यह **सॉफ्टवेयर इंजीनियरिंग** के लिए एक अध्ययन योजना है, न कि वेब विकास के लिए। Google, Amazon जैसी बड़ी सॉफ्टवेयर कंपनियां,
फेसबुक और माइक्रोसॉफ्ट सॉफ्टवेयर इंजीनियरिंग को वेब डेवलपमेंट से अलग मानते हैं। उदाहरण के लिए, अमेज़ॅन के पास है
फ्रंटएंड इंजीनियर्स (FEE) और सॉफ्टवेयर डेवलपमेंट इंजीनियर्स (SDE)। ये 2 अलग-अलग भूमिकाएँ और साक्षात्कार हैं
वे समान नहीं होंगे, क्योंकि प्रत्येक की अपनी योग्यताएं हैं। इन कंपनियों को कंप्यूटर विज्ञान के ज्ञान की आवश्यकता होती है
सॉफ्टवेयर विकास / इंजीनियरिंग भूमिकाएँ।

---

## विषयसूची

### अध्ययन योजना
- [यह क्या है?](#क्या-क्या है-यह)
- [इसका उपयोग क्यों करें?](# Why-use-it)
- [इसका उपयोग कैसे करें] (# कैसे-कैसे उपयोग करें-इसे)
- [यह महसूस न करें कि आप पर्याप्त स्मार्ट नहीं हैं](#न-महसूस-आप-नहीं-स्मार्ट-पर्याप्त)
- [वीडियो संसाधनों के बारे में एक नोट](#a-नोट-के बारे में-वीडियो-संसाधन)
- [एक प्रोग्रामिंग भाषा चुनें] (# प्रोग्रामिंग भाषा चुनें)
- [डेटा संरचनाओं और एल्गोरिदम के लिए पुस्तकें](#books-for-data-structures-and-algorithms)
- [साक्षात्कार तैयारी पुस्तकें](#साक्षात्कार-तैयारी-किताबें)
- [मेरी गलतियाँ न करें] (# मेरी गलतियाँ न करें)
- [जो आप कवर नहीं देखेंगे] (# क्या-आप-नहीं-देख-कवर)
- [दैनिक योजना](#दैनिक योजना)
- [कोडिंग प्रश्न अभ्यास] (# कोडिंग-प्रश्न-अभ्यास)
- [कोडिंग समस्याएं] (# कोडिंग-समस्याएं)

### अध्ययन के विषय

- [एल्गोरिदमिक जटिलता / बिग-ओ / एसिम्प्टोटिक विश्लेषण] (# एल्गोरिदमिक-जटिलता--बिग-ओ--एसिम्प्टोटिक-विश्लेषण)
- [डेटा संरचनाएं] (# डेटा-संरचनाएं)
    - [सरणी](#सरणी)
    - [लिंक की गई सूचियाँ] (# लिंक्ड-सूचियाँ)
    - [स्टैक] (#स्टैक)
    - [कतार] (# कतार)
    - [हैश टेबल] (# हैश-टेबल)
- [अधिक ज्ञान](# अधिक-ज्ञान)
    - [द्विआधारी खोज](#द्विआधारी-खोज)
    - [बिटवाइज ऑपरेशंस](#बिटवाइज-ऑपरेशंस)
- [पेड़](#पेड़)
    - [पेड़ - नोट्स और पृष्ठभूमि](#trees---notes--background)
    - [बाइनरी सर्च ट्री: BSTs](#binary-search-trees-bsts)
    - [ढेर/प्राथमिकता कतार/बाइनरी हीप](# हीप--प्राथमिकता-कतार--द्विआधारी-ढेर)
    - संतुलित खोज पेड़ (सामान्य अवधारणा, विवरण नहीं)
    - ट्रैवर्सल: प्रीऑर्डर, इनऑर्डर, पोस्टऑर्डर, बीएफएस, डीएफएस
- [छँटाई] (# छँटाई)
    - चयन
    - प्रविष्टि
    - ढेर बनाएं और छांटें
    - जल्दी से सुलझाएं
    - मर्ज़ सॉर्ट
- [ग्राफ](#ग्राफ)
    - निर्देशित
    - अप्रत्यक्ष
    - सहखंडज मैट्रिक्स
    - निकटता सूची
    - ट्रैवर्सल: बीएफएस, डीएफएस
- [और भी अधिक ज्ञान] (# और भी अधिक-ज्ञान)
    - [पुनरावृत्ति] (# रिकर्सन)
    - [डायनामिक प्रोग्रामिंग] (# डायनामिक-प्रोग्रामिंग)
    - [डिज़ाइन पैटर्न] (# डिज़ाइन-पैटर्न)
    - [कॉम्बिनेटोरिक्स (n चुनें k) और प्रायिकता](#combinatorics-n-choose-k--probability)
    - [एनपी, एनपी-पूर्ण और अनुमान एल्गोरिदम] (# एनपी-एनपी-पूर्ण-और-सन्निकटन-एल्गोरिदम)
    - [कंप्यूटर प्रोग्राम को कैसे प्रोसेस करते हैं](#how-कंप्यूटर-प्रोसेस-ए-प्रोग्राम)
    - [कैश] (# कैश)
    - [प्रक्रियाएं और धागे] (# प्रक्रियाएं-और-धागे)
    - [परीक्षण] (# परीक्षण)
    - [स्ट्रिंग खोज और जोड़तोड़] (# स्ट्रिंग-खोज--हेरफेर)
    - [कोशिश करता है] (# प्रयास करता है)
    - [फ़्लोटिंग पॉइंट नंबर] (# फ़्लोटिंग-पॉइंट-नंबर)
    - [यूनिकोड] (# यूनिकोड)
    - [एंडियननेस](#endianness)
    - [नेटवर्किंग] (# नेटवर्किंग)
- [अंतिम समीक्षा](#अंतिम समीक्षा)
### नौकरी पाना

- [अपना रिज्यूमे अपडेट करें](#अपडेट-अपना रिज्यूमे)
- [नौकरी खोजें](# एक नौकरी खोजें)
- [साक्षात्कार प्रक्रिया और सामान्य साक्षात्कार तैयारी](#साक्षात्कार-प्रक्रिया-सामान्य-साक्षात्कार-तैयारी)
- [साक्षात्कार आने के समय के बारे में सोचें]
- [साक्षात्कारकर्ता के लिए प्रश्न हैं](#हैव-प्रश्न-के लिए-साक्षात्कारकर्ता)
- [वन्स यू हैव गॉट द जॉब] (# वन्स-यूव-गोट-द-जॉब)

***** इस बिंदु के नीचे सब कुछ वैकल्पिक है ----------------**

### वैकल्पिक अतिरिक्त विषय और संसाधन

- [अतिरिक्त पुस्तकें](#अतिरिक्त पुस्तकें)
- [सिस्टम डिज़ाइन, स्केलेबिलिटी, डेटा हैंडलिंग] (# सिस्टम-डिज़ाइन-स्केलेबिलिटी-डेटा-हैंडलिंग) (यदि आपके पास 4+ वर्ष का अनुभव है)
- [अतिरिक्त शिक्षण](#अतिरिक्त-शिक्षण)
    - [संकलक](#संकलक)
    - [Emacs और vi(m)](#emacs-and-vim)
    - [यूनिक्स कमांड लाइन टूल्स] (# यूनिक्स-कमांड-लाइन-टूल्स)
    - [सूचना सिद्धांत](#सूचना-सिद्धांत-वीडियो)
    - [समता और हैमिंग कोड] (# समता--हैमिंग-कोड-वीडियो)
    - [एंट्रॉपी] (#एंट्रॉपी)
    - [क्रिप्टोग्राफी](#क्रिप्टोग्राफी)
    - [संपीड़न](#संपीड़न)
    - [कंप्यूटर सुरक्षा](#कंप्यूटर-सुरक्षा)
    - [कचरा संग्रह] (# कचरा संग्रह)
    - [समानांतर प्रोग्रामिंग] (# समानांतर प्रोग्रामिंग)
    - [मैसेजिंग, सीरियलाइज़ेशन, और क्यूइंग सिस्टम](#messaging-serialization-and-queueing-systems)
    - [ए*](#ए)
    - [फास्ट फूरियर ट्रांसफॉर्म](#फास्ट-फूरियर-ट्रांसफॉर्म)
    - [ब्लूम फ़िल्टर](#ब्लूम-फ़िल्टर)
    - [हाइपरलॉगलॉग](#हाइपरलॉगलॉग)
    - [इलाके-संवेदनशील हैशिंग](#इलाके-संवेदी-हैशिंग)
    - [वैन एम्दे बोस ट्री](#van-emde-boas-trees)
    - [संवर्धित डेटा संरचनाएं] (# संवर्धित-डेटा-संरचनाएं)
    - [संतुलित खोज वृक्ष](#संतुलित-खोज-वृक्ष)
        - एवीएल पेड़
        - स्प्ले पेड़
        - लाल/काले पेड़
        - 2-3 सर्च ट्री
        - 2-3-4 पेड़ (उर्फ 2-4 पेड़)
        - एन-आर्य (के-आर्य, एम-आर्य) पेड़
        - बी-पेड़
    - [के-डी पेड़](#के-डी-पेड़)
    - [छोड़ें सूचियां](#छोड़ें-सूचियां)
    - [नेटवर्क प्रवाह](# नेटवर्क-प्रवाह)
    - [असंबद्ध सेट और संघ खोजें] (# असंबद्ध-सेट--संघ-खोज)
    - [तेजी से प्रसंस्करण के लिए गणित](# गणित के लिए तेजी से प्रसंस्करण)
    - [ट्रीप] (#treap)
    - [रैखिक प्रोग्रामिंग](#रैखिक-प्रोग्रामिंग-वीडियो)
    - [ज्यामिति, उत्तल पतवार] (# ज्यामिति-उत्तल-पतवार-वीडियो)
    - [असतत गणित] (# असतत-गणित)
- [कुछ विषयों पर अतिरिक्त विवरण](#अतिरिक्त-विवरण-पर-कुछ-विषयों)
- [वीडियो श्रृंखला](#वीडियो-श्रृंखला)
- [कंप्यूटर विज्ञान पाठ्यक्रम](#कंप्यूटर-विज्ञान-पाठ्यक्रम)
- [कागजात](#कागजात)

---

## इसका उपयोग क्यों करें?

अगर आप किसी बड़ी कंपनी में सॉफ्टवेयर इंजीनियर के तौर पर काम करना चाहते हैं तो ये बातें आपको जाननी चाहिए।

यदि आप कंप्यूटर विज्ञान में डिग्री प्राप्त करने से चूक गए, जैसे मैंने किया, तो यह आपको पकड़ लेगा और आपके जीवन के चार साल बचाएगा।

जब मैंने इस परियोजना को शुरू किया, तो मुझे ढेर से ढेर का पता नहीं था, बिग-ओ को कुछ भी नहीं पता था, या पेड़ों के बारे में कुछ भी नहीं पता था, या कैसे करना है
एक ग्राफ पार करें। अगर मुझे एक सॉर्टिंग एल्गोरिदम कोड करना पड़ा, तो मैं आपको बता सकता हूं कि यह भयानक होता।
मेरे द्वारा उपयोग की जाने वाली प्रत्येक डेटा संरचना भाषा में बनाई गई थी, और मुझे नहीं पता था कि उन्होंने कैसे काम किया
हुड के नीचे बिल्कुल। मुझे कभी भी स्मृति का प्रबंधन नहीं करना पड़ा जब तक कि मैं जो प्रक्रिया चला रहा था वह "आउट ऑफ"
मेमोरी" त्रुटि, और फिर मुझे एक समाधान खोजना होगा। मैंने अपने जीवन में कुछ बहुआयामी सरणियों का उपयोग किया और
हजारों सहयोगी सरणियाँ, लेकिन मैंने कभी भी खरोंच से डेटा संरचनाएँ नहीं बनाईं।

यह एक लंबी योजना है। आपको महीनों लग सकते हैं। यदि आप पहले से ही इसके बारे में बहुत कुछ जानते हैं तो इसमें आपको बहुत कम समय लगेगा।

## इसका उपयोग कैसे करना है

नीचे सब कुछ एक रूपरेखा है, और आपको ऊपर से नीचे तक वस्तुओं से निपटना चाहिए।

मैं गिटहब के विशेष मार्कडाउन स्वाद का उपयोग कर रहा हूं, जिसमें प्रगति को ट्रैक करने के लिए कार्य सूचियां शामिल हैं।
  - [GitHub-फ्लेवर्ड मार्कडाउन के बारे में अधिक जानकारी](https://guides.github.com/features/mastering-markdown/#GitHub-flavored-markdown)

### यदि आप git . का उपयोग नहीं करना चाहते हैं

इस पृष्ठ पर, शीर्ष के पास कोड बटन पर क्लिक करें, फिर "ज़िप डाउनलोड करें" पर क्लिक करें। फ़ाइल को अनज़िप करें और आप टेक्स्ट फ़ाइलों के साथ काम कर सकते हैं।

यदि आप एक ऐसे कोड संपादक में खुले हैं जो मार्कडाउन को समझता है, तो आप देखेंगे कि सब कुछ अच्छी तरह से स्वरूपित है।

![रेपो को ज़िप फ़ाइल के रूप में कैसे डाउनलोड करें](https://d3j2pkmjtin6ou.cloudfront.net/how-to-download-as-zip.png)

### यदि आप गिट के साथ सहज हैं

एक नई शाखा बनाएँ ताकि आप इस तरह की वस्तुओं की जाँच कर सकें, बस कोष्ठक में एक x डालें: [x]
1. *** फोर्क द गिटहब रेपो:*** `https://github.com/jwasham/coding-interview-university` फोर्क बटन पर क्लिक करके।

    ![फोर्क द गिटहब रेपो](https://d3j2pkmjtin6ou.cloudfront.net/fork-button.png)

1. अपने स्थानीय रेपो को क्लोन करें:

    ```
    git क्लोन git@github.com:<your_github_username>/coding-interview-university.git
    सीडी कोडिंग-साक्षात्कार-विश्वविद्यालय
    गिट चेकआउट-बी प्रगति
    git रिमोट jwasham जोड़ें https://github.com/jwasham/coding-interview-university
    गिट फ़ेच --all
    ```

1. अपने परिवर्तन पूर्ण करने के बाद सभी बक्सों को X से चिह्नित करें:

    ```
    गिट जोड़ें।
    गिट प्रतिबद्ध-एम "चिह्नित एक्स"
    git rebase jwasham/main
    गिट पुश --सेट-अपस्ट्रीम मूल प्रगति
    गिट पुश --फोर्स
    ```

## यह महसूस न करें कि आप पर्याप्त स्मार्ट नहीं हैं

- सफल सॉफ्टवेयर इंजीनियर होशियार होते हैं, लेकिन बहुतों में असुरक्षा की भावना होती है कि वे पर्याप्त स्मार्ट नहीं हैं।
- निम्नलिखित वीडियो आपको इस असुरक्षा को दूर करने में मदद कर सकते हैं:
    - [द मिथ ऑफ़ द जीनियस प्रोग्रामर](https://www.youtube.com/watch?v=0SARbwvhupQ)
    - [इट्स डेंजरस टू गो अलोन: बैटलिंग द इनविजिबल मॉन्स्टर्स इन टेक](https://www.youtube.com/watch?v=1i8ylq4j_EY)

## वीडियो संसाधनों के बारे में एक नोट

कुछ वीडियो केवल कौरसेरा या एडएक्स कक्षा में नामांकन करके उपलब्ध होते हैं। इन्हें एमओओसी कहा जाता है।
कभी-कभी कक्षाएं सत्र में नहीं होती हैं, इसलिए आपको कुछ महीने इंतजार करना पड़ता है, इसलिए आपके पास पहुंच नहीं है।

ऑनलाइन पाठ्यक्रम संसाधनों को मुफ्त और हमेशा उपलब्ध सार्वजनिक स्रोतों से बदलना बहुत अच्छा होगा,
जैसे YouTube वीडियो (अधिमानतः विश्वविद्यालय व्याख्यान), ताकि आप लोग इनका कभी भी अध्ययन कर सकें,
केवल तब नहीं जब कोई विशिष्ट ऑनलाइन पाठ्यक्रम सत्र में हो।

## प्रोग्रामिंग भाषा चुनें

आपके द्वारा किए जाने वाले कोडिंग साक्षात्कार के लिए आपको एक प्रोग्रामिंग भाषा चुननी होगी,
लेकिन आपको एक ऐसी भाषा भी ढूंढनी होगी जिसका उपयोग आप कंप्यूटर विज्ञान अवधारणाओं का अध्ययन करने के लिए कर सकें।

अधिमानतः भाषा वही होगी, इसलिए आपको केवल एक में कुशल होने की आवश्यकता है।

### इस अध्ययन योजना के लिए

जब मैंने अध्ययन की योजना बनाई, तो मैंने इसमें से अधिकांश के लिए 2 भाषाओं का उपयोग किया: C और Python

* सी: बहुत निम्न स्तर। आपको पॉइंटर्स और मेमोरी आवंटन/डीलोकेशन से निपटने की अनुमति देता है, ताकि आप डेटा संरचनाओं को महसूस कर सकें
    और आपकी हड्डियों में एल्गोरिदम। पायथन या जावा जैसी उच्च स्तरीय भाषाओं में, ये आपसे छिपी हुई हैं। दिन-प्रतिदिन के काम में, यह बहुत बढ़िया है,
    लेकिन जब आप सीख रहे हैं कि ये निम्न-स्तरीय डेटा संरचनाएं कैसे बनाई जाती हैं, तो धातु के करीब महसूस करना बहुत अच्छा होता है।
    - सी हर जगह है। जब आप अध्ययन कर रहे हों तो आपको पुस्तकों, व्याख्यानों, वीडियो, *हर जगह* में उदाहरण दिखाई देंगे।
    - [द सी प्रोग्रामिंग लैंग्वेज, वॉल्यूम 2](https://www.amazon.com/Programming-Language-Brian-W-Kernighan/dp/0131103628)
        - यह एक छोटी किताब है, लेकिन यह आपको सी भाषा पर एक अच्छी पकड़ देगी और यदि आप इसका थोड़ा अभ्यास करते हैं
            आप जल्दी से कुशल हो जाएंगे। C को समझने से आपको यह समझने में मदद मिलती है कि प्रोग्राम और मेमोरी कैसे काम करते हैं।
        - आपको किताब में बहुत गहराई तक जाने की जरूरत नहीं है (या इसे खत्म भी करें)। बस वहां पहुंचें जहां आप सी में पढ़ने और लिखने में सहज हों।
        - [पुस्तक में प्रश्नों के उत्तर](https://github.com/lekkas/c-algorithms)
* पायथन: आधुनिक और बहुत अभिव्यंजक, मैंने इसे सीखा क्योंकि यह बहुत उपयोगी है और मुझे एक साक्षात्कार में कम कोड लिखने की भी अनुमति देता है।

यह मेरी पसंद है। आप वही करते हैं जो आपको पसंद है, बिल्कुल।

आपको इसकी आवश्यकता नहीं हो सकती है, लेकिन नई भाषा सीखने के लिए यहां कुछ साइटें दी गई हैं:
- [व्यायाम](https://exercism.org/tracks)
- [कोडवार्स] (http://www.codewars.com)
- [कोडिलिटी](https://codility.com/programmers/)
- [हैकरअर्थ](https://www.hackerearth.com/)
- [क्षेत्र ऑनलाइन न्यायाधीश (spoj)] (http://www.spoj.com/)
- [कोडशेफ](https://www.codechef.com/)
- [कोडफोर्स] (https://codeforces.com/)
- [स्केलर विषय](https://www.scaler.com/topics/)

### आपके कोडिंग इंटरव्यू के लिए

आप उस भाषा का उपयोग कर सकते हैं जिसमें आप साक्षात्कार के कोडिंग भाग को करने के लिए सहज हैं, लेकिन बड़ी कंपनियों के लिए, ये ठोस विकल्प हैं:

- सी++
- जावा
- पायथन

आप इनका उपयोग भी कर सकते हैं, लेकिन पहले पढ़ लें। चेतावनी हो सकती है:

- जावास्क्रिप्ट
- माणिक
साक्षात्कार के लिए भाषा चुनने के बारे में मैंने यहां एक लेख लिखा है:
[कोडिंग इंटरव्यू के लिए एक भाषा चुनें](https://startupnextdoor.com/important-pick-one-language-for-the-coding-interview/)।
यह मूल लेख है जिस पर मेरी पोस्ट आधारित थी: [साक्षात्कार के लिए प्रोग्रामिंग भाषा चुनना](https://web.archive.org/web/20210516054124/http://blog.codingforinterviews.com/best-programming-language- नौकरियां/)

आपको भाषा में बहुत सहज होने और जानकार होने की आवश्यकता है।

विकल्पों के बारे में और पढ़ें:
- [अपने कोडिंग साक्षात्कार के लिए सही भाषा चुनें](http://www.byte-by-byte.com/choose-the-right-language-for-your-coding-interview/)

[यहां भाषा-विशिष्ट संसाधन देखें] (प्रोग्रामिंग-भाषा-संसाधन.एमडी)

## डेटा संरचनाओं और एल्गोरिदम के लिए पुस्तकें

यह पुस्तक कंप्यूटर विज्ञान के लिए आपकी नींव बनाएगी।

बस एक को चुनें, ऐसी भाषा में जिसमें आप सहज हों। आप बहुत सारी रीडिंग और कोडिंग कर रहे होंगे।

### सी

- [सी में एल्गोरिदम, भाग 1-5 (बंडल), तीसरा संस्करण](https://www.amazon.com/Algorithms-Parts-1-5-Bundle-Fundamentals/dp/0201756080)
    - बुनियादी बातों, डेटा संरचनाएं, छँटाई, खोज, और ग्राफ़ एल्गोरिथम

### पायथन

- [पायथन में डेटा संरचनाएं और एल्गोरिदम](https://www.amazon.com/Structures-Algorithms-Python-Michael-Goodrich/dp/1118290275/)
    - गुडरिक, तमासिया, गोल्डवासेर द्वारा
    - मुझे यह किताब पसंद आई। इसने सब कुछ और बहुत कुछ कवर किया।
    - पाइथोनिक कोड
    - माय ग्लोइंग बुक रिपोर्ट: https://startupnextdoor.com/book-report-data-structures-and-algorithms-in-python/

### जावा

आपकी पंसद:

- गुडरिक, तमासिया, गोल्डवासेर
    - [जावा में डेटा संरचनाएं और एल्गोरिदम] (https://www.amazon.com/Data-Structures-Algorithms-Michael-Goodrich/dp/1118771338/)
- सेडगेविक और वेन:
    - [एल्गोरिदम] (https://www.amazon.com/Algorithms-4th-Robert-Sedgewick/dp/032157351X/)
    - नि: शुल्क कौरसेरा पाठ्यक्रम जो पुस्तक को कवर करता है (लेखकों द्वारा पढ़ाया जाता है!):
        - [एल्गोरिदम I](https://www.coursera.org/learn/algorithms-part1)
        - [एल्गोरिदम II](https://www.coursera.org/learn/algorithms-part2)

### सी++

आपकी पंसद:

- गुडरिक, तमासिया और माउंट
    - [C++ में डेटा संरचनाएं और एल्गोरिदम, दूसरा संस्करण](https://www.amazon.com/Data-Structures-Algorithms-Michael-Goodrich/dp/0470383275)
- सेडगेविक और वेन
    - [सी ++ में एल्गोरिदम, भाग 1-4: बुनियादी बातों, डेटा संरचना, छँटाई, खोज] (https://www.amazon.com/Algorithms-Parts-1-4-Fundamentals-Structure/dp/0201350882/)
    - [सी ++ भाग 5 में एल्गोरिदम: ग्राफ़ एल्गोरिदम] (https://www.amazon.com/Algorithms-Part-Graph-3rd-Pt-5/dp/020136183/)

## साक्षात्कार तैयारी पुस्तकें
आपको इनमें से एक गुच्छा खरीदने की ज़रूरत नहीं है। ईमानदारी से "कोडिंग साक्षात्कार को क्रैक करना" शायद पर्याप्त है,
लेकिन मैंने खुद को और अधिक अभ्यास देने के लिए और अधिक खरीदा। लेकिन मैं हमेशा बहुत ज्यादा करता हूं।

मैंने ये दोनों खरीदे। उन्होंने मुझे काफी अभ्यास दिया।

- [प्रोग्रामिंग इंटरव्यू एक्सपोज़्ड: कोडिंग योर वे थ्रू इंटरव्यू, चौथा संस्करण](https://www.amazon.com/Programming-Interviews-Exposed-Through-Interview/dp/111941847X/)
    - सी ++ और जावा में उत्तर
    - कोडिंग इंटरव्यू को क्रैक करने के लिए यह एक अच्छा अभ्यास है
    - ज्यादा मुश्किल नहीं है। एक साक्षात्कार में आप जो देखेंगे उससे अधिकतर समस्याएं आसान हो सकती हैं (जो मैंने पढ़ा है)
- [कोडिंग साक्षात्कार को क्रैक करना, छठा संस्करण] (http://www.amazon.com/Cracking-Coding-Interview-6th-Programming/dp/0984782850/)
    - जावा में उत्तर

### यदि आपके पास अतिरिक्त समय है:

एक का चयन:

- [प्रोग्रामिंग साक्षात्कार के तत्व (C++ संस्करण)](https://www.amazon.com/Elements-Programming-Interviews-Insiders-Guide/dp/1479274836)
- [पायथन में प्रोग्रामिंग साक्षात्कार के तत्व](https://www.amazon.com/Elements-Programming-Interviews-Python-Insiders/dp/1537713949/)
- [प्रोग्रामिंग साक्षात्कार के तत्व (जावा संस्करण)](https://www.amazon.com/Elements-Programming-Interviews-Java-Insiders/dp/1517435803/)
        - [सहयोगी परियोजना - पुस्तक में हर समस्या के लिए विधि आधार और परीक्षण मामले](https://github.com/gardncl/elements-of-programming-interviews)

## मेरी गलती मत करो

यह सूची कई महीनों में बढ़ी, और हाँ, यह हाथ से निकल गई।

यहां कुछ गलतियां हैं जो मैंने की हैं ताकि आपके पास बेहतर अनुभव हो। और आप महीनों का समय बचाएंगे।

### 1. आपको यह सब याद नहीं रहेगा

मैंने घंटों वीडियो देखे और प्रचुर मात्रा में नोट्स लिए, और महीनों बाद बहुत कुछ ऐसा था जो मुझे याद नहीं था। मैंने जाने में 3 दिन बिताए
अपने नोट्स और फ्लैशकार्ड बनाकर, ताकि मैं समीक्षा कर सकूं। मुझे उस सब ज्ञान की आवश्यकता नहीं थी।

कृपया, पढ़ें ताकि आप मेरी गलतियाँ न करें:

[रिटेनिंग कंप्यूटर साइंस नॉलेज](https://startupnextdoor.com/retaining-computer-science-knowledge/)।

### 2. फ्लैशकार्ड का प्रयोग करें

समस्या को हल करने के लिए, मैंने एक छोटी फ्लैशकार्ड साइट बनाई जहां मैं 2 प्रकार के फ्लैशकार्ड जोड़ सकता था: सामान्य और कोड।
प्रत्येक कार्ड में अलग-अलग स्वरूपण होते हैं। मैंने एक मोबाइल-फर्स्ट वेबसाइट बनाई है, इसलिए मैं अपने फोन या टैबलेट पर समीक्षा कर सकता हूं, चाहे मैं कहीं भी रहूं।

मुफ्त में अपना बनाएं:

- [फ्लैशकार्ड साइट रेपो](https://github.com/jwasham/computer-science-flash-cards)

**मैं अपने फ्लैशकार्ड का उपयोग करने की अनुशंसा नहीं करता।** बहुत अधिक हैं और उनमें से अधिकांश सामान्य ज्ञान हैं जिनकी आपको आवश्यकता नहीं है।

लेकिन अगर आप मेरी बात नहीं सुनना चाहते हैं, तो आप यहां जाएं:
- [माई फ्लैश कार्ड डेटाबेस (1200 कार्ड्स)](https://github.com/jwasham/computer-science-flash-cards/blob/main/cards-jwasham.db):
- [माई फ्लैश कार्ड डेटाबेस (एक्सट्रीम - 1800 कार्ड्स)](https://github.com/jwasham/computer-science-flash-cards/blob/main/cards-jwasham-extreme.db):


ध्यान रखें कि मैं पानी में डूब गया था और मेरे पास असेंबली भाषा और पायथन ट्रिविया से लेकर मशीन लर्निंग और सांख्यिकी तक सब कुछ कवर करने वाले कार्ड हैं।
जो आवश्यक है उसके लिए यह बहुत अधिक है।

**फ्लैशकार्ड पर ध्यान दें:** पहली बार जब आप पहचानते हैं कि आपको उत्तर पता है, तो इसे ज्ञात के रूप में चिह्नित न करें। आपको देखना है
एक ही कार्ड और वास्तव में इसे जानने से पहले कई बार सही उत्तर दें। दोहराव उस ज्ञान को और गहरा कर देगा
आपका दिमाग।

मेरी फ्लैशकार्ड साइट का उपयोग करने का एक विकल्प [अंकी] (http://ankisrs.net/) है, जिसकी मुझे कई बार सिफारिश की गई है।
यह आपको याद रखने में मदद करने के लिए एक दोहराव प्रणाली का उपयोग करता है। यह उपयोगकर्ता के अनुकूल है, सभी प्लेटफार्मों पर उपलब्ध है और इसमें क्लाउड सिंक सिस्टम है।
आईओएस पर इसकी कीमत 25 डॉलर है लेकिन यह अन्य प्लेटफॉर्म पर मुफ्त है।

Anki प्रारूप में मेरा फ्लैशकार्ड डेटाबेस: https://ankiweb.net/shared/info/25173560 (धन्यवाद [@xiewenya](https://github.com/xiewenya))।

कुछ छात्रों ने सफेद स्थान के साथ स्वरूपण मुद्दों का उल्लेख किया है जिन्हें निम्नलिखित करके ठीक किया जा सकता है: डेक खोलें, कार्ड संपादित करें, कार्ड क्लिक करें, "स्टाइलिंग" रेडियो बटन चुनें, सदस्य "व्हाइट-स्पेस: प्री;" जोड़ें। कार्ड वर्ग के लिए।

### 3. जब आप सीख रहे हों तो साक्षात्कार के प्रश्नों की कोडिंग करें

यह बहुत महत्वपूर्ण है।

जब आप डेटा संरचना और एल्गोरिदम सीख रहे हों, तब साक्षात्कार के प्रश्नों की कोडिंग करना शुरू करें।

आप जो सीख रहे हैं उसे समस्याओं को हल करने के लिए लागू करने की आवश्यकता है, या आप भूल जाएंगे। मैंने यह गलती की।

एक बार जब आप कोई विषय सीख लेते हैं, और उसके साथ कुछ सहज महसूस करते हैं, उदाहरण के लिए, **लिंक्ड सूचियां**:
1. [कोडिंग इंटरव्यू बुक्स] (#इंटरव्यू-प्रेप-बुक्स) (या कोडिंग प्रॉब्लम वेबसाइट्स, नीचे सूचीबद्ध) में से एक खोलें
1. लिंक्ड सूचियों के संबंध में 2 या 3 प्रश्न करें।
1. अगले सीखने के विषय पर आगे बढ़ें।
1. बाद में, वापस जाएं और अन्य 2 या 3 लिंक की गई सूची की समस्याएं करें।
1. अपने द्वारा सीखे गए प्रत्येक नए विषय के साथ ऐसा करें।

**समस्याएँ तब करते रहें जब आप यह सब सीख रहे हों, उसके बाद नहीं।**

आपको ज्ञान के लिए काम पर नहीं रखा जा रहा है, लेकिन आप ज्ञान को कैसे लागू करते हैं।

इसके लिए कई संसाधन हैं, जो नीचे सूचीबद्ध हैं। बढ़ा चल।

### 4. फोकस

बहुत सारे विकर्षण हैं जो मूल्यवान समय ले सकते हैं। फोकस और एकाग्रता कठिन है। कुछ संगीत चालू करें
गीत के बिना और आप बहुत अच्छी तरह से ध्यान केंद्रित करने में सक्षम होंगे।

## जिसे आप कवर नहीं देखेंगे

ये प्रचलित प्रौद्योगिकियां हैं लेकिन इस अध्ययन योजना का हिस्सा नहीं हैं:

- एसक्यूएल
- जावास्क्रिप्ट
- HTML, CSS और अन्य फ्रंट-एंड प्रौद्योगिकियां

## दैनिक योजना

यह कोर्स बहुत सारे विषयों पर चलता है। प्रत्येक में शायद आपको कुछ दिन लगेंगे, या शायद एक सप्ताह या उससे भी अधिक समय लगेगा। यह आपके शेड्यूल पर निर्भर करता है।

प्रत्येक दिन, सूची में अगला विषय लें, उस विषय के बारे में कुछ वीडियो देखें, और फिर एक कार्यान्वयन लिखें
उस डेटा संरचना या एल्गोरिथम की भाषा में जिसे आपने इस पाठ्यक्रम के लिए चुना है।

आप मेरा कोड यहाँ देख सकते हैं:
 - [सी] (https://github.com/jwasham/practice-c)
 - [सी++](https://github.com/jwasham/practice-cpp)
 - [पायथन](https://github.com/jwasham/practice-python)

आपको प्रत्येक एल्गोरिदम को याद रखने की आवश्यकता नहीं है। आपको अपना खुद का कार्यान्वयन लिखने में सक्षम होने के लिए इसे पर्याप्त रूप से समझने में सक्षम होना चाहिए।

## कोडिंग प्रश्न अभ्यास

    यह यहाँ क्यों है? मैं साक्षात्कार के लिए तैयार नहीं हूं।

[फिर वापस जाएं और इसे पढ़ें।](#3-डू-कोडिंग-साक्षात्कार-प्रश्न-जबकि-आप-सीख रहे हैं)

आपको प्रोग्रामिंग समस्याओं का अभ्यास करने की आवश्यकता क्यों है:
- समस्या की पहचान, और जहां सही डेटा संरचनाएं और एल्गोरिदम फिट होते हैं
- समस्या के लिए आवश्यकताओं को इकट्ठा करना
- समस्या के माध्यम से अपने तरीके से बात करना जैसे आप साक्षात्कार में करेंगे
- व्हाइटबोर्ड या पेपर पर कोडिंग, कंप्यूटर पर नहीं
- आपके समाधान के लिए समय और स्थान की जटिलता के साथ आ रहा है (नीचे बिग-ओ देखें)
- अपने समाधानों का परीक्षण

एक साक्षात्कार में व्यवस्थित, संचार समस्या समाधान के लिए एक महान परिचय है। आप इसे प्रोग्रामिंग से प्राप्त करेंगे
साक्षात्कार पुस्तकें भी, लेकिन मुझे यह बकाया लगा:
[एल्गोरिदम डिज़ाइन कैनवास](http://www.hiredintech.com/algorithm-design/)

व्हाइटबोर्ड या पेपर पर कोड लिखें, कंप्यूटर पर नहीं। कुछ नमूना इनपुट के साथ परीक्षण करें। फिर इसे टाइप करें और कंप्यूटर पर इसका परीक्षण करें।

अगर आपके घर में व्हाइटबोर्ड नहीं है, तो किसी आर्ट स्टोर से एक बड़ा ड्राइंग पैड लें। आप सोफे पर बैठकर अभ्यास कर सकते हैं।
यह मेरा "सोफा व्हाइटबोर्ड" है। मैंने फोटो में पेन को सिर्फ स्केल के लिए जोड़ा है। यदि आप कलम का उपयोग करते हैं, तो आप चाहते हैं कि आप मिटा सकें।
जल्दी गन्दा हो जाता है। **मैं पेंसिल और इरेज़र का उपयोग करता हूं।**

![मेरा सोफ़ा व्हाइटबोर्ड](https://d3j2pkmjtin6ou.cloudfront.net/art_board_sm_2.jpg)

**कोडिंग प्रश्न अभ्यास प्रोग्रामिंग समस्याओं के उत्तर याद रखने के बारे में नहीं है।**

## कोडिंग समस्याएं

अपनी मुख्य कोडिंग साक्षात्कार पुस्तकें [यहां] (# साक्षात्कार-प्रीप-किताबें) न भूलें।

समस्याओं को सुलझा रहा:
- [कैसे समाधान खोजें](https://www.topcoder.com/thrive/articles/How%20To%20Find%20a%20Solution)
- [टॉपकोडर प्रॉब्लम स्टेटमेंट को कैसे डिसाइड करें](https://www.topcoder.com/thrive/articles/How%20To%20Dissect%20a%20Topcoder%20Problem%20Statement%20Content)

कोडिंग साक्षात्कार प्रश्न वीडियो:
- [आईडीसर्व (88 वीडियो)](https://www.youtube.com/playlist?list=PLamzFoFxwoNjPfxzaWqs7cZGsPYy0x_gI)
- [तुषार रॉय (5 प्लेलिस्ट)](https://www.youtube.com/user/tusharroy2525/playlists?shelf_id=2&view=50&sort=dd)
    - समस्या समाधान के पूर्वाभ्यास के लिए सुपर
- [निक व्हाइट - LeetCode Solutions (187 वीडियो)](https://www.youtube.com/playlist?list=PLU_sdQYzUj2keVENTP0a5rdykRSgg9Wp-)
    - समाधान और कोड की अच्छी व्याख्या
    - आप कम समय में कई देख सकते हैं
- [फिशरकोडर - लीटकोड सॉल्यूशंस](https://youtube.com/FisherCoder)
- [नीटकोड - ब्लाइंड 75 लीटकोड सॉल्यूशंस](https://www.youtube.com/watch?v=KLlXCFG5TnA&list=PLot-Xpze53ldVwtstag2TL4HQhAnC8ATf)
    - समाधान और अजगर कोड की अच्छी व्याख्या
    - सभी प्रश्नों की सूची के लिए [एक्सेल शीट](https://docs.google.com/spreadsheets/d/1A2PaQKcdwO_lwxz9bAnxXnIQayCouZP6d-ENrBz_NXc/edit#gid=0) भी चेकआउट करें
    - [Github लिंक](https://github.com/neetcode-gh/leetcode) सभी समाधान कोड के लिए
    - [नीटकोड 150](https://neetcode.io/)

चुनौती साइटें:
- [लीटकोड] (https://leetcode.com/)
    - मेरी पसंदीदा कोडिंग समस्या साइट। यह आपके द्वारा तैयार किए जा रहे 1-2 महीनों के लिए सदस्यता राशि के लायक है।
    - कोड वॉक-थ्रू के लिए ऊपर निक व्हाइट और फिशरकोडर वीडियो देखें।
- [हैकररैंक](https://www.hackerrank.com/)
- [टॉपकोडर](https://www.topcoder.com/)
- [गीक्स फॉर गीक्स](https://practice.geeksforgeeks.org/explore/?page=1)
- [इंटरव्यूबिट] (https://www.interviewbit.com/)
- [प्रोजेक्ट यूलर](https://projecteuler.net/)
- [AlgoExpert](https://www.algoexpert.io/product)
    - Google इंजीनियरों द्वारा बनाया गया, यह आपके कौशल को सुधारने के लिए भी एक उत्कृष्ट संसाधन है।

## आएँ शुरू करें

ठीक है, बहुत हुई बात, आइए जानें!

लेकिन जब आप सीखते हैं तो ऊपर से कोडिंग की समस्याएं करना न भूलें!

## एल्गोरिथम जटिलता / बिग-ओ / स्पर्शोन्मुख विश्लेषण

- यहां लागू करने के लिए कुछ भी नहीं है, आप केवल वीडियो देख रहे हैं और नोट्स ले रहे हैं! वाह!
- यहां बहुत सारे वीडियो हैं। जब तक आप इसे समझ न लें, तब तक पर्याप्त देखें। आप हमेशा वापस आ सकते हैं और समीक्षा कर सकते हैं।
- अगर आप इसके पीछे का सारा गणित नहीं समझते हैं तो चिंता न करें।
- आपको बस यह समझने की जरूरत है कि बिग-ओ के संदर्भ में एल्गोरिथम की जटिलता को कैसे व्यक्त किया जाए।
- [ ] [हार्वर्ड CS50 - स्पर्शोन्मुख संकेतन (वीडियो)](https://www.youtube.com/watch?v=iOq5kSKqeR4)
- [ ] [बिग ओ नोटेशन (सामान्य त्वरित ट्यूटोरियल) (वीडियो)](https://www.youtube.com/watch?v=V6mKVRU1evU)
- [ ] [बिग ओ नोटेशन (और ओमेगा और थीटा) - सर्वोत्तम गणितीय व्याख्या (वीडियो)](https://www.youtube.com/watch?v=ei-A_wy5Yxw&index=2&list=PL1BaGV1cIH4UhkL8a9bJGG356covJ76qN)
- [ ] [स्कीना (वीडियो)](https://www.youtube.com/watch?v=z1mkCe3kVUA)
- [ ] [यूसी बर्कले बिग ओ (वीडियो)](https://archive.org/details/ucberkeley_webcast_VIS4YDpuP98)
- [ ] [परिशोधन विश्लेषण (वीडियो)](https://www.youtube.com/watch?v=B3SpQZaAZP4&index=10&list=PL1BaGV1cIH4UhkL8a9bJGG356covJ76qN)
- [] टॉपकोडर (पुनरावृत्ति संबंध और मास्टर प्रमेय शामिल हैं):
    - [कम्प्यूटेशनल जटिलता: सेक्शन 1](https://www.topcoder.com/thrive/articles/Computational%20Complexity%20part%20one)
    - [कम्प्यूटेशनल जटिलता: धारा 2](https://www.topcoder.com/thrive/articles/Computational%20Complexity%20part%20two)
- [ ] [चीट शीट] (http://bigocheatsheet.com/)

खैर, बस इतना ही काफी है।

जब आप "Cracking the Coding Interview" के माध्यम से जाते हैं, तो इस पर एक अध्याय है, और अंत में देखने के लिए एक प्रश्नोत्तरी है
यदि आप विभिन्न एल्गोरिदम की रनटाइम जटिलता की पहचान कर सकते हैं। यह एक सुपर समीक्षा और परीक्षण है।

## डेटा संरचनाएं

- ### सरणी
    - [ ] सरणियों के बारे में:
        - [सरणी (वीडियो)](https://www.coursera.org/lecture/data-structs/arrays-OsBSF)
        - [यूसी बर्कले CS61B - लीनियर और मल्टी-डिम एरेज़ (वीडियो)](https://archive.org/details/ucberkeley_webcast_Wp8oiO_CZZE) (15m 32s से देखना शुरू करें)
        - [डायनामिक एरेज़ (वीडियो)](https://www.coursera.org/lecture/data-structures/dynamic-arrays-EwbnV)
        - [जैग्ड ऐरे (वीडियो)](https://www.youtube.com/watch?v=1jtrQqYpt7g)
    - [] एक वेक्टर लागू करें (स्वचालित आकार बदलने के साथ परिवर्तनीय सरणी):
        - [] इंडेक्सिंग का उपयोग करने के बजाय इंडेक्स पर कूदने के लिए एरेज़ और पॉइंटर्स और पॉइंटर मैथ का उपयोग करके कोडिंग का अभ्यास करें।
        - [] आवंटित स्मृति के साथ नया कच्चा डेटा सरणी
          - हुड के नीचे इंट सरणी आवंटित कर सकते हैं, बस इसकी विशेषताओं का उपयोग न करें
            - 16 से शुरू करें, या यदि शुरुआती संख्या अधिक है, तो 2 की शक्ति का उपयोग करें - 16, 32, 64, 128
        - [] आकार () - वस्तुओं की संख्या
        - [] क्षमता () - इसमें रखी जा सकने वाली वस्तुओं की संख्या
        - [ ] खाली है()
        - [ ] at(index) - दिए गए इंडेक्स पर आइटम लौटाता है, अगर इंडेक्स सीमा से बाहर हो जाता है तो ब्लो अप हो जाता है
        - [] पुश (आइटम)
        - [] सम्मिलित करें (सूचकांक, आइटम) - सूचकांक में आइटम सम्मिलित करता है, उस सूचकांक के मूल्य और अनुगामी तत्वों को दाईं ओर स्थानांतरित करता है
        - [] प्रीपेन्ड (आइटम) - इंडेक्स 0 . पर ऊपर इंसर्ट का उपयोग कर सकते हैं
        - [] पॉप () - अंत से हटा दें, वापसी मूल्य
        - [] हटाएं (सूचकांक) - सूचकांक पर आइटम हटाएं, सभी अनुगामी तत्वों को बाईं ओर स्थानांतरित करें
        - [] हटाएं (आइटम) - मूल्य की तलाश करता है और इसे धारण करने वाले इंडेक्स को हटा देता है (भले ही कई जगहों पर)
        - [] ढूंढें (आइटम) - मूल्य की तलाश करता है और उस मूल्य के साथ पहली अनुक्रमणिका देता है, -1 अगर नहीं मिला
        - [] आकार बदलें (नई_क्षमता) // निजी फ़ंक्शन
            - जब आप क्षमता तक पहुँच जाते हैं, तो आकार को दोगुना करने के लिए आकार बदलें
            - किसी आइटम को पॉप करते समय, यदि आकार क्षमता का 1/4 है, तो आकार बदलकर आधा कर दें
    - [ ] समय
        - O(1) अंत में जोड़ने/निकालने के लिए (अधिक स्थान के लिए आवंटन के लिए परिशोधित), अनुक्रमणिका, या अद्यतन
        - ओ (एन) कहीं और डालने/निकालने के लिए
    - [ ] अंतरिक्ष
        - स्मृति में सन्निहित, इसलिए निकटता प्रदर्शन में मदद करती है
        - स्थान की आवश्यकता = (सरणी क्षमता, जो> = n है) * वस्तु का आकार, लेकिन भले ही 2n, फिर भी O(n)
- ### लिंक्ड सूचियां
    - [ ] विवरण:
        - [ ] [सिंगली लिंक्ड लिस्ट (वीडियो)](https://www.coursera.org/lecture/data-structures/singly-linked-lists-kHhgK)
        - [ ] [सीएस 61बी - लिंक्ड सूचियां 1 (वीडियो)](https://archive.org/details/ucberkeley_webcast_htzJdKoEmO0)
        - [ ] [सीएस 61बी - लिंक्ड सूचियां 2 (वीडियो)](https://archive.org/details/ucberkeley_webcast_-c4I3gFYe3w)
    - [ ] [सी कोड (वीडियो)](https://www.youtube.com/watch?v=QN6FPiD0Gzo)
            - संपूर्ण वीडियो नहीं, केवल नोड संरचना और स्मृति आवंटन के बारे में अंश
    - [] लिंक्ड लिस्ट बनाम एरेज़:
        - [कोर लिंक्ड लिस्ट बनाम एरेज़ (वीडियो)](https://www.coursera.org/lecture/data-structures-optimizing-performance/core-linked-lists-vs-arrays-rjBs9)
        - [इन द रियल वर्ल्ड लिंक्ड लिस्ट्स बनाम एरेज़ (वीडियो)](https://www.coursera.org/lecture/data-structures-optimizing-performance/in-the-real-world-lists-vs-arrays-QUaUd )
    - [ ] [आपको लिंक की गई सूचियों (वीडियो) से क्यों बचना चाहिए](https://www.youtube.com/watch?v=YQs6IC-vgmo)
    - [] गोचा: आपको पॉइंटर टू पॉइंटर नॉलेज चाहिए:
        (जब आप किसी फ़ंक्शन के लिए एक पॉइंटर पास करते हैं जो उस पते को बदल सकता है जहां वह पॉइंटर इंगित करता है)
        यह पेज सिर्फ पीटीआर से पीटीआर तक को समझने के लिए है। मैं इस सूची ट्रैवर्सल शैली की अनुशंसा नहीं करता। चतुराई के कारण पठनीयता और रखरखाव को नुकसान होता है।
        - [पॉइंटर्स टू पॉइंटर्स](https://www.eskimo.com/~scs/cclass/int/sx8.html)
    - [] लागू करें (मैंने टेल पॉइंटर के साथ और बिना किया):
        - [] आकार () - सूची में डेटा तत्वों की संख्या लौटाता है
        - [] खाली () - खाली होने पर बूल सही हो जाता है
        - [] value_at(index) - nवें आइटम का मान लौटाता है (पहले के लिए 0 से शुरू)
        - [] push_front (मान) - सूची के सामने एक आइटम जोड़ता है
        - [] pop_front () - सामने की वस्तु को हटा दें और उसका मूल्य लौटा दें
        - [] push_back(value) - अंत में एक आइटम जोड़ता है
        - [] pop_back () - अंतिम वस्तु को हटाता है और उसका मूल्य लौटाता है
        - [] सामने () - सामने की वस्तु का मूल्य प्राप्त करें
        - [] वापस () - अंतिम वस्तु का मूल्य प्राप्त करें
        - [] सम्मिलित करें (सूचकांक, मूल्य) - सूचकांक में मूल्य डालें, इसलिए उस सूचकांक में वर्तमान आइटम को सूचकांक में नए आइटम द्वारा इंगित किया जाता है
        - [] मिटाएं (इंडेक्स) - दिए गए इंडेक्स पर नोड को हटा दें
        - [] value_n_from_end(n) - सूची के अंत से nवें स्थान पर नोड का मान लौटाता है
        - [ ] reverse() - reverses the list
        - [ ] remove_value(value) - removes the first item in the list with this value
    - [ ] Doubly-linked List
        - [Description (video)](https://www.coursera.org/lecture/data-structures/doubly-linked-lists-jpGKD)
        - No need to implement
- ### ढेर
    - [ ] [स्टैक (वीडियो)](https://www.coursera.org/lecture/data-structs/stacks-UdKzQ)
    - [ ] लागू नहीं होगा। सरणी के साथ कार्यान्वित करना तुच्छ है

- ### कतार
    - [ ] [कतार (वीडियो)](https://www.coursera.org/lecture/data-structs/queues-EShpq)
    - [ ] [सर्कुलर बफर/फीफो](https://en.wikipedia.org/wiki/Circular_buffer)
    - [] टेल पॉइंटर के साथ लिंक्ड-लिस्ट का उपयोग करके लागू करें:
        - एनक्यू (मान) - पूंछ पर स्थिति पर मूल्य जोड़ता है
        - dequeue () - मान लौटाता है और कम से कम हाल ही में जोड़े गए तत्व (सामने) को हटाता है
        - खाली()
    - [] निश्चित आकार के सरणी का उपयोग करके कार्यान्वित करें:
        - एनक्यू (मान) - उपलब्ध भंडारण के अंत में आइटम जोड़ता है
        - dequeue () - मान लौटाता है और कम से कम हाल ही में जोड़े गए तत्व को हटाता है
        - खाली()
        - भरा हुआ()
    - [ ] लागत:
        - लिंक की गई सूची का उपयोग करके एक खराब कार्यान्वयन जहां आप सिर पर कतार लगाते हैं और पूंछ पर dequeue ओ (एन) होगा
            क्योंकि आपको अगले से अंतिम तत्व की आवश्यकता होगी, जिससे प्रत्येक dequeue एक पूर्ण ट्रैवर्सल हो जाएगा
        - एनक्यू: ओ (1) (परिशोधन, लिंक्ड सूची और सरणी [जांच])
        - dequeue: O(1) (लिंक की गई सूची और सरणी)
        - खाली: ओ (1) (लिंक की गई सूची और सरणी)

- ### हैश टेबल
    - [] वीडियो:
        - [ ] [हैशिंग विद चेनिंग (वीडियो)](https://www.youtube.com/watch?v=0M_kIqhwbFo&list=PLUl4u3cNGP61Oq3tWYp6V_F-5jb5L2iHb&index=8)
        - [ ] [टेबल डबलिंग, कार्प-राबिन (वीडियो)](https://www.youtube.com/watch?v=BRO7mVIFt08&index=9&list=PLUl4u3cNGP61Oq3tWYp6V_F-5jb5L2iHb)
        - [ ] [ओपन एड्रेसिंग, क्रिप्टोग्राफिक हैशिंग (वीडियो)](https://www.youtube.com/watch?v=rvdJDijO2Ro&index=10&list=PLUl4u3cNGP61Oq3tWYp6V_F-5jb5L2iHb)
        - [ ] [पायकॉन 2010: द माइटी डिक्शनरी (वीडियो)](https://www.youtube.com/watch?v=C4Kc8xzcA68)
        - [ ] [पायकॉन 2017: द डिक्शनरी इवन माइटियर (वीडियो)](https://www.youtube.com/watch?v=66P5FMkWoVU)
        - [ ] [(उन्नत) रैंडमाइजेशन: यूनिवर्सल एंड परफेक्ट हैशिंग (वीडियो)](https://www.youtube.com/watch?v=z0lJ2k0sl1g&list=PLUl4u3cNGP6317WaSNfmCvGym2ucw3oGp&index=11)
        - [ ] [(उन्नत) परफेक्ट हैशिंग (वीडियो)](https://www.youtube.com/watch?v=N0COwN14gt0&list=PL2B4EEwhKD-NbwZ4ezj7gyc_3yNrojKM9&index=4)

    
- [ ] ऑनलाइन पाठ्यक्रम:
        - [ ] [कोर हैश टेबल्स (वीडियो)](https://www.coursera.org/lecture/data-structures-optimizing-performance/core-hash-tables-m7UuP)
        - [ ] [डेटा संरचनाएं (वीडियो)](https://www.coursera.org/learn/data-structs/home/week/4)
        - [ ] [फोन बुक प्रॉब्लम (वीडियो)](https://www.coursera.org/lecture/data-structures/phone-book-problem-NYZZP)
        - [] वितरित हैश टेबल:
            - [ड्रॉपबॉक्स (वीडियो) में तत्काल अपलोड और संग्रहण अनुकूलन](https://www.coursera.org/lecture/data-structures/instant-uploads-and-storage-optimization-in-dropbox-DvaIb)
            - [डिस्ट्रिब्यूटेड हैश टेबल्स (वीडियो)](https://www.coursera.org/lecture/data-structures/distributed-hash-tables-tvH8H)

    - [] रैखिक जांच का उपयोग करके सरणी के साथ कार्यान्वित करें
        - हैश (के, एम) - एम हैश टेबल का आकार है
        - जोड़ें (कुंजी, मान) - यदि कुंजी पहले से मौजूद है, तो मान अपडेट करें
        - मौजूद है (कुंजी)
        - चाबी देना)
        - हटाएं (कुंजी)

## अधिक ज्ञान

- ### द्विआधारी खोज
    - [ ] [बाइनरी सर्च (वीडियो)](https://www.youtube.com/watch?v=D5SrAga1pno)
    - [ ] [बाइनरी सर्च (वीडियो)](https://www.khanacademy.org/computing/computer-science/algorithms/binary-search/a/binary-search)
    - [ ] [विस्तार] (https://www.topcoder.com/thrive/articles/Binary%20Search)
    - [ ] [खाका](https://leetcode.com/discuss/general-discussion/786126/python-powerful-ultimate-binary-search-template-solved-many-problems)
    - [ ] अमल में लाना:
        - द्विआधारी खोज (पूर्णांक के क्रमबद्ध सरणी पर)
        - पुनरावर्तन का उपयोग कर द्विआधारी खोज
- ### बिटवाइज़ ऑपरेशन
    - [ ] [बिट्स चीट शीट](https://github.com/jwasham/coding-interview-university/blob/main/extras/cheat%20sheets/bits-cheat-sheet.pdf) - आपको इनमें से कई के बारे में पता होना चाहिए 2 से 2 की शक्तियां (2^1 से 2^16 और 2^32)
    - [] के साथ बिट्स में हेरफेर करने की वास्तव में अच्छी समझ प्राप्त करें: &, |, ^, ~, >>, <<
        - [ ] [शब्द](https://en.wikipedia.org/wiki/Word_(computer_architecture))
        - [] अच्छा परिचय:
            [बिट मैनिपुलेशन (वीडियो)](https://www.youtube.com/watch?v=7jkIUgLC29I)
        - [ ] [सी प्रोग्रामिंग ट्यूटोरियल 2-10: बिटवाइज़ ऑपरेटर्स (वीडियो)](https://www.youtube.com/watch?v=d0AwjSpNXR0)
        - [ ] [बिट मैनिपुलेशन] (https://en.wikipedia.org/wiki/Bit_manipulation)
        - [ ] [बिटवाइज ऑपरेशन](https://en.wikipedia.org/wiki/Bitwise_operation)
        - [ ] [बिथैक्स](https://graphics.stanford.edu/~seander/bithacks.html)
        - [ ] [द बिट ट्विडलर](https://bits.stephan-brumme.com/)
        - [ ] [द बिट ट्विडलर इंटरएक्टिव](https://bits.stephan-brumme.com/interactive.html)
        - [ ] [बिट हैक्स (वीडियो)](https://www.youtube.com/watch?v=ZusiKXcz_ac)
- [ ] [प्रैक्टिस ऑपरेशंस](https://pconrad.github.io/old_pconrad_cs16/topics/bitOps/)
    - [] 2s और 1s पूरक
        - [बाइनरी: प्लसस और माइनस (हम दो के पूरक का उपयोग क्यों करते हैं) (वीडियो)](https://www.youtube.com/watch?v=lKTsv6iVxV4)
        - [1s पूरक](https://en.wikipedia.org/wiki/Ones%27_complement)
        - [2s पूरक](https://en.wikipedia.org/wiki/Two%27s_complement)
    - [] काउंट सेट बिट्स
        - [एक बाइट में बिट्स गिनने के 4 तरीके (वीडियो)](https://youtu.be/Hzuzo9NJrlc)
        - [काउंट बिट्स](https://graphics.stanford.edu/~seander/bithacks.html#CountBitsSetKernighan)
        - [32 बिट पूर्णांक में सेट बिट्स की संख्या की गणना कैसे करें](http://stackoverflow.com/questions/109023/how-to-count-the-number-of-set-bits-in-a-32 -बिट-पूर्णांक)
    - [] स्वैप मान:
        - [स्वैप] (https://bits.stephan-brumme.com/swap.html)
    - [ ] निरपेक्ष मूल्य:
        - [निरपेक्ष पूर्णांक](https://bits.stephan-brumme.com/absInteger.html)
## पेड़

- ### पेड़ - नोट्स और पृष्ठभूमि
    - [ ] [श्रृंखला: पेड़ (वीडियो)] (https://www.coursera.org/lecture/data-structs/trees-95qda)
    - मूल वृक्ष निर्माण
    - ट्रैवर्सल
    - हेरफेर एल्गोरिदम
    - [ ] [बीएफएस (चौड़ाई-पहली खोज) और डीएफएस (गहराई-पहली खोज) (वीडियो)](https://www.youtube.com/watch?v=uWL6FJhq5fM)
        - बीएफएस नोट:
           - स्तर आदेश (बीएफएस, कतार का उपयोग करके)
           - समय जटिलता: ओ (एन)
           - अंतरिक्ष जटिलता: सर्वोत्तम: ओ (1), सबसे खराब: ओ (एन/2) = ओ (एन)
        - डीएफएस नोट:
            - समय जटिलता: ओ (एन)
            - अंतरिक्ष जटिलता:
                सबसे अच्छा: ओ (लॉग एन) - औसत। पेड़ की ऊंचाई
                सबसे खराब: ओ (एन)
            - क्रम में (डीएफएस: बाएं, स्वयं, दाएं)
            - पोस्टऑर्डर (डीएफएस: बाएं, दाएं, स्वयं)
            - प्रीऑर्डर (डीएफएस: स्वयं, बाएं, दाएं)

- ### बाइनरी सर्च ट्री: बीएसटी
    - [ ] [बाइनरी सर्च ट्री रिव्यू (वीडियो)](https://www.youtube.com/watch?v=x6At0nzX92o&index=1&list=PLA5Lqm4uh9Bbq-E0ZnqTIa8LRaL77ica6)
    - [ ] [परिचय (वीडियो)](https://www.coursera.org/learn/data-structs/lecture/E7cXP/introduction)
    - [ ] [एमआईटी (वीडियो)](https://www.youtube.com/watch?v=76dhtgZt38A&ab_channel=MITOpenCourseWare)
    - सी/सी++:
        - [ ] [बाइनरी सर्च ट्री - सी/सी++ (वीडियो) में कार्यान्वयन](https://www.youtube.com/watch?v=COZK7NATh4k&list=PL2_aWCzGMAwI3W_JlcBbtYTwiQSsOTa6P&index=28)
        - [ ] [बीएसटी कार्यान्वयन - स्टैक और हीप में मेमोरी आवंटन (वीडियो)](https://www.youtube.com/watch?v=hWokyBoo0aI&list=PL2_aWCzGMAwI3W_JlcBbtYTwiQSsOTa6P&index=29)
        - [ ] [बाइनरी सर्च ट्री (वीडियो) में न्यूनतम और अधिकतम तत्व खोजें](https://www.youtube.com/watch?v=Ut90klNN264&index=30&list=PL2_aWCzGMAwI3W_JlcBbtYTwiQSsOTa6P)
        - [ ] [एक बाइनरी ट्री की ऊंचाई ज्ञात करें (वीडियो)](https://www.youtube.com/watch?v=_pnqMz5nrRs&सूची=PL2_aWCzGMAwI3W_JlcBbtYTwiQSsOTa6P&index=31)
        - [ ] [बाइनरी ट्री ट्रैवर्सल - चौड़ाई-पहली और गहराई-पहली रणनीतियां (वीडियो)](https://www.youtube.com/watch?v=9RHO6jU--GU&list=PL2_aWCzGMAwI3W_JlcBbtYTwiQSsOTa6P&index=32)
        - [ ] [बाइनरी ट्री: लेवल ऑर्डर ट्रैवर्सल (वीडियो)](https://www.youtube.com/watch?v=86g8jAQug04&index=33&list=PL2_aWCzGMAwI3W_JlcBbtYTwiQSsOTa6P)
        - [ ] [बाइनरी ट्री ट्रैवर्सल: प्रीऑर्डर, इनऑर्डर, पोस्टऑर्डर (वीडियो)](https://www.youtube.com/watch?v=gm8DUJJhmY4&index=34&list=PL2_aWCzGMAwI3W_JlcBbtYTwiQSsOTa6P)
        - [ ] [जांचें कि बाइनरी ट्री बाइनरी सर्च ट्री है या नहीं (वीडियो)](https://www.youtube.com/watch?v=yEwSGhSsT0U&index=35&list=PL2_aWCzGMAwI3W_JlcBbtYTwiQSsOTa6P)
        - [ ] [बाइनरी सर्च ट्री (वीडियो) से एक नोड हटाएं](https://www.youtube.com/watch?v=gcULXE7ViZw&list=PL2_aWCzGMAwI3W_JlcBbtYTwiQSsOTa6P&index=36)
        - [ ] [बाइनरी सर्च ट्री (वीडियो) में क्रमागत उत्तराधिकारी](https://www.youtube.com/watch?v=5cPbNCrdotA&index=37&list=PL2_aWCzGMAwI3W_JlcBbtYTwiQSsOTa6P)
    - [ ] अमल में लाना:
        - [] डालें // ट्री में वैल्यू डालें
        - [] get_node_count // संग्रहीत मूल्यों की गणना प्राप्त करें
        - [ ] print_values ​​// ट्री में मानों को न्यूनतम से अधिकतम तक प्रिंट करता है
        - [] डिलीट_ट्री
        - [] is_in_tree // अगर पेड़ में दिया गया मान मौजूद है तो सही है
        - [] get_height // नोड्स में ऊंचाई लौटाता है (एकल नोड की ऊंचाई 1 है)
        - [] get_min // ट्री में संग्रहीत न्यूनतम मान लौटाता है
        - [] get_max // पेड़ में संग्रहीत अधिकतम मूल्य लौटाता है
        - [] is_binary_search_tree
        - [ ] delete_value
        - [] get_successor // दिए गए मान के बाद ट्री में अगला-उच्चतम मान लौटाता है, -1 यदि कोई नहीं

- ### हीप / प्राथमिकता कतार / बाइनरी हीप
    - एक पेड़ के रूप में देखा जाता है, लेकिन आमतौर पर भंडारण में रैखिक होता है (सरणी, लिंक्ड सूची)
    - [ ] [हीप] (https://en.wikipedia.org/wiki/Heap_(data_struct))
    - [ ] [परिचय (वीडियो)](https://www.coursera.org/lecture/data-structures/introduction-2OpTs)
    - [ ] [बेवकूफ कार्यान्वयन (वीडियो)](https://www.coursera.org/learn/data-structs/lecture/z3l9N/naive-implementations)
    - [ ] [बाइनरी ट्री (वीडियो)](https://www.coursera.org/learn/data-structures/lecture/GRV2q/binary-trees)
    - [ ] [वृक्ष ऊंचाई टिप्पणी (वीडियो)](https://www.coursera.org/learn/data-structs/supplement/S5xxz/tree-height-remark)
    - [ ] [बुनियादी संचालन (वीडियो)](https://www.coursera.org/learn/data-structs/lecture/0g1dl/basic-operations)
    - [ ] [पूर्ण बाइनरी ट्री (वीडियो)](https://www.coursera.org/learn/data-structs/lecture/gl5Ni/complete-binary-trees)
    - [ ] [स्यूडोकोड (वीडियो)](https://www.coursera.org/learn/data-structures/lecture/HxQo9/pseudocode)
    - [ ] [हीप सॉर्ट - जंप टू स्टार्ट (वीडियो)](https://youtu.be/odNJmw5TOEE?list=PLFDnELG9dpVxQCxuD-9BSy2E7BWY3t5Sm&t=3291)
    - [ ] [हीप सॉर्ट (वीडियो)](https://www.coursera.org/lecture/data-structures/heap-sort-hSzMO)
    - [ ] [ढेर बनाना (वीडियो)](https://www.coursera.org/lecture/data-structures/build-a-heap-dwrOS)
    - [ ] [एमआईटी: हीप्स एंड हीप सॉर्ट (वीडियो)](https://www.youtube.com/watch?v=B7hVxCmfPtM&index=4&list=PLUl4u3cNGP61Oq3tWYp6V_F-5jb5L2iHb)
    - [ ] [सीएस 61बी व्याख्यान 24: प्राथमिकता कतारें (वीडियो)](https://archive.org/details/ucberkeley_webcast_yIUFT6AKBGE)
    - [ ] [रैखिक समय BuildHeap (अधिकतम-ढेर)](https://www.youtube.com/watch?v=MiyLo8adrWw)
    - [] अधिकतम ढेर लागू करें:
        - [ ] डालना
        - [] sift_up - डालने के लिए आवश्यक
        - [] get_max - अधिकतम आइटम को हटाए बिना लौटाता है
        - [] get_size () - संग्रहीत तत्वों की वापसी संख्या
        - [] is_empty () - यदि ढेर में कोई तत्व नहीं है, तो सत्य लौटाता है
        - [] Extract_max - अधिकतम आइटम लौटाता है, इसे हटाता है
        - [] sift_down - Extract_max . के लिए आवश्यक
        - [] निकालें (x) - सूचकांक x . पर आइटम हटा देता है
        - [] heapify - heap_sort . के लिए आवश्यक तत्वों की एक सरणी से एक ढेर बनाएं
        - [] heap_sort () - एक अनसोल्ड एरे लें और इसे अधिकतम हीप या मिन हीप का उपयोग करके इन-प्लेस सॉर्ट किए गए एरे में बदल दें

## छँटाई
- [ ] टिप्पणियाँ:
    - प्रकार लागू करें और सबसे अच्छा मामला / सबसे खराब स्थिति जानें, प्रत्येक की औसत जटिलता:
        - कोई बबल सॉर्ट नहीं - यह भयानक है - O(n^2), सिवाय जब n <= 16
    - [] एल्गोरिदम को छांटने में स्थिरता ("क्या क्विकसॉर्ट स्थिर है?")
        - [सॉर्टिंग एल्गोरिथम स्थिरता](https://en.wikipedia.org/wiki/Sorting_algorithm#Stability)
        - [एल्गोरिदम छँटाई में स्थिरता](http://stackoverflow.com/questions/1517793/stability-in-sorting-algorithms)
        - [एल्गोरिदम छँटाई में स्थिरता](http://www.geeksforgeeks.org/stability-in-sorting-algorithms/)
        - [एल्गोरिदम छँटाई - स्थिरता](http://homepages.math.uic.edu/~leon/cs-mcs401-s08/handouts/stability.pdf)
    - [ ] लिंक्ड सूचियों पर कौन से एल्गोरिदम का उपयोग किया जा सकता है? सरणी पर कौन सा? दोनों पर कौन सा?
        - मैं एक लिंक्ड सूची को सॉर्ट करने की अनुशंसा नहीं करता, लेकिन मर्ज सॉर्ट करने योग्य है।
        - [लिंक्ड लिस्ट के लिए मर्ज सॉर्ट](http://www.geeksforgeeks.org/merge-sort-for-linked-list/)

- हीपसॉर्ट के लिए, ऊपर हीप डेटा संरचना देखें। ढेर छँटाई महान है, लेकिन स्थिर नहीं है

- [ ] [सेजविक - मर्जसॉर्ट (5 वीडियो)](https://www.coursera.org/learn/algorithms-part1/home/week/3)
    - [ ] [1. मर्जसॉर्ट](https://www.coursera.org/lecture/algorithms-part1/mergesort-ARWDq)
    - [ ] [2. बॉटम अप मर्जसॉर्ट](https://www.coursera.org/learn/algorithms-part1/lecture/PWNEl/bottom-up-mergesort)
    - [ ] [3. छँटाई जटिलता](https://www.coursera.org/lecture/algorithms-part1/sorting-complexity-xAltF)
    - [ ] [4. तुलनित्र](https://www.coursera.org/lecture/algorithms-part1/comparators-9FYhS)
    - [ ] [5. स्थिरता](https://www.coursera.org/learn/algorithms-part1/lecture/pvvLZ/stability)

- [ ] [सेजविक - क्विकसॉर्ट (4 वीडियो)](https://www.coursera.org/learn/algorithms-part1/home/week/3)
    - [ ] [1. क्विकसॉर्ट](https://www.coursera.org/learn/algorithms-part1/lecture/vjvnC/quicksort)
    - [ ] [2. चयन](https://www.coursera.org/lecture/algorithms-part1/selection-UQxFT)
    - [ ] [3. डुप्लीकेट कुंजियाँ](https://www.coursera.org/lecture/algorithms-part1/duplicate-keys-XvjPd)
    - [ ] [4. सिस्टम सॉर्ट](https://www.coursera.org/lecture/algorithms-part1/system-sorts-QBNZ7) 
- [ ] यूसी बरकेले:
    - [ ] [सीएस 61बी लेक्चर 29: सॉर्टिंग I (वीडियो)](https://archive.org/details/ucberkeley_webcast_EiUvYS2DT6I)
    - [ ] [सीएस 61बी लेक्चर 30: सॉर्टिंग II (वीडियो)](https://archive.org/details/ucberkeley_webcast_2hTY3t80Qsk)
    - [ ] [सीएस 61बी व्याख्यान 32: छँटाई III (वीडियो)](https://archive.org/details/ucberkeley_webcast_Y6LOLpxg6Dc)
    - [ ] [सीएस 61बी व्याख्यान 33: छँटाई वी (वीडियो)](https://archive.org/details/ucberkeley_webcast_qNMQ4ly43p4)

- [ ] [बबल सॉर्ट (वीडियो)](https://www.youtube.com/watch?v=P00xJgWzz2c&index=1&list=PL89B61F78B552C1AB)
- [ ] [बबल सॉर्ट का विश्लेषण (वीडियो)](https://www.youtube.com/watch?v=ni_zk257Nqo&index=7&list=PL89B61F78B552C1AB)
- [ ] [सम्मिलन सॉर्ट, मर्ज सॉर्ट (वीडियो)](https://www.youtube.com/watch?v=Kg4bqzAqRBM&index=3&list=PLUl4u3cNGP61Oq3tWYp6V_F-5jb5L2iHb)
- [ ] [सम्मिलन क्रमित करें (वीडियो)](https://www.youtube.com/watch?v=c4BRHC7kTaQ&index=2&list=PL89B61F78B552C1AB)
- [ ] [मर्ज सॉर्ट (वीडियो)](https://www.youtube.com/watch?v=GCae1WNvnZM&index=3&list=PL89B61F78B552C1AB)
- [ ] [क्विकसोर्ट (वीडियो)](https://www.youtube.com/watch?v=y_G9BkAm6B8&index=4&list=PL89B61F78B552C1AB)
- [ ] [चयन क्रम (वीडियो)](https://www.youtube.com/watch?v=6nDMgr0-Yyo&index=8&list=PL89B61F78B552C1AB)

- [] मर्ज सॉर्ट कोड:
    - [ ] [आउटपुट ऐरे (सी) का उपयोग करना] (http://www.cs.yale.edu/homes/aspnes/classes/223/examples/sorting/mergesort.c)
    - [ ] [आउटपुट ऐरे (पायथन) का उपयोग करना] (https://github.com/jwasham/practice-python/blob/master/merge_sort/merge_sort.py)
    - [ ] [इन-प्लेस (C++)](https://github.com/jwasham/practice-cpp/blob/master/merge_sort/merge_sort.cc)
- [] त्वरित सॉर्ट कोड:
    - [ ] [कार्यान्वयन (सी)] (http://www.cs.yale.edu/homes/aspnes/classes/223/examples/randomization/quick.c)
    - [ ] [कार्यान्वयन (सी)] (https://github.com/jwasham/practice-c/blob/master/quick_sort/quick_sort.c)
    - [ ] [कार्यान्वयन (पायथन)](https://github.com/jwasham/practice-python/blob/master/quick_sort/quick_sort.py)

- [ ] अमल में लाना:
    - [] मर्जसॉर्ट: ओ (एन लॉग एन) औसत और सबसे खराब स्थिति
    - [] क्विकसॉर्ट ओ (एन लॉग एन) औसत मामला
    - चयन प्रकार और सम्मिलन प्रकार दोनों ओ (एन ^ 2) औसत और सबसे खराब स्थिति हैं
    - हीपसॉर्ट के लिए, ऊपर हीप डेटा संरचना देखें
 - [] आवश्यक नहीं है, लेकिन मैंने उनकी सिफारिश की:
    - [ ] [सेजविक - रेडिक्स सॉर्ट्स (6 वीडियो)](https://www.coursera.org/learn/algorithms-part2/home/week/3)
        - [ ] [1. जावा में स्ट्रिंग्स](https://www.coursera.org/learn/algorithms-part2/lecture/vGHvb/strings-in-java)
        - [ ] [2. कुंजी अनुक्रमित गिनती](https://www.coursera.org/lecture/algorithms-part2/key-indexed-counting-2pi1Z)
        - [ ] [3. कम से कम महत्वपूर्ण अंक प्रथम स्ट्रिंग रेडिक्स सॉर्ट](https://www.coursera.org/learn/algorithms-part2/lecture/c1U7L/lsd-radix-sort)
        - [ ] [4. सबसे महत्वपूर्ण अंक पहली स्ट्रिंग रेडिक्स सॉर्ट](https://www.coursera.org/learn/algorithms-part2/lecture/gFxwG/msd-radix-sort)
        - [ ] [5. 3 वे रेडिक्स क्विकसॉर्ट](https://www.coursera.org/lecture/algorithms-part2/3-way-radix-quicksort-crkd5)
        - [ ] [6. प्रत्यय सरणी](https://www.coursera.org/learn/algorithms-part2/lecture/TH18W/suffix-arrays)
    - [ ] [रेडिक्स सॉर्ट](http://www.cs.yale.edu/homes/aspnes/classes/223/notes.html#radixSort)
    - [ ] [रेडिक्स सॉर्ट (वीडियो)](https://www.youtube.com/watch?v=xhr26ia4k38)
    - [ ] [रेडिक्स सॉर्ट, काउंटिंग सॉर्ट (रैखिक समय दिए गए प्रतिबंध) (वीडियो)](https://www.youtube.com/watch?v=Nz1KZXbghj8&index=7&list=PLUl4u3cNGP61Oq3tWYp6V_F-5jb5L2iHb)
    - [ ] [यादृच्छिककरण: मैट्रिक्स गुणा, क्विकॉर्ट, फ्रीवाल्ड्स एल्गोरिथम (वीडियो)](https://www.youtube.com/watch?v=cNB2lADK3_s&index=8&list=PLUl4u3cNGP6317WaSNfmCvGym2ucw3oGp)
    - [ ] [रैखिक समय (वीडियो) में छंटनी](https://www.youtube.com/watch?v=pOKy3RZbSws&list=PLUl4u3cNGP61hsJNdULdudlRL493b-XZf&index=14)

संक्षेप में, यहां [15 सॉर्टिंग एल्गोरिदम](https://www.youtube.com/watch?v=kPRA0W1kECg) का एक दृश्य प्रतिनिधित्व है।
यदि आपको इस विषय पर अधिक विवरण की आवश्यकता है, तो [कुछ विषयों पर अतिरिक्त विवरण] (# अतिरिक्त-विवरण-पर-कुछ-विषयों) में "सॉर्टिंग" अनुभाग देखें।

## रेखांकन

कंप्यूटर विज्ञान में कई समस्याओं का प्रतिनिधित्व करने के लिए रेखांकन का उपयोग किया जा सकता है, इसलिए यह खंड लंबा है, जैसे पेड़ और छँटाई थी।

- टिप्पणियाँ:
    - मेमोरी में ग्राफ को दर्शाने के 4 बुनियादी तरीके हैं:
        - ऑब्जेक्ट्स और पॉइंटर्स
        - सहखंडज मैट्रिक्स
        - निकटता सूची
        - आसन्न नक्शा
    - प्रत्येक प्रतिनिधित्व और उसके पेशेवरों और विपक्षों से खुद को परिचित करें
    - बीएफएस और डीएफएस - उनकी कम्प्यूटेशनल जटिलता, उनके व्यापार बंद, और उन्हें वास्तविक कोड में कैसे लागू किया जाए, इसके बारे में जानें
    - जब कोई प्रश्न पूछा जाए, तो पहले ग्राफ़-आधारित समाधान देखें, फिर यदि कोई नहीं है तो आगे बढ़ें

- [] एमआईटी (वीडियो):
    - [ ] [चौड़ाई-पहली खोज](https://www.youtube.com/watch?v=oFVYVzlvk9c&t=14s&ab_channel=MITOpenCourseWare)
    - [ ] [गहराई-पहली खोज](https://www.youtube.com/watch?v=IBfWDYSffUU&t=32s&ab_channel=MITOpenCourseWare)

- [] स्कीएना व्याख्यान - महान परिचय:
    - [ ] [CSE373 2020 - लेक्चर 10 - ग्राफ़ डेटा स्ट्रक्चर (वीडियो)](https://www.youtube.com/watch?v=Sjk0xqWWPCc&list=PLOtl7M3yp-DX6ic0HGT0PUX_wiNmkWkXx&index=10)
    - [ ] [CSE373 2020 - व्याख्यान 11 - ग्राफ़ ट्रैवर्सल (वीडियो)](https://www.youtube.com/watch?v=ZTwjXj81NVY&list=PLOtl7M3yp-DX6ic0HGT0PUX_wiNmkWkXx&index=11)
    - [ ] [CSE373 2020 - व्याख्यान 12 - गहराई पहली खोज (वीडियो)](https://www.youtube.com/watch?v=KyordYB3BOs&list=PLOtl7M3yp-DX6ic0HGT0PUX_wiNmkWkXx&index=12)
    - [ ] [CSE373 2020 - व्याख्यान 13 - न्यूनतम फैले हुए पेड़ (वीडियो)](https://www.youtube.com/watch?v=oolm2VnJUKw&list=PLOtl7M3yp-DX6ic0HGT0PUX_wiNmkWkXx&index=13)
    - [ ] [CSE373 2020 - व्याख्यान 14 - न्यूनतम फैले हुए पेड़ (नहीं) (वीडियो)](https://www.youtube.com/watch?v=RktgPx0MarY&list=PLOtl7M3yp-DX6ic0HGT0PUX_wiNmkWkXx&index=14)
    - [ ] [CSE373 2020 - लेक्चर 15 - ग्राफ़ एल्गोरिथम (2 नहीं) (वीडियो)](https://www.youtube.com/watch?v=MUe5DXRhyAo&list=PLOtl7M3yp-DX6ic0HGT0PUX_wiNmkWkXx&index=15)

- [] रेखांकन (समीक्षा और अधिक):

    - [ ] [6.006 सिंगल-सोर्स शॉर्टेस्ट पाथ प्रॉब्लम (वीडियो)](https://www.youtube.com/watch?v=Aa2sqUhIn-E&index=15&list=PLUl4u3cNGP61Oq3tWYp6V_F-5jb5L2iHb)
    - [ ] [6.006 डिजस्ट्रा (वीडियो)](https://www.youtube.com/watch?v=NSHizBK9JD8&t=1731s&ab_channel=MITOpenCourseWare)
    - [ ] [6.006 बेलमैन-फोर्ड (वीडियो)](https://www.youtube.com/watch?v=f9cVS_URPc0&ab_channel=MITOpenCourseWare)
    - [ ] [6.006 स्पीड अप दिज्क्स्ट्रा (वीडियो)](https://www.youtube.com/watch?v=CHvQ3q_gJ7E&list=PLUl4u3cNGP61Oq3tWYp6V_F-5jb5L2iHb&index=18)
    - [ ] [अदुनी: ग्राफ़ एल्गोरिथम I - टोपोलॉजिकल सॉर्टिंग, न्यूनतम स्पैनिंग ट्री, प्राइम का एल्गोरिथम - लेक्चर 6 (वीडियो)]( https://www.youtube.com/watch?v=i_AQT_XfvD8&index=6&list=PLFDnELG9dpVxQCxuD-9WBSy2Em)
    - [ ] [अदुनी: ग्राफ़ एल्गोरिथम II - डीएफएस, बीएफएस, क्रुस्कल का एल्गोरिदम, संघ डेटा संरचना खोजें - व्याख्यान 7 (वीडियो)]( https://www.youtube.com/watch?v=ufj5_bppBsA&list=PLFDnELG9dpVxQCxuD-9BSy2E7B&index=7S5S )
    - [ ] [अदुनी: ग्राफ़ एल्गोरिथम III: सबसे छोटा रास्ता - व्याख्यान 8 (वीडियो)](https://www.youtube.com/watch?v=DiedsPsMKXc&list=PLFDnELG9dpVxQCxuD-9BSy2E7BWY3t5Sm&index=8)
    - [ ] [अदुनी: ग्राफ़ Alg. IV: ज्यामितीय एल्गोरिदम का परिचय - व्याख्यान 9 (वीडियो)](https://www.youtube.com/watch?v=XIAQRlNkJAw&list=PLFDnELG9dpVxQCxuD-9BSy2E7BWY3t5Sm&index=9)
    - [ ] [सीएस 61बी 2014: भारित ग्राफ (वीडियो)](https://archive.org/details/ucberkeley_webcast_zFbq8vOZ_0k)
    - [ ] [लालची एल्गोरिदम: न्यूनतम फैले हुए पेड़ (वीडियो)](https://www.youtube.com/watch?v=tKwnms5iRBU&index=16&list=PLUl4u3cNGP6317WaSNfmCvGym2ucw3oGp)
    - [ ] [मजबूत रूप से जुड़े घटक कोसाराजू का एल्गोरिथम ग्राफ़ एल्गोरिथम (वीडियो)](https://www.youtube.com/watch?v=RpgcYiky7uw)

- पूर्ण कौरसेरा कोर्स:
    - [ ] [ग्राफ़ पर एल्गोरिदम (वीडियो)](https://www.coursera.org/learn/algorithms-on-graphs/home/welcome)

- मैं लागू करूंगा:
    - [] आसन्न सूची के साथ डीएफएस (पुनरावर्ती)
    - [] आसन्न सूची के साथ डीएफएस (स्टैक के साथ पुनरावृत्त)
    - [] आसन्न मैट्रिक्स के साथ डीएफएस (पुनरावर्ती)
    - [] आसन्न मैट्रिक्स के साथ डीएफएस (स्टैक के साथ पुनरावृत्त)
    - [ ] बीएफएस आसन्न सूची के साथ
    - [] आसन्न मैट्रिक्स के साथ बीएफएस
    - [] एकल-स्रोत सबसे छोटा पथ (दिज्क्स्ट्रा)
    - [ ] न्यूनतम फैलाव वाला पेड़
    - डीएफएस-आधारित एल्गोरिदम (ऊपर Aduni वीडियो देखें):
        - [] साइकिल की जांच करें (टोपोलॉजिकल सॉर्ट के लिए आवश्यक है, क्योंकि हम शुरू करने से पहले साइकिल की जांच करेंगे)
        - [] टोपोलॉजिकल सॉर्ट
        - [] एक ग्राफ में जुड़े घटकों की गणना करें
        - [] दृढ़ता से जुड़े घटकों की सूची बनाएं
        - [] द्विदलीय ग्राफ के लिए जाँच करें

## Even More Knowledge
- ### रिकर्सन
    - [ ] स्टैनफोर्ड रिकर्सन और बैकट्रैकिंग पर व्याख्यान:
        - [ ] [व्याख्यान 8 | प्रोग्रामिंग एब्स्ट्रैक्शन (वीडियो)](https://www.youtube.com/watch?v=gl3emqCuueQ&list=PLFE6E58F856038C69&index=8)
        - [ ] [व्याख्यान 9 | प्रोग्रामिंग एब्स्ट्रैक्शन (वीडियो)](https://www.youtube.com/watch?v=uFJhEPrbycQ&list=PLFE6E58F856038C69&index=9)
        - [ ] [व्याख्यान 10 | प्रोग्रामिंग एब्स्ट्रैक्शन (वीडियो)](https://www.youtube.com/watch?v=NdF1QDTRkck&index=10&list=PLFE6E58F856038C69)
        - [ ] [व्याख्यान 11 | प्रोग्रामिंग एब्स्ट्रैक्शन (वीडियो)](https://www.youtube.com/watch?v=p-gpaIGRCQI&list=PLFE6E58F856038C69&index=11)
    - इसका उपयोग कब करना उचित है?
    - टेल रिकर्सन कैसे बेहतर नहीं है?
        - [ ] [टेल रिकर्सन क्या है यह इतना बुरा क्यों है?](https://www.quora.com/What-is-tail-recursion- Why-is-it-so-bad)
        - [ ] [टेल रिकर्सन (वीडियो)](https://www.coursera.org/lecture/programming-languages/tail-recursion-YZic1)
    - [ ] [किसी भी पुनरावर्ती समस्या को हल करने के लिए 5 सरल चरण (वीडियो)](https://youtu.be/ngCos392W4w)

बैकट्रैकिंग ब्लूप्रिंट: [जावा](https://leetcode.com/problems/combination-sum/discuss/16502/A-general-approach-to-backtracking-questions-in-Java-(Subsets-Permutations-Combination-Sum-) पलिंड्रोम-विभाजन))
[पायथन](https://leetcode.com/problems/combination-sum/discuss/429538/General-Backtracking-questions-solutions-in-Python-for-reference-%3A)
- ### गतिशील प्रोग्रामिंग
    - आप शायद अपने साक्षात्कार में कोई गतिशील प्रोग्रामिंग समस्या नहीं देखेंगे, लेकिन यह पहचानने में सक्षम होने के लायक है
    गतिशील प्रोग्रामिंग के लिए एक उम्मीदवार के रूप में समस्या।
    - यह विषय काफी कठिन हो सकता है, क्योंकि प्रत्येक डीपी घुलनशील समस्या को एक पुनरावर्ती संबंध के रूप में परिभाषित किया जाना चाहिए, और इसके साथ आना मुश्किल हो सकता है।
    - मेरा सुझाव है कि जब तक आपको इसमें शामिल पैटर्न की ठोस समझ न हो, तब तक डीपी समस्याओं के कई उदाहरण देखें।
    - [] वीडियो:
       - [ ] [स्किएना: CSE373 2020 - लेक्चर 19 - डायनेमिक प्रोग्रामिंग का परिचय (वीडियो)](https://www.youtube.com/watch?v=wAA0AMfcJHQ&list=PLOtl7M3yp-DX6ic0HGT0PUX_wiNmkWkXx&index=18)
        - [ ] [स्किएना: CSE373 2020 - लेक्चर 20 - एडिट डिस्टेंस (वीडियो)](https://www.youtube.com/watch?v=T3A4jlHlhtA&list=PLOtl7M3yp-DX6ic0HGT0PUX_wiNmkWkXx&index=19)
        - [ ] [स्किएना: CSE373 2020 - व्याख्यान 20 - दूरी संपादित करें (जारी) (वीडियो)](https://www.youtube.com/watch?v=iPnPVcZmRbE&list=PLOtl7M3yp-DX6ic0HGT0PUX_wiNmkWkXx&index=20)
        - [ ] [स्किएना: CSE373 2020 - लेक्चर 21 - डायनेमिक प्रोग्रामिंग (वीडियो)](https://www.youtube.com/watch?v=2xPE4Wq8coQ&list=PLOtl7M3yp-DX6ic0HGT0PUX_wiNmkWkXx&index=21)
        - [ ] [स्किएना: CSE373 2020 - व्याख्यान 21 - गतिशील प्रोग्रामिंग और समीक्षा (वीडियो)](https://www.youtube.com/watch?v=2xPE4Wq8coQ&list=PLOtl7M3yp-DX6ic0HGT0PUX_wiNmkWkXx&index=21)
        - [ ] [साइमनसन: डायनेमिक प्रोग्रामिंग 0 (59:18 बजे शुरू होता है) (वीडियो)](https://youtu.be/J5aJEcOr6Eo?list=PLFDnELG9dpVxQCxuD-9BSy2E7BWY3t5Sm&t=3558)
        - [ ] [साइमनसन: डायनेमिक प्रोग्रामिंग I - लेक्चर 11 (वीडियो)](https://www.youtube.com/watch?v=0EzHjQ_SOeU&index=11&list=PLFDnELG9dpVxQCxuD-9BSy2E7BWY3t5Sm)
        - [ ] [साइमनसन: डायनेमिक प्रोग्रामिंग II - लेक्चर 12 (वीडियो)](https://www.youtube.com/watch?v=v1qiRwuJU7g&list=PLFDnELG9dpVxQCxuD-9BSy2E7BWY3t5Sm&index=12)
        - [] व्यक्तिगत डीपी समस्याओं की सूची (प्रत्येक संक्षिप्त है):
            [डायनेमिक प्रोग्रामिंग (वीडियो)](https://www.youtube.com/playlist?list=PLrmLmBdmIlpsHaNTPP_jHHDx_os9ItYXr)
    - [ ] येल व्याख्यान नोट्स:
        - [ ] [डायनामिक प्रोग्रामिंग](http://www.cs.yale.edu/homes/aspnes/classes/223/notes.html#dynamicProgramming)
    - [ ] कौरसेरा:
        - [ ] [आरएनए सेकेंडरी स्ट्रक्चर प्रॉब्लम (वीडियो)](https://www.coursera.org/learn/algorithmic-thinking-2/lecture/80RrW/the-rna-secondary-structure-problem)
        - [ ] [एक गतिशील प्रोग्रामिंग एल्गोरिथम (वीडियो)](https://www.coursera.org/lecture/algorithmic-thinking-2/a-dynamic-programming-algorithm-PSonq)
        - [ ] [डीपी एल्गोरिथम (वीडियो) का चित्रण](https://www.coursera.org/lecture/algorithmic-thinking-2/illustrating-the-dp-algorithm-oUEK2)
       
- [ ] [डीपी एल्गोरिथम (वीडियो) का रनिंग टाइम] (https://www.coursera.org/learn/algorithmic-thinking-2/lecture/nfK2r/running-time-of-the-dp-algorithm)
        - [ ] [डीपी बनाम पुनरावर्ती कार्यान्वयन (वीडियो)](https://www.coursera.org/learn/algorithmic-thinking-2/lecture/M999a/dp-vs-recursive-implementation)
        - [ ] [वैश्विक जोड़ीवार अनुक्रम संरेखण (वीडियो)](https://www.coursera.org/lecture/algorithmic-thinking-2/global-pairwise-sequence-alignment-UZ7o6)
        - [ ] [स्थानीय जोड़ीवार अनुक्रम संरेखण (वीडियो)](https://www.coursera.org/learn/algorithmic-thinking-2/lecture/WnNau/local-pairwise-sequence-alignment)

- ### डिजाइन पैटर्न्स
    - [ ] [त्वरित यूएमएल समीक्षा (वीडियो)](https://www.youtube.com/watch?v=3cmzqZzwNDM&list=PLGLfVvz_LVvQ5G-LdJ8RLqe-ndo7QITYc&index=3)
    - [ ] ये पैटर्न सीखें:
        - [ ] रणनीति
        - [] सिंगलटन
        - [] एडेप्टर
        - [] प्रोटोटाइप
        - [ ] डेकोरेटर
        - [] आगंतुक
        - [] कारखाना, अमूर्त कारखाना
        - [] मुखौटा
        - [ ] देखने वाला
        - [] प्रॉक्सी
        - [ ] प्रतिनिधि
        - [ ] आज्ञा
        - [ ] राज्य
        - [ ] स्मृति चिन्ह
        - [] पुनरावर्तक
        - [] समग्र
        - [] फ्लाईवेट
    - [ ] [वीडियो की शृंखला (27 वीडियो)](https://www.youtube.com/playlist?list=PLF206E906175C7E07)
    - [ ] [पुस्तक: हेड फर्स्ट डिज़ाइन पैटर्न](https://www.amazon.com/Head-First-Design-Patterns-Freeman/dp/059607124)
        - मुझे पता है कि विहित पुस्तक "डिज़ाइन पैटर्न: पुन: प्रयोज्य ऑब्जेक्ट-ओरिएंटेड सॉफ़्टवेयर के तत्व" है, लेकिन हेड फर्स्ट ओओ के शुरुआती लोगों के लिए बहुत अच्छा है।
    - [आसान संदर्भ: 101 डिज़ाइन पैटर्न और डेवलपर्स के लिए सुझाव](https://sourcemaking.com/design-patterns-and-tips)


- ### कॉम्बिनेटरिक्स (n चुनें k) और प्रायिकता
    - [ ] [गणित कौशल: भाज्य, क्रमचय और संयोजन कैसे खोजें (चुनें) (वीडियो)](https://www.youtube.com/watch?v=8RRo6Ti9d0U)
    - [ ] [मेक स्कूल: प्रोबेबिलिटी (वीडियो)](https://www.youtube.com/watch?v=sZkAAk9Wwa4)
    - [ ] [मेक स्कूल: मोर प्रोबेबिलिटी एंड मार्कोव चेन्स (वीडियो)](https://www.youtube.com/watch?v=dNaJg-mLobQ)
    - [ ] खान अकादमी:
        - कोर्स लेआउट:
            - [ ] [मूल सैद्धांतिक संभावना](https://www.khanacademy.org/math/probability/probability-and-combinatorics-topic)
        - बस वीडियो - 41 (प्रत्येक सरल हैं और प्रत्येक छोटा है):
            - [ ] [संभाव्यता की व्याख्या (वीडियो)](https://www.youtube.com/watch?v=uzkc-qNVoOk&list=PLC58778F28211FA19)

- ### एनपी, एनपी-पूर्ण और सन्निकटन एल्गोरिदम
    - एनपी-पूर्ण समस्याओं के सबसे प्रसिद्ध वर्गों के बारे में जानें, जैसे यात्रा विक्रेता और बस्ता समस्या,
        और जब कोई साक्षात्कारकर्ता आपसे वेश में पूछे तो उन्हें पहचानने में सक्षम हो।
    - जानिए एनपी-पूर्ण का क्या मतलब है।
    - [ ] [कम्प्यूटेशनल जटिलता (वीडियो)](https://www.youtube.com/watch?v=moPtwq_cVH8&list=PLUl4u3cNGP61Oq3tWYp6V_F-5jb5L2iHb&index=23)
    - [] साइमनसन:
        - [ ] [लालची Algs. II और एनपी पूर्णता का परिचय (वीडियो)](https://youtu.be/qcGnJ47Smlo?list=PLFDnELG9dpVxQCxuD-9BSy2E7BWY3t5Sm&t=2939)
        - [ ] [एनपी पूर्णता II और कटौती (वीडियो)](https://www.youtube.com/watch?v=e0tGC6ZQdQE&index=16&list=PLFDnELG9dpVxQCxuD-9BSy2E7BWY3t5Sm)
        - [ ] [एनपी पूर्णता III (वीडियो)](https://www.youtube.com/watch?v=fCX1BGT3wjE&index=17&list=PLFDnELG9dpVxQCxuD-9BSy2E7BWY3t5Sm)
        - [ ] [एनपी पूर्णता IV (वीडियो)](https://www.youtube.com/watch?v=NKLDp3Rch3M&list=PLFDnELG9dpVxQCxuD-9BSy2E7BWY3t5Sm&index=18)
    - [] स्कीना:
       - [ ] [CSE373 2020 - व्याख्यान 23 - एनपी-पूर्णता (वीडियो)](https://www.youtube.com/watch?v=ItHp5laE1VE&list=PLOtl7M3yp-DX6ic0HGT0PUX_wiNmkWkXx&index=23)
        - [ ] [CSE373 2020 - व्याख्यान 24 - संतुष्टि (वीडियो)](https://www.youtube.com/watch?v=inaFJeCzGxU&list=PLOtl7M3yp-DX6ic0HGT0PUX_wiNmkWkXx&index=24)
        - [ ] [CSE373 2020 - व्याख्यान 25 - अधिक एनपी-पूर्णता (वीडियो)](https://www.youtube.com/watch?v=B-bhKxjZLlc&list=PLOtl7M3yp-DX6ic0HGT0PUX_wiNmkWkXx&index=25)
        - [ ] [CSE373 2020 - व्याख्यान 26 - एनपी-पूर्णता चुनौती (वीडियो)](https://www.youtube.com/watch?v=_EzetTkG_Cc&list=PLOtl7M3yp-DX6ic0HGT0PUX_wiNmkWkXx&index=26)
    - [ ] [जटिलता: पी, एनपी, एनपी-पूर्णता, कटौती (वीडियो)](https://www.youtube.com/watch?v=eHZifpgyH_4&list=PLUl4u3cNGP6317WaSNfmCvGym2ucw3oGp&index=22)
    - [ ] [जटिलता: सन्निकटन एल्गोरिदम (वीडियो)](https://www.youtube.com/watch?v=MEz1J9wY2iM&list=PLUl4u3cNGP6317WaSNfmCvGym2ucw3oGp&index=24)
    - [ ] [जटिलता: फिक्स्ड-पैरामीटर एल्गोरिदम (वीडियो)](https://www.youtube.com/watch?v=4q-jmGrmxKs&index=25&list=PLUl4u3cNGP6317WaSNfmCvGym2ucw3oGp)
    - पीटर नॉरविग ने ट्रैवलिंग सेल्समैन की समस्या के निकट-इष्टतम समाधानों पर चर्चा की:
        - [जुपिटर नोटबुक](http://nbviewer.jupyter.org/url/norvig.com/ipython/TSP.ipynb)
    - यदि आपके पास सीएलआरएस में पृष्ठ 1048 - 1140 है।

- ### कंप्यूटर प्रोग्राम को कैसे प्रोसेस करते हैं

    - [ ] [सीपीयू किसी प्रोग्राम को कैसे निष्पादित करता है (वीडियो)](https://www.youtube.com/watch?v=XM4lGflQFvA)
    - [ ] [कंप्यूटर कैसे कैलकुलेट करते हैं - ALU (वीडियो)](https://youtu.be/1I5ZMmrOfnA)
    - [ ] [रजिस्टर और रैम (वीडियो)](https://youtu.be/fpnE6UAfbtU)
    - [ ] [सेंट्रल प्रोसेसिंग यूनिट (सीपीयू) (वीडियो)](https://youtu.be/FZGugFqdr60)
    - [ ] [निर्देश और कार्यक्रम (वीडियो)](https://youtu.be/zltgXvg6r3k)

- ### कैश
    - [] एलआरयू कैश:
        - [ ] [LRU कैश का जादू (गूगल देव के 100 दिन) (वीडियो)](https://www.youtube.com/watch?v=R5ON3iwx78M)
        - [ ] [एलआरयू (वीडियो) लागू करना](https://www.youtube.com/watch?v=bq6N7Ym81iI)
        - [ ] [LeetCode - 146 LRU कैश (C++) (वीडियो)](https://www.youtube.com/watch?v=8-FZRAjR7qU)
    - [] सीपीयू कैश:
        - [ ] [MIT 6.004 L15: मेमोरी पदानुक्रम (वीडियो)](https://www.youtube.com/watch?v=vjYF_fAZI5E&list=PLrRW1w6CGAcXbMtDFj205vALOGmiRc82-&index=24)
        - [ ] [MIT 6.004 L16: कैश की समस्या (वीडियो)](https://www.youtube.com/watch?v=ajgC3-pyGlk&index=25&list=PLrRW1w6CGAcXbMtDFj205vALOGmiRc82-)

- ### प्रक्रियाएं और सूत्र
    - [ ] कंप्यूटर साइंस 162 - ऑपरेटिंग सिस्टम (25 वीडियो):
        - प्रक्रियाओं और थ्रेड्स के लिए वीडियो देखें 1-11
        - [ऑपरेटिंग सिस्टम और सिस्टम प्रोग्रामिंग (वीडियो)](https://archive.org/details/ucberkeley-webcast-PL-XXv-cvA_iBDyz-ba4yDskqMDY6A1w_c)
    - [एक प्रक्रिया और एक धागे में क्या अंतर है?](https://www.quora.com/What-is-the-difference-between-a-process-and-a-thread)
    - कवर:
        - प्रक्रियाएं, सूत्र, समवर्ती मुद्दे
            - प्रक्रियाओं और धागे के बीच अंतर
            - प्रक्रियाएं
            - धागे
            - ताले
            - म्यूटेक्स
            - सेमाफोरस
            - मॉनिटर्स
            - वे कैसे काम करते हैं?
            - गतिरोध
            - लाइवलॉक
        - सीपीयू गतिविधि, इंटरप्ट, संदर्भ स्विचिंग
        - मल्टीकोर प्रोसेसर के साथ आधुनिक समवर्ती निर्माण
        - [पेजिंग, सेगमेंटेशन और वर्चुअल मेमोरी (वीडियो)](https://youtu.be/O4nwUqQodAg)
        - [व्यवधान (वीडियो)](https://youtu.be/iKlAWIKEyuw)
        - प्रक्रिया संसाधन की जरूरत (मेमोरी: कोड, स्टैटिक स्टोरेज, स्टैक, हीप, और फाइल डिस्क्रिप्टर, i/o)
        - एक ही प्रक्रिया में अन्य थ्रेड्स के साथ थ्रेड रिसोर्स की जरूरत (ऊपर के शेयर (माइनस स्टैक) लेकिन प्रत्येक का अपना पीसी, स्टैक काउंटर, रजिस्टर और स्टैक होता है)
        - फोर्किंग वास्तव में कॉपी ऑन राइट (रीड-ओनली) है जब तक कि नई प्रक्रिया मेमोरी को नहीं लिखती है, तब यह पूरी कॉपी करता है।
        - प्रसंग स्विचिंग
          - ऑपरेटिंग सिस्टम और अंतर्निहित हार्डवेयर द्वारा संदर्भ स्विचिंग कैसे शुरू की जाती है?
    - [ ] [सी++ में थ्रेड (श्रृंखला - 10 वीडियो)](https://www.youtube.com/playlist?list=PL5jc9xFGsL8E12so1wlMS0r0hTQoJL74M)
    - [ ] [सीएस 377 स्प्रिंग '14: मैसाचुसेट्स विश्वविद्यालय से ऑपरेटिंग सिस्टम](https://www.youtube.com/playlist?list=PLacuG5pysFbDQU8kKxbUh4K5c1iL5_k7k)
    - [] पायथन में संगामिति (वीडियो):
        - [ ] [थ्रेड्स पर शॉर्ट सीरीज़](https://www.youtube.com/playlist?list=PL1H1sBF1VAKVMONJWJkmUh6_p8g4F2oy1)
        - [ ] [पायथन थ्रेड्स](https://www.youtube.com/watch?v=Bs7vPNbB9JM)
        - [ ] [पायथन जीआईएल को समझना (2010)](https://www.youtube.com/watch?v=Obt-vMVdM8s)
            - [संदर्भ] (http://www.dabeaz.com/GIL)
        - [ ] [डेविड बेज़ले - पाइथॉन कंकरेंसी फ्रॉम द ग्राउंड अप: लाइव! - पाइकॉन 2015](https://www.youtube.com/watch?v=MCs5OvhV9S4)
        - [ ] [मुख्य वक्ता डेविड बेज़ले - रुचि के विषय (पायथन एसिंकियो)](https://www.youtube.com/watch?v=ZzfHjytDceU)
        - [ ] [पायथन में म्यूटेक्स](https://www.youtube.com/watch?v=0zaPs8OtyKY)

- ### परिक्षण
    - आच्छादित करना:
        - यूनिट परीक्षण कैसे काम करता है
        - नकली वस्तुएं क्या हैं
        - एकीकरण परीक्षण क्या है
        - निर्भरता इंजेक्शन क्या है
    - [ ] [जेम्स बाख के साथ एजाइल सॉफ्टवेयर टेस्टिंग (वीडियो)](https://www.youtube.com/watch?v=SAhJf36_u5U)
    - [ ] [जेम्स बाख द्वारा सॉफ्टवेयर परीक्षण पर खुला व्याख्यान (वीडियो)](https://www.youtube.com/watch?v=ILkT_HV9DVU)
    - [ ] [स्टीव फ्रीमैन - टेस्ट-ड्रिवेन डेवलपमेंट (यही हमारा मतलब नहीं था) (वीडियो)](https://vimeo.com/83960706)
        - [स्लाइड्स] (http://gotocon.com/dl/goto-berlin-2013/slides/SteveFreeman_TestDrivenDevelopmentThatsNotWhatWeMeant.pdf)
    - [ ] निर्भरता इंजेक्शन:
        - [ ] [वीडियो](https://www.youtube.com/watch?v=IKD2-MAkXyQ)
        - [ ] [परीक्षण के ताओ] (http://jasonpolites.github.io/tao-of-testing/ch3-1.1.html)
    - [ ] [परीक्षा कैसे लिखें](http://jasonpolites.github.io/tao-of-testing/ch4-1.1.html)

-### स्ट्रिंग खोज और जोड़तोड़
    - [ ] [सेडगेविक - प्रत्यय सरणी (वीडियो)](https://www.coursera.org/learn/algorithms-part2/lecture/TH18W/suffix-arrays)
    - [ ] [सेजविक - सबस्ट्रिंग सर्च (वीडियो)](https://www.coursera.org/learn/algorithms-part2/home/week/4)
        - [ ] [1. सबस्ट्रिंग सर्च का परिचय](https://www.coursera.org/lecture/algorithms-part2/introduction-to-substring-search-n3ZpG)
        - [ ] [2. ब्रूट-फोर्स सबस्ट्रिंग सर्च](https://www.coursera.org/learn/algorithms-part2/lecture/2Kn5i/brute-force-substring-search)
        - [ ] [3. नुथ-मॉरिस प्रैट](https://www.coursera.org/learn/algorithms-part2/lecture/TAtDr/knuth-morris-pratt)
        - [ ] [4. बॉयर-मूर](https://www.coursera.org/learn/algorithms-part2/lecture/CYxOT/boyer-moore)
        - [ ] [5. राबिन-कार्प](https://www.coursera.org/lecture/algorithms-part2/rabin-karp-3KiqT)
    - [ ] [पाठ में खोज पैटर्न (वीडियो)](https://www.coursera.org/learn/data-structs/lecture/tAfHI/search-pattern-in-text)

    यदि आपको इस विषय पर अधिक विवरण की आवश्यकता है, तो [कुछ विषयों पर अतिरिक्त विवरण] (# अतिरिक्त-विवरण-पर-कुछ-विषयों) में "स्ट्रिंग मिलान" अनुभाग देखें।

- ### कोशिश करता है
    - ध्यान दें कि विभिन्न प्रकार के प्रयास हैं। कुछ में उपसर्ग होते हैं, कुछ नहीं, और कुछ बिट्स के बजाय स्ट्रिंग का उपयोग करते हैं
        पथ को ट्रैक करने के लिए
    - मैं कोड के माध्यम से पढ़ता हूं, लेकिन लागू नहीं करूंगा
    - [ ] [सेजविक - ट्राइज़ (3 वीडियो)](https://www.coursera.org/learn/algorithms-part2/home/week/4)
        - [ ] [1. आर वे ट्राइस](https://www.coursera.org/learn/algorithms-part2/lecture/CPVdr/r-way-trys)
        - [ ] [2. टर्नरी खोज प्रयास](https://www.coursera.org/learn/algorithms-part2/lecture/yQM8K/ternary-search-trys)
        - [ ] [3. चरित्र आधारित संचालन](https://www.coursera.org/learn/algorithms-part2/lecture/jwNmV/character-based-operations)
   - [ ] [डेटा संरचनाओं और प्रोग्रामिंग तकनीकों पर नोट्स](http://www.cs.yale.edu/homes/aspnes/classes/223/notes.html#Tries)
    - [ ] लघु ​​पाठ्यक्रम वीडियो:
        - [ ] [प्रयासों का परिचय (वीडियो)](https://www.coursera.org/learn/data-structures-optimizing-performance/lecture/08Xyf/core-introduction-to-trys)
        - [ ] [प्रयासों का प्रदर्शन (वीडियो)](https://www.coursera.org/learn/data-structures-optimizing-performance/lecture/PvlZW/core-performance-of-trys)
        - [ ] [एक ट्री को लागू करना (वीडियो)](https://www.coursera.org/learn/data-structures-optimizing-performance/lecture/DFvd3/core-implementing-a-trie)
    - [ ] [द ट्री: ए नेग्लेक्टेड डेटा स्ट्रक्चर](https://www.toptal.com/java/the-trie-a-neglected-data-struct)
    - [ ] [टॉपकोडर - ट्राईज़ का उपयोग करना](https://www.topcoder.com/thrive/articles/Using%20Tries)
    - [ ] [स्टैनफोर्ड लेक्चर (असली दुनिया में इस्तेमाल का मामला) (वीडियो)](https://www.youtube.com/watch?v=TJ8SkcUSdbU)
    - [ ] [एमआईटी, उन्नत डेटा संरचनाएं, स्ट्रिंग्स (आधे रास्ते में बहुत अस्पष्ट हो सकती हैं) (वीडियो)](https://www.youtube.com/watch?v=NinWEPPrkDQ&index=16&list=PLUl4u3cNGP61hsJNdULdudlRL493b-XZf)

- ### दशमलव संख्याएं
    - [ ] साधारण 8-बिट: [फ़्लोटिंग पॉइंट नंबरों का प्रतिनिधित्व - 1 (वीडियो - गणना में त्रुटि है - वीडियो विवरण देखें)](https://www.youtube.com/watch?v=ji3SfClm8TU)

- ### यूनिकोड
    - [ ] [पूर्ण न्यूनतम हर सॉफ्टवेयर डेवलपर बिल्कुल, सकारात्मक रूप से यूनिकोड और कैरेक्टर सेट के बारे में जानना चाहिए]( http://www.joelonsoftware.com/articles/Unicode.html)
    - [ ] [पाठ के साथ काम करने के लिए हर प्रोग्रामर को क्या बिल्कुल, सकारात्मक रूप से एन्कोडिंग और कैरेक्टर सेट के बारे में जानने की जरूरत है](http://kunsttube.net/encoding/)
-### अंतहीनता
    - [ ] [बिग एंड लिटिल एंडियन](https://web.archive.org/web/20180107141940/http://www.cs.umd.edu:80/class/sum2003/cmsc311/Notes/Data/endian. एचटीएमएल)
    - [ ] [बिग एंडियन बनाम लिटिल एंडियन (वीडियो)](https://www.youtube.com/watch?v=JrNF0KRAlyo)
    - [ ] [बिग एंड लिटिल एंडियन इनसाइड/आउट (वीडियो)](https://www.youtube.com/watch?v=oBSuXP-1Tc0)
        - कर्नेल देवों के लिए बहुत तकनीकी बात। यदि अधिकांश आपके सिर के ऊपर है तो चिंता न करें।
        - पहला हाफ काफी है।

- ### नेटवर्किंग
    - **यदि आपके पास नेटवर्किंग का अनुभव है या आप एक विश्वसनीयता इंजीनियर या संचालन इंजीनियर बनना चाहते हैं, तो प्रश्नों की अपेक्षा करें**
    - अन्यथा, यह जानना अच्छा है
    - [ ] [खान अकादमी](https://www.khanacademy.org/computing/code-org/computers-and-the-internet)
    - [ ] [यूडीपी और टीसीपी: ट्रांसपोर्ट प्रोटोकॉल की तुलना (वीडियो)](https://www.youtube.com/watch?v=Vdc8TCESIg8)
    - [ ] [टीसीपी/आईपी और ओएसआई मॉडल की व्याख्या! (वीडियो)](https://www.youtube.com/watch?v=e5DEVa9eSN0)
    - [ ] [इंटरनेट पर पैकेट ट्रांसमिशन। नेटवर्किंग और टीसीपी/आईपी ट्यूटोरियल। (वीडियो)](https://www.youtube.com/watch?v=nomyRJehhnM)
    - [ ] [HTTP (वीडियो)](https://www.youtube.com/watch?v=WGJrLqtX7As)
    - [ ] [एसएसएल और एचटीटीपीएस (वीडियो)](https://www.youtube.com/watch?v=S2iBR2ZlZf0)
    - [ ] [एसएसएल/टीएलएस (वीडियो)](https://www.youtube.com/watch?v=Rp3iZUvXWlM)
    - [ ] [HTTP 2.0 (वीडियो)](https://www.youtube.com/watch?v=E9FxNzv1Tr8)
    - [ ] [वीडियो सीरीज़ (21 वीडियो) (वीडियो)](https://www.youtube.com/playlist?list=PLEbnTDJUr_IegfoqO4iPnPYQui46QqT0j)
    - [ ] [सबनेटिंग डिमिस्टिफाइड - भाग 5 सीआईडीआर नोटेशन (वीडियो)](https://www.youtube.com/watch?v=t5xYI0jzOf4)
    - [] सॉकेट:
        - [ ] [जावा - सॉकेट - परिचय (वीडियो)](https://www.youtube.com/watch?v=6G_W54zuadg&t=6s)
        - [ ] [सॉकेट प्रोग्रामिंग (वीडियो)](https://www.youtube.com/watch?v=G75vN2mnJeQ)

## अंतिम समीक्षा

    इस अनुभाग में छोटे वीडियो होंगे जिन्हें आप अधिकांश महत्वपूर्ण अवधारणाओं की समीक्षा करने के लिए बहुत तेज़ी से देख सकते हैं।
    यदि आप अक्सर एक पुनश्चर्या चाहते हैं तो यह अच्छा है।

- [] 2-3 मिनट के लघु विषय वीडियो की श्रृंखला (23 वीडियो)
    - [वीडियो](https://www.youtube.com/watch?v=r4r1DZcx1cM&list=PLmVb1OknmNJuC5POdcDv5oCS7_OUkDgpj&index=22)
- [ ] 2-5 मिनट के लघु विषय वीडियो की श्रृंखला - माइकल साम्बोल (18 वीडियो):
    - [वीडियो](https://www.youtube.com/channel/UCzDJwLWoYCUQowF_nG3m5OQ)
- [ ] [सेजविक वीडियो - एल्गोरिदम I](https://www.coursera.org/learn/algorithms-part1)
- [ ] [सेजविक वीडियो - एल्गोरिदम II](https://www.coursera.org/learn/algorithms-part2)

---

## अपना रिज्यूमे अपडेट करें

- किताबों में तैयारी की जानकारी फिर से शुरू करें देखें: "कोडिंग इंटरव्यू क्रैकिंग" और "प्रोग्रामिंग इंटरव्यू एक्सपोज्ड"
- मुझे नहीं पता कि यह कितना महत्वपूर्ण है (आप अपना खुद का शोध कर सकते हैं) लेकिन यहां आपके रेज़्यूमे को एटीएस के अनुरूप बनाने पर एक लेख है:
    - [कैसे बनाएं या जांचें कि आपका रिज्यूमे एटीएस के अनुरूप है या नहीं](https://ayedot.com/97/MiniBlog/Meaning-of-ATS-compliant-resume-and-How-to-create-ATS-Resume-for -मुक्त)
- [गेल मैकडॉवेल (क्रैकिंग द कोडिंग इंटरव्यू के लेखक) द्वारा ["दिस इज़ व्हाट ए गुड रिज्यूमे शुड लुक लाइक"](https://www.careercup.com/resume),
    - लेखक द्वारा नोट: "यह यूएस-केंद्रित रिज्यूमे के लिए है। भारत और अन्य देशों के लिए सीवी की अलग-अलग अपेक्षाएं हैं, हालांकि कई बिंदु समान होंगे।"
- [टेक इंटरव्यू हैंडबुक द्वारा "स्टेप-बाय-स्टेप रेज़्यूमे गाइड"](https://www.techinterviewhandbook.org/resume/guide)
    - शुरू से अपना रिज्यूमे कैसे सेट करें, इस बारे में विस्तृत गाइड, प्रभावी रिज्यूमे सामग्री लिखें, इसे ऑप्टिमाइज़ करें और अपने रिज्यूमे का परीक्षण करें


## एक नौकरी ढूंढो

- [नौकरियां खोजने के लिए साइटें](https://ayedot.com/151/MiniBlog/Top-10-Best-Websites-for-Careers--Jobs)

## साक्षात्कार प्रक्रिया और सामान्य साक्षात्कार तैयारी

- [ ] [2021 में इंजीनियरिंग इंटरव्यू कैसे पास करें](https://davidbyttow.medium.com/how-to-pass-the-engineering-interview-in-2021-45f1b389a1)
- [ ] [तकनीकी भर्ती का रहस्योद्घाटन](https://www.youtube.com/watch?v=N233T0epWTs)
- [ ] बिग 4 में नौकरी कैसे प्राप्त करें:
    - [ ] [बिग 4 में नौकरी कैसे पाएं - Amazon, Facebook, Google और Microsoft (वीडियो)](https://www.youtube.com/watch?v=YJZCUhxNCv8)
    - [ ] [बिग 4.1 में नौकरी कैसे पाएं (फॉलो-अप वीडियो)](https://www.youtube.com/watch?v=6790FVXWBw8&feature=youtu.be)
- [ ] कोडिंग इंटरव्यू सेट 1 को क्रैक करना:
    - [ ] [गेल एल मैकडॉवेल - क्रैकिंग द कोडिंग इंटरव्यू (वीडियो)](https://www.youtube.com/watch?v=rEJzOhC5ZtQ)
    - [ ] [लेखक गेल लाकमैन मैकडॉवेल के साथ कोडिंग इंटरव्यू क्रैक करना (वीडियो)](https://www.youtube.com/watch?v=aClxtDcdpsQ)
- [ ] फेसबुक कोडिंग इंटरव्यू को क्रैक करना:
    - [ ] [दृष्टिकोण](https://www.youtube.com/watch?v=wCl9kvQGHPI)
    - [ ] [समस्या पूर्वाभ्यास](https://www.youtube.com/watch?v=4UWDyJq8jZg)
- तैयारी पाठ्यक्रम:
    - [सॉफ्टवेयर इंजीनियर इंटरव्यू अनलीशेड (पेड कोर्स)](https://www.udemy.com/software-engineer-interview-unleashed):
        - Google के किसी पूर्व साक्षात्कारकर्ता से सॉफ़्टवेयर इंजीनियर साक्षात्कार के लिए स्वयं को तैयार करने का तरीका जानें.
    - [पायथन फॉर डेटा स्ट्रक्चर्स, एल्गोरिदम, और इंटरव्यू (पेड कोर्स)](https://www.udemy.com/python-for-data-structures-algorithms-and-interviews/):
        - एक पायथन केंद्रित साक्षात्कार तैयारी पाठ्यक्रम जिसमें डेटा संरचनाएं, एल्गोरिदम, नकली साक्षात्कार और बहुत कुछ शामिल है।
    - [पायथन का उपयोग करके डेटा संरचनाओं और एल्गोरिदम का परिचय (उडेसिटी फ्री कोर्स)](https://www.udacity.com/course/data-structures-and-algorithms-in-python--ud513):
        - एक मुफ्त पायथन केंद्रित डेटा संरचनाएं और एल्गोरिदम पाठ्यक्रम।
    - [डेटा संरचनाएं और एल्गोरिदम नैनोडेग्री! (उडेसिटी पेड नैनोडेग्री)](https://www.udacity.com/course/data-structures-and-algorithms-nanodegree--nd256):
        - साक्षात्कार और नौकरी के परिदृश्य के लिए तैयार करने में मदद करने के लिए एक समर्पित सलाहकार से 100 से अधिक डेटा संरचनाओं और एल्गोरिदम अभ्यास और मार्गदर्शन के साथ व्यावहारिक अभ्यास प्राप्त करें।
    - [बिहेवियरल इंटरव्यू ग्रोकिंग (शिक्षा मुक्त कोर्स)](https://www.educative.io/courses/grokking-the-behavioral-interview):
        - कई बार, यह आपकी तकनीकी योग्यता नहीं है जो आपको अपने सपनों की नौकरी में उतरने से रोकती है, यह है कि आप व्यवहारिक साक्षात्कार पर कैसा प्रदर्शन करते हैं।

नकली साक्षात्कार:
- [Gainlo.co: बड़ी कंपनियों के नकली साक्षात्कारकर्ता] (http://www.gainlo.co/#!/) - मैंने इसका इस्तेमाल किया और इससे मुझे फोन स्क्रीन और साइट पर साक्षात्कार के लिए आराम करने में मदद मिली
- [प्रैम्प: पीयर-टू-पीयर मॉडल ऑफ़ प्रैक्टिस इंटरव्यूज़] (https://www.pramp.com/)
- [interviewing.io: वरिष्ठ इंजीनियरों के साथ मॉक इंटरव्यू का अभ्यास करें](https://interviewing.io) - अनाम एल्गोरिथम/सिस्टम डिज़ाइन साक्षात्कार FAANG के वरिष्ठ इंजीनियरों के साथ गुमनाम रूप से

## इंटरव्यू कब आए, इसके बारे में सोचें

नीचे दी गई मदों की पंक्तियों के साथ आपको मिलने वाले लगभग 20 साक्षात्कार प्रश्नों के बारे में सोचें। प्रत्येक के लिए कम से कम एक उत्तर दें।
आपके द्वारा हासिल की गई किसी चीज़ के बारे में, केवल डेटा ही नहीं, एक कहानी रखें।

- आपको यह नौकरी क्यों चाहिए?
- आपने कौन सी कठिन समस्या हल की है?
- सबसे बड़ी चुनौतियों का सामना करना पड़ा?
- सबसे अच्छा / सबसे खराब डिजाइन देखा गया?
- मौजूदा उत्पाद में सुधार के लिए विचार
- आप एक व्यक्ति के रूप में और एक टीम के हिस्से के रूप में सबसे अच्छा कैसे काम करते हैं?
- आपका कौन सा कौशल या अनुभव भूमिका में संपत्ति होगा और क्यों?
- [जॉब एक्स / प्रोजेक्ट वाई] में आपको सबसे ज्यादा क्या पसंद आया?
- [जॉब एक्स / प्रोजेक्ट वाई] में आपको सबसे बड़ी चुनौती क्या थी?
- [जॉब एक्स / प्रोजेक्ट वाई] में आपको सबसे कठिन बग क्या था?
- आपने [जॉब x / प्रोजेक्ट y] में क्या सीखा?
- [जॉब x / प्रोजेक्ट y] में आपने क्या बेहतर किया होगा?

- यदि आपको इस प्रकार के साक्षात्कार प्रश्नों के अच्छे उत्तर प्राप्त करने में कठिनाई होती है, तो यहां कुछ उपाय दिए गए हैं:
    - [सामान्य साक्षात्कार प्रश्न और उनके उत्तर](https://ayedot.com/119/MiniBlog/General-Interview-Questions-and-their-Answers-for-Tech-Jobs)

## साक्षात्कारकर्ता के लिए प्रश्न हैं

मेरे कुछ (मैं पहले से ही उत्तर जानता हूं, लेकिन उनकी राय या टीम परिप्रेक्ष्य चाहता हूं):

- आपकी टीम कितनी बड़ी है?
- आपका देव चक्र कैसा दिखता है? क्या आप वाटरफॉल/स्प्रिंट/फुर्तीली करते हैं?
- क्या समय सीमा के लिए दौड़ आम है? या कोई लचीलापन है?
- आपकी टीम में निर्णय कैसे लिए जाते हैं?
- आप प्रति सप्ताह कितनी बैठकें करते हैं?
- क्या आपको लगता है कि आपके काम का माहौल आपको ध्यान केंद्रित करने में मदद करता है?
- आप किस पर काम कर रहे हैं?
- आपको इसमें क्या पसंद है?
- काम का जीवन कैसा है?
- कार्य/जीवन संतुलन कैसा है?

## एक बार आपको नौकरी मिल गई

बधाई हो!

सीखते रहो।

आप वास्तव में कभी नहीं कर रहे हैं।

---

    *********************************************** *********************************************** *
    *********************************************** *********************************************** *

    इस बिंदु के नीचे सब कुछ वैकल्पिक है। प्रवेश स्तर के साक्षात्कार के लिए इसकी आवश्यकता नहीं है।
    हालांकि, इनका अध्ययन करके, आप अधिक सीएस अवधारणाओं के बारे में अधिक जानकारी प्राप्त करेंगे, और इसके लिए बेहतर तरीके से तैयार होंगे
    कोई भी सॉफ्टवेयर इंजीनियरिंग जॉब। आप बहुत अधिक कुशल सॉफ्टवेयर इंजीनियर होंगे।
    
    *********************************************** *********************************************** *
    *********************************************** *********************************************** *

---

## अतिरिक्त पुस्तकें
 यहां हैं ताकि आप किसी ऐसे विषय पर जा सकें जो आपको रुचिकर लगे।

- [यूनिक्स प्रोग्रामिंग पर्यावरण](https://www.amazon.com/dp/013937681X)
    - एक बूढ़ी लेकिन एक गुडी
- [लिनक्स कमांड लाइन: एक पूर्ण परिचय](https://www.amazon.com/dp/1593273894/)
    - एक आधुनिक विकल्प
- [टीसीपी/आईपी इलस्ट्रेटेड सीरीज](https://en.wikipedia.org/wiki/TCP/IP_Illustrated)
- [हेड फर्स्ट डिज़ाइन पैटर्न](https://www.amazon.com/gp/product/0596007124/)
    - डिजाइन पैटर्न के लिए एक सौम्य परिचय
- [डिज़ाइन पैटर्न: पुन: प्रयोज्य ऑब्जेक्ट-ओरिएंट डी सॉफ़्टवेयर के तत्व](https://www.amazon.com/Design-Patterns-Elements-Reusable-Object-Oriented/dp/0201633612)
    - उर्फ ​​"गैंग ऑफ़ फोर" पुस्तक, या GOF
    - विहित डिजाइन पैटर्न पुस्तक
- [एल्गोरिदम डिजाइन मैनुअल] (http://www.amazon.com/Algorithm-Design-Manual-Steven-Skiena/dp/1849967202) (स्कीना)
    - समीक्षा और समस्या की पहचान के रूप में
    - एल्गोरिथम कैटलॉग भाग आपको साक्षात्कार में मिलने वाली कठिनाई के दायरे से बाहर है
    - इस पुस्तक के 2 भाग हैं:
        - डेटा संरचनाओं और एल्गोरिदम पर कक्षा की पाठ्यपुस्तक
            - पेशेवरों:
                - एक अच्छी समीक्षा है क्योंकि कोई भी एल्गोरिदम पाठ्यपुस्तक होगी
                - उद्योग और शिक्षा जगत में समस्याओं को सुलझाने के उनके अनुभवों की अच्छी कहानियाँ
                - सी . में कोड उदाहरण
            - दोष:
                - सीएलआरएस जितना घना या अभेद्य हो सकता है, और कुछ मामलों में, सीएलआरएस कुछ विषयों के लिए एक बेहतर विकल्प हो सकता है
                - अध्याय 7, 8, 9 का पालन करने की कोशिश करना दर्दनाक हो सकता है, क्योंकि कुछ वस्तुओं को अच्छी तरह से समझाया नहीं गया है या मेरे पास जितना दिमाग है उससे अधिक दिमाग की आवश्यकता है
                - मुझे गलत मत समझो: मुझे स्कीना, उनकी शिक्षण शैली और तौर-तरीके पसंद हैं, लेकिन मैं स्टोनी ब्रुक सामग्री नहीं हो सकता
        - एल्गोरिथम कैटलॉग:
            - यही असली कारण है कि आप इस किताब को खरीदते हैं।
            - यह पुस्तक एक एल्गोरिथम संदर्भ के रूप में बेहतर है, न कि कुछ ऐसा जिसे आप कवर टू कवर पढ़ते हैं।
    - इसे किंडल पर किराए पर ले सकते हैं
    - उत्तर:
        - [समाधान](https://web.archive.org/web/20150404194210/http://www.algorithm.cs.sunysb.edu/algowiki/index.php/The_Algorithms_Design_Manual_(Second_Edition))
    - [इरेटा](http://www3.cs.stonybrook.edu/~skiena/algorist/book/errata)
- [महान कोड लिखें: खंड 1: मशीन को समझना](https://www.amazon.com/Write-Great-Code-Understand-Machine/dp/1593270038)
    - पुस्तक 2004 में प्रकाशित हुई थी, और कुछ पुरानी है, लेकिन कंप्यूटर को संक्षेप में समझने के लिए यह एक बढ़िया संसाधन है
    - लेखक ने [HLA](https://en.wikipedia.org/wiki/High_Level_Assembly) का आविष्कार किया, इसलिए नमक के एक दाने के साथ HLA में उल्लेख और उदाहरण लें। व्यापक रूप से उपयोग नहीं किया जाता है, लेकिन असेंबली कैसा दिखता है इसके अच्छे उदाहरण हैं
    - आपको एक अच्छी नींव देने के लिए ये अध्याय पढ़ने लायक हैं:
        - अध्याय 2 - संख्यात्मक प्रतिनिधित्व
        - अध्याय 3 - बाइनरी अंकगणित और बिट संचालन
        - अध्याय 4 - फ़्लोटिंग-पॉइंट प्रतिनिधित्व
        - अध्याय 5 - चरित्र प्रतिनिधित्व
        - अध्याय 6 - स्मृति संगठन और पहुंच
        - अध्याय 7 - समग्र डेटा प्रकार और मेमोरी ऑब्जेक्ट
        - अध्याय 9 - सीपीयू वास्तुकला
        - अध्याय 10 - निर्देश सेट वास्तुकला
        - अध्याय 11 - स्मृति वास्तुकला और संगठन
- [एल्गोरिदम का परिचय](https://www.amazon.com/Introduction-Algorithms-fourth-Thomas-Cormen/dp/026204630X)
    - **महत्वपूर्ण:** इस पुस्तक को पढ़ने का केवल सीमित महत्व होगा। यह पुस्तक एल्गोरिदम और डेटा संरचनाओं की एक बेहतरीन समीक्षा है, लेकिन यह आपको अच्छा कोड लिखना नहीं सिखाएगी। आपको एक अच्छे समाधान को कुशलता से कोड करने में सक्षम होना चाहिए
    - उर्फ ​​सीएलआर, कभी-कभी सीएलआरएस, क्योंकि स्टीन खेल के लिए देर हो चुकी थी
- [कंप्यूटर आर्किटेक्चर, छठा संस्करण: एक मात्रात्मक दृष्टिकोण] (https://www.amazon.com/dp/0128119055)
    - एक अमीर, अधिक अप-टू-डेट (2017) के लिए, लेकिन लंबे समय तक इलाज

## सिस्टम डिज़ाइन, स्केलेबिलिटी, डेटा हैंडलिंग

**यदि आपके पास 4+ वर्ष का अनुभव है तो आप सिस्टम डिज़ाइन प्रश्नों की अपेक्षा कर सकते हैं।**

- कई विषयों और संसाधनों के साथ स्केलेबिलिटी और सिस्टम डिज़ाइन बहुत बड़े विषय हैं, क्योंकि
      सॉफ़्टवेयर/हार्डवेयर सिस्टम को डिज़ाइन करते समय विचार करने के लिए बहुत कुछ है जो स्केल कर सकता है।
      इस पर काफी समय बिताने की अपेक्षा करें
- विचार:
    - मापनीयता
        - बड़े डेटा सेट को एकल मानों पर डिस्टिल करें
        - एक डेटा सेट को दूसरे में बदलना
        - अश्लील रूप से बड़ी मात्रा में डेटा को संभालना
    - प्रणाली की रूपरेखा
        - सुविधाएँ सेट
        - इंटरफेस
        - वर्ग पदानुक्रम
        - कुछ बाधाओं के तहत एक प्रणाली को डिजाइन करना
        - सादगी और मजबूती
        - ट्रेडऑफ़
        - प्रदर्शन विश्लेषण और अनुकूलन
- [ ] **यहां शुरू करें**: [सिस्टम डिजाइन प्राइमर](https://github.com/donnemartin/system-design-primer)
- [ ] [HiredInTech से सिस्टम डिज़ाइन] (http://www.hiredintech.com/system-design/)
- [ ] [तकनीकी साक्षात्कार में मैं डिजाइन प्रश्नों के उत्तर देने की तैयारी कैसे करूं?](https://www.quora.com/How-do-I-prepare-to-answer-design-questions-in-a-technical -साक्षात्कार?redirected_qid=1500023)
- [ ] [8 चीजें जो आपको सिस्टम डिजाइन साक्षात्कार से पहले पता होनी चाहिए](http://blog.gainlo.co/index.php/2015/10/22/8-things-you-need-to-know-before -सिस्टम-डिजाइन-साक्षात्कार/)
- [ ] [डेटाबेस सामान्यीकरण - 1NF, 2NF, 3NF और 4NF (वीडियो)](https://www.youtube.com/watch?v=UrYLYV7WSHM)
- [ ] [सिस्टम डिज़ाइन इंटरव्यू](https://github.com/checkcheckzz/system-design-interview) - इसमें बहुत सारे संसाधन हैं। लेखों और उदाहरणों के माध्यम से देखें। मैंने उनमें से कुछ को नीचे रखा है
- [ ] [कैसे एक सिस्टम डिजाइन साक्षात्कार में सफलता प्राप्त करें](https://web.archive.org/web/20120716060051/http://www.palantir.com/2011/10/how-to-rock-a-systems -डिजाइन-साक्षात्कार/)
- [ ] [संख्या सभी को पता होनी चाहिए](http://everythingisdata.wordpress.com/2009/10/17/numbers-everyone- should-know/)
- [ ] [संदर्भ स्विच करने में कितना समय लगता है?](http://blog.tsunanet.net/2010/11/how-long-does-it-take-to-make-context.html)
- [ ] [डेटासेंटर में लेन-देन (वीडियो)](https://www.youtube.com/watch?v=srOgpXECblk)
- [ ] [कैप प्रमेय का एक सादा अंग्रेजी परिचय](http://ksat.me/a-plain-english-introduction-to-cap-theorem)
- [ ] [MIT 6.824: डिस्ट्रिब्यूटेड सिस्टम्स, स्प्रिंग 2020 (20 वीडियो)](https://www.youtube.com/watch?v=cQP8WApzIQQ&list=PLrw6a1wE39_tb2fErI4-WkMbsvGQk9_UB)
- [] आम सहमति एल्गोरिदम:
    - [ ] पैक्सोस - [पैक्सोस एग्रीमेंट - कंप्यूटरफाइल (वीडियो)](https://www.youtube.com/watch?v=s8JqcZtvnsM)
    - [ ] बेड़ा - [बेड़ा वितरित आम सहमति एल्गोरिथ्म का एक परिचय (वीडियो)](https://www.youtube.com/watch?v=P9Ydif5_qvE)
        - [ ] [पढ़ने में आसान पेपर](https://raft.github.io/)
        - [ ] [इन्फोग्राफिक] (http://thesecretlivesofdata.com/raft/)
- [ ] [लगातार हैशिंग] (http://www.tom-e-white.com/2007/11/consistent-hashing.html)
- [ ] [नोएसक्यूएल पैटर्न] (http://horicky.blogspot.com/2009/11/nosql-patterns.html)
- [] मापनीयता:
    - आपको इन सब की जरूरत नहीं है। बस कुछ ऐसे चुनें जिनमें आपकी रुचि हो।
    - [ ] [शानदार अवलोकन (वीडियो)](https://www.youtube.com/watch?v=-W9F__D3oY4)
    - [] लघु ​​श्रृंखला:
       - [क्लोन] (http://www.lecloud.net/post/7295452622/scalability-for-dummies-part-1-clones)
        - [डेटाबेस] (http://www.lecloud.net/post/7994751381/scalability-for-dummies-part-2-database)
        - [कैश] (http://www.lecloud.net/post/9246290032/scalability-for-dummies-part-3-cache)
        - [एसिंक्रोनिज़्म] (http://www.lecloud.net/post/9699762917/scalability-for-dummies-part-4-asynchronism)
    - [ ] [स्केलेबल वेब आर्किटेक्चर और डिस्ट्रिब्यूटेड सिस्टम्स] (http://www.aosabook.org/en/distsys.html)
    - [ ] [डिस्ट्रिब्यूटेड कंप्यूटिंग की गलतियां समझाया](https://pages.cs.wisc.edu/~zuyu/files/fallacies.pdf)
    - [ ] [जेफ डीन - Google पर सॉफ्टवेयर सिस्टम बनाना और सीखे गए पाठ (वीडियो)](https://www.youtube.com/watch?v=modXC5IWTJI)
    - [ ] [स्केल के लिए आर्किटेक्चरिंग सिस्टम का परिचय](http://lethain.com/introduction-to-architecting-systems-for-scale/)
    - [ ] [ऐप इंजन और क्लाउड डेटास्टोर (वीडियो) का उपयोग करके मोबाइल गेम को वैश्विक दर्शकों तक पहुंचाना](https://www.youtube.com/watch?v=9nWyWwY2Onc)
    - [ ] [Google प्लैनेट-स्केल इंफ़्रा के लिए प्लैनेट-स्केल इंजीनियरिंग कैसे करता है (वीडियो)](https://www.youtube.com/watch?v=H4vMcD7zKM0)
    - [ ] [एल्गोरिदम का महत्व](https://www.topcoder.com/thrive/articles/The%20Importance%20of%20Algorithms)
    - [ ] [शार्डिंग] (http://highscalability.com/blog/2009/8/6/an-unorthodox-approach-to-database-design-the-coming-of-the.html)
    - [ ] [लंबे गेम के लिए इंजीनियरिंग - एस्ट्रिड एटकिंसन कीनोट (वीडियो)](https://www.youtube.com/watch?v=p0jGmgIrf_M&list=PLRXxvay_m8gqVlExPC5DG3TGWJTaBgqSA&index=4)
    - [ ] [30 मिनट में 7 साल के YouTube मापनीयता पाठ](http://highscalability.com/blog/2012/3/26/7-years-of-youtube-scalability-lessons-in-30-minutes.html )
        - [वीडियो](https://www.youtube.com/watch?v=G-lGCC4KKok)
    - [ ] [कैसे पेपैल ने केवल 8VMs का उपयोग करके प्रतिदिन अरबों लेन-देन किया](http://highscalability.com/blog/2016/8/15/how-paypal-scaled-to-billions-of-transactions-daily-using -जू.एचटीएमएल)
    - [ ] [बड़े डेटासेट में डुप्लीकेट कैसे निकालें](https://blog.clevertap.com/how-to-remove-duplicates-in-large-datasets/)
    - [ ] [जॉन कोवी के साथ एटीसी के पैमाने और इंजीनियरिंग संस्कृति के अंदर एक नज़र (वीडियो)](https://www.youtube.com/watch?v=3vV4YiqKm1o)
    - [ ] [व्हाट लेड अमेज़ॉन टू इट्स ओन माइक्रोसर्विसेज आर्किटेक्चर](http://thenewstack.io/led-amazon-microservices-architecture/)
    - [ ] [कंप्रेस करना या न करना, यह उबर का सवाल था](https://eng.uber.com/trip-data-squeeze/)
    - [ ] [अनुमानित क्वेरी संसाधन का उपयोग कब किया जाना चाहिए?]
    - [ ] [एकल डेटासेंटर से Google का ट्रांज़िशन, टू फ़ेलओवर, टू ए नेटिव मल्टीहोम आर्किटेक्चर]( http://highscalability.com/blog/2016/2/23/googles-transition-from-single-datacenter-to-failover- to-a-n.html)
    - [ ] [इमेज ऑप्टिमाइजेशन टेक्नोलॉजी जो प्रतिदिन लाखों अनुरोधों को पूरा करती है](http://highscalability.com/blog/2016/6/15/the-image-optimization-technology-that-serves-millions-of-re .एचटीएमएल)
    - [ ] [एक पैट्रियन आर्किटेक्चर शॉर्ट](http://highscalability.com/blog/2016/2/1/a-patreon-architecture-short.html)
    - [ ] [टिंडर: सबसे बड़े अनुशंसा इंजनों में से एक कैसे तय करता है कि आप आगे किसे देखेंगे?](http://highscalability.com/blog/2016/1/27/tinder-how-does-one-of- the-सबसे बड़ा-सिफारिश-इंजन-de.html)
    - [ ] [एक आधुनिक कैश का डिज़ाइन](http://highscalability.com/blog/2016/1/25/design-of-a-आधुनिक-cache.html)
    - [ ] [फेसबुक स्केल पर लाइव वीडियो स्ट्रीमिंग](http://highscalability.com/blog/2016/1/13/live-video-streaming-at-facebook-scale.html)
    - [ ] [अमेज़ॅन के एडब्ल्यूएस पर 11 मिलियन+ उपयोगकर्ताओं को स्केलिंग करने के लिए एक शुरुआती गाइड](http://highscalability.com/blog/2016/1/11/a-beginners-guide-to-scaling-to-11-million- users-on-amazons.html)
    - [ ] [संपूर्ण नेटफ्लिक्स स्टैक का एक 360 डिग्री दृश्य](http://highscalability.com/blog/2015/11/9/a-360-degree-view-of-the-entire-netflix-stack.html )
    - [ ] [विलंबता हर जगह है और यह आपको बिक्री पर खर्च करती है - इसे कैसे कुचलें] (http://highscalability.com/latency-everywhere-and-it-costs-you-sales-how-crush-it)
    - [ ] [व्हाट पॉवर्स इंस्टाग्राम: सैकड़ों इंस्टेंस, दर्जनों टेक्नोलॉजीज] (http://instagram-engineering.tumblr.com/post/13649370142/what-powers-instagram-hundreds-of-instances)
    - [ ] [सेल्सफोर्स आर्किटेक्चर - हाउ वे हैंडल 1.3 बिलियन ट्रांजैक्शन ए डे](http://highscalability.com/blog/2013/9/23/salesforce-architecture-how-they-handle-13-billion-transacti.html )
    - [ ] [ईएसपीएन का आर्किटेक्चर स्केल पर - 100,000 दुह नुह नुह्स प्रति सेकेंड पर परिचालन](http://highscalability.com/blog/2013/11/4/espns-architecture-at-scale-operating-at-100000-duh -नुह-नुह.एचटीएमएल)
    - [ ] सेवाओं को आपस में जोड़ने वाली कुछ तकनीकों के बारे में जानकारी के लिए नीचे "मैसेजिंग, सीरियलाइज़ेशन और क्यूइंग सिस्टम" देखें।
    - [ ] ट्विटर:
        - [ओ'रेली माईएसक्यूएल सीई 2011: जेरेमी कोल, "@Twitter पर बड़ा और छोटा डेटा" (वीडियो)](https://www.youtube.com/watch?v=5cKTP36HVgI)
        - [पैमाने पर समयरेखा](https://www.infoq.com/presentations/Twitter-Timeline-Scalability)
    - और भी अधिक के लिए, [वीडियो श्रृंखला](#वीडियो-श्रृंखला) अनुभाग में "बड़े पैमाने पर डेटासेट खनन" वीडियो श्रृंखला देखें
- [ ] सिस्टम डिजाइन प्रक्रिया का अभ्यास करना: कागज पर काम करने की कोशिश करने के लिए यहां कुछ विचार दिए गए हैं, प्रत्येक में कुछ दस्तावेज हैं कि इसे वास्तविक दुनिया में कैसे संभाला गया था:
    - समीक्षा करें: [सिस्टम डिज़ाइन प्राइमर](https://github.com/donnemartin/system-design-primer)
    - [HiredInTech से सिस्टम डिज़ाइन] (http://www.hiredintech.com/system-design/)
    - [चीट शीट](https://github.com/jwasham/coding-interview-university/blob/main/extras/cheat%20sheets/system-design.pdf)
    - बहे:
        1. समस्या और दायरे को समझें:
            - साक्षात्कारकर्ता की सहायता से उपयोग के मामलों को परिभाषित करें
            - अतिरिक्त सुविधाओं का सुझाव दें
            - उन वस्तुओं को हटा दें जिन्हें साक्षात्कारकर्ता दायरे से बाहर मानता है
            - मान लें कि उच्च उपलब्धता की आवश्यकता है, उपयोग के मामले के रूप में जोड़ें
        2. बाधाओं के बारे में सोचें:
            - पूछें कि प्रति माह कितने अनुरोध हैं
            - पूछें कि प्रति सेकंड कितने अनुरोध हैं (वे इसे स्वयंसेवा कर सकते हैं या आपको गणित कर सकते हैं)
            - अनुमान पढ़ता है बनाम प्रतिशत लिखता है
            - अनुमान लगाते समय 80/20 नियम को ध्यान में रखें
            - प्रति सेकंड कितना डेटा लिखा जाता है
            - 5 वर्षों में कुल संग्रहण की आवश्यकता
            - प्रति सेकंड कितना डेटा पढ़ता है
        3. सार डिजाइन:
            - परतें (सेवा, डेटा, कैशिंग)
            - इन्फ्रास्ट्रक्चर: लोड बैलेंसिंग, मैसेजिंग
            - सेवा को चलाने वाले किसी भी प्रमुख एल्गोरिथम का मोटे तौर पर अवलोकन
            - बाधाओं पर विचार करें और समाधान निर्धारित करें
    - व्यायाम:
        - [एक यादृच्छिक अद्वितीय आईडी जनरेशन सिस्टम डिज़ाइन करें](https://blog.twitter.com/2010/announcing-snowflake)
        - [की-वैल्यू डेटाबेस डिज़ाइन करें] (http://www.slideshare.net/dvirsky/introduction-to-redis)
        - [तस्वीर साझा करने वाला सिस्टम डिज़ाइन करें](http://highscalability.com/blog/2011/12/6/instagram-architecture-14-million-users-terabytes-of-photos.html)
        - [एक सिफारिश प्रणाली डिजाइन करें](http://ijcai13.org/files/tutorial_slides/td3.pdf)
        - [यूआरएल-शॉर्टनर सिस्टम डिज़ाइन करें: ऊपर से कॉपी किया गया] (http://www.hiredintech.com/system-design/the-system-design-process/)
        - [एक कैश सिस्टम डिज़ाइन करें](https://web.archive.org/web/20220217064329/https://adayinthelifeof.nl/2011/02/06/memcache-internals/)

## अतिरिक्त शिक्षा
मैंने उन्हें एक संपूर्ण सॉफ़्टवेयर इंजीनियर बनने में आपकी सहायता करने के लिए, और कुछ के बारे में जागरूक होने के लिए जोड़ा है
    प्रौद्योगिकियों और एल्गोरिदम, तो आपके पास एक बड़ा टूलबॉक्स होगा।

- ### कंपाइलर्स
    - [एक कंपाइलर ~1 मिनट में कैसे काम करता है (वीडियो)](https://www.youtube.com/watch?v=IhC7sdYe-Jg)
    - [हार्वर्ड CS50 - कंपाइलर (वीडियो)](https://www.youtube.com/watch?v=CSZLNYF4Klo)
    - [सी++ (वीडियो)](https://www.youtube.com/watch?v=twodd1KFfGk)
    - [कंपाइलर ऑप्टिमाइज़ेशन को समझना (C++) (वीडियो)](https://www.youtube.com/watch?v=FnGCDLhaxKU)

- ### Emacs और vi(m)
    - यूनिक्स-आधारित कोड संपादक से खुद को परिचित करें
    - vi (एम):
        - [विम 01 के साथ संपादन - इंस्टॉलेशन, सेटअप और मोड (वीडियो)](https://www.youtube.com/watch?v=5givLEMcINQ&index=1&list=PL13bz4SHGmRxlZVmWQ9DvXo1fEg4UdGkr)
        - [वीआईएम एडवेंचर्स](http://vim-adventures.com/)
        - 4 वीडियो का सेट:
            - [vi/vim संपादक - पाठ 1](https://www.youtube.com/watch?v=SI8TeVMX8pk)
            - [vi/vim संपादक - पाठ 2](https://www.youtube.com/watch?v=F3OO7ZIOaJE)
            - [vi/vim संपादक - पाठ 3](https://www.youtube.com/watch?v=ZYEccA_nMaI)
            - [vi/vim संपादक - पाठ 4](https://www.youtube.com/watch?v=1lYD5gwgZIA)
        - [Emacs के बजाय Vi का उपयोग करना](http://www.cs.yale.edu/homes/aspnes/classes/223/notes.html#Using_Vi_instead_of_Emacs)
    - एमएसीएस:
        - [बेसिक्स Emacs ट्यूटोरियल (वीडियो)](https://www.youtube.com/watch?v=hbmV1bnQ-i0)
        - 3 का सेट (वीडियो):
            - [Emacs Tutorial (शुरुआती) -भाग 1- फ़ाइल कमांड, कट/कॉपी/पेस्ट, कर्सर कमांड](https://www.youtube.com/watch?v=ujODL7MD04Q)
            - [Emacs Tutorial (शुरुआती) -भाग 2- बफर प्रबंधन, खोज, M-x grep और rgrep मोड](https://www.youtube.com/watch?v=XWpsRupJ4II)
            - [Emacs Tutorial (शुरुआती) -भाग 3- एक्सप्रेशन, स्टेटमेंट, ~/.emacs फ़ाइल और पैकेज](https://www.youtube.com/watch?v=paSgzPso-yc)
        - [ईविल मोड: या, हाउ आई लर्न टू स्टॉप वरीइंग एंड लव Emacs (वीडियो)](https://www.youtube.com/watch?v=JWD1Fpdd4Pc)
        - [Emacs के साथ C प्रोग्राम लिखना](http://www.cs.yale.edu/homes/aspnes/classes/223/notes.html#Writing_C_programs_with_Emacs)
- [द एब्सोल्यूट बिगिनर्स गाइड टू Emacs (डेविड विल्सन द्वारा वीडियो)](https://www.youtube.com/watch?v=48JlgiBpw_I&t=0s)
- [द एब्सोल्यूट बिगिनर्स गाइड टू Emacs (डेविड विल्सन के नोट्स)](https://systemcrafters.net/emacs-entials/absolute-beginners-guide-to-emacs/)

- ### यूनिक्स कमांड लाइन टूल्स
    - मैंने नीचे दी गई सूची को अच्छे टूल से भरा।
   - दे घुमा के
    - बिल्ली
    - ग्रेपी
    - सेडो
    - अजीब
    - कर्ल या wget
    - क्रम से लगाना
    - त्रि
    - uniq
    - [स्ट्रेस] (https://en.wikipedia.org/wiki/Strace)
    - [tcpdump](https://danielmiessler.com/study/tcpdump/)

- ### सूचना सिद्धांत (वीडियो)
    - [खान अकादमी](https://www.khanacademy.org/computing/computer-science/informationtheory)
    - मार्कोव प्रक्रियाओं के बारे में अधिक जानकारी:
        - [कोर मार्कोव टेक्स्ट जनरेशन](https://www.coursera.org/learn/data-structures-optimizing-performance/lecture/waxgx/core-markov-text-generation)
        - [कोर इम्प्लीमेंटिंग मार्कोव टेक्स्ट जनरेशन](https://www.coursera.org/learn/data-structures-optimizing-performance/lecture/gZhiC/core-implementing-markov-text-generation)
        - [प्रोजेक्ट = मार्कोव टेक्स्ट जेनरेशन वॉक थ्रू](https://www.coursera.org/learn/data-structures-optimizing-performance/lecture/EUjrq/project-markov-text-generation-walk-through)
    - नीचे MIT 6.050J सूचना और एन्ट्रापी श्रृंखला में और देखें

- ### समता और हैमिंग कोड (वीडियो)
    - [परिचय](https://www.youtube.com/watch?v=q-3BctoUpHE)
    - [समता](https://www.youtube.com/watch?v=DdMcAUlxh1M)
    - हैमिंग कोड:
        - [त्रुटि का पता लगाना](https://www.youtube.com/watch?v=1A_NcXxdoCc)
        - [त्रुटि सुधार](https://www.youtube.com/watch?v=JAMLuxdHH8o)
    - [त्रुटि जांच](https://www.youtube.com/watch?v=wbH2VxzmoZk)

- ### एन्ट्रॉपी
    - नीचे दिए गए वीडियो भी देखें
    - पहले सूचना सिद्धांत वीडियो देखना सुनिश्चित करें
    - [सूचना सिद्धांत, क्लाउड शैनन, एन्ट्रॉपी, अतिरेक, डेटा संपीड़न और बिट्स (वीडियो)](https://youtu.be/JnJq3Py0dyM?t=176)

- ### क्रिप्टोग्राफी
    - नीचे दिए गए वीडियो भी देखें
    - पहले सूचना सिद्धांत वीडियो देखना सुनिश्चित करें
    - [खान अकादमी सीरीज](https://www.khanacademy.org/computing/computer-science/cryptography)
    - [क्रिप्टोग्राफी: हैश फंक्शन](https://www.youtube.com/watch?v=KqqOXndnvic&list=PLUl4u3cNGP6317WaSNfmCvGym2ucw3oGp&index=30)
    - [क्रिप्टोग्राफी: एन्क्रिप्शन](https://www.youtube.com/watch?v=9TNI2wHmaeI&index=31&list=PLUl4u3cNGP6317WaSNfmCvGym2ucw3oGp)

- ### संपीड़न
    - पहले सूचना सिद्धांत वीडियो देखना सुनिश्चित करें
    - कंप्यूटरफाइल (वीडियो):
        - [संपीड़न](https://www.youtube.com/watch?v=Lto-ajuqW3w)
        - [संपीड़न में एन्ट्रापी](https://www.youtube.com/watch?v=M5c_RFKVkko)
        - [उल्टा पेड़ (हफमैन ट्री)](https://www.youtube.com/watch?v=umTbivyJoiI)
        - [अतिरिक्त बिट्स/ट्रिट्स - हफ़मैन ट्री](https://www.youtube.com/watch?v=DV8efuB3h2g)
        - [टेक्स्ट में एलिगेंट कंप्रेशन (LZ 77 मेथड)](https://www.youtube.com/watch?v=goOa3DGezUA)
        - [पाठ संपीड़न संभावनाओं को पूरा करता है](https://www.youtube.com/watch?v=cCDCfoHTsaU)
    - [कंप्रेसर हेड वीडियो](https://www.youtube.com/playlist?list=PLOU2XLYxmsIJGErt5rrCqaSGTMyyqNt2H)
    - [(वैकल्पिक) Google डेवलपर लाइव: GZIP पर्याप्त नहीं है!](https://www.youtube.com/watch?v=whGwm0Lky2s)

- ### कंप्यूटर सुरक्षा
    - [एमआईटी (23 वीडियो)](https://www.youtube.com/playlist?list=PLUl4u3cNGP62K2DjQLRxDNRi0z2IRWnNh)
        - [परिचय, थ्रेट मॉडल](https://www.youtube.com/watch?v=GqmQg-cszw4&index=1&list=PLUl4u3cNGP62K2DjQLRxDNRi0z2IRWnNh)
        - [अपहरण हमलों को नियंत्रित करें](https://www.youtube.com/watch?v=6bwzNg5qQ0o&list=PLUl4u3cNGP62K2DjQLRxDNRi0z2IRWnNh&index=2)
        - [बफ़र ओवरफ़्लो एक्सप्लॉइट्स एंड डिफेंस](https://www.youtube.com/watch?v=drQyrzRoRiA&list=PLUl4u3cNGP62K2DjQLRxDNRi0z2IRWnNh&index=3)
        - [विशेषाधिकार पृथक्करण](https://www.youtube.com/watch?v=6SIJmoE9L9g&index=4&list=PLUl4u3cNGP62K2DjQLRxDNRi0z2IRWnNh)
        - [क्षमता](https://www.youtube.com/watch?v=8VqTSY-11F4&index=5&list=PLUl4u3cNGP62K2DjQLRxDNRi0z2IRWnNh)
        - [सैंडबॉक्सिंग नेटिव कोड](https://www.youtube.com/watch?v=VEV74hwASeU&list=PLUl4u3cNGP62K2DjQLRxDNRi0z2IRWnNh&index=6)
        - [वेब सुरक्षा मॉडल](https://www.youtube.com/watch?v=chkFBigodIw&index=7&list=PLUl4u3cNGP62K2DjQLRxDNRi0z2IRWnNh)
        - [वेब एप्लिकेशन सुरक्षित करना](https://www.youtube.com/watch?v=EBQIGy1ROLY&index=8&list=PLUl4u3cNGP62K2DjQLRxDNRi0z2IRWnNh)
        - [प्रतीकात्मक निष्पादन](https://www.youtube.com/watch?v=yRVZPvHYHzw&index=9&list=PLUl4u3cNGP62K2DjQLRxDNRi0z2IRWnNh)
        - [नेटवर्क सुरक्षा](https://www.youtube.com/watch?v=SIEVvk3NVuk&index=11&list=PLUl4u3cNGP62K2DjQLRxDNRi0z2IRWnNh)
        - [नेटवर्क प्रोटोकॉल](https://www.youtube.com/watch?v=QOtA76ga_fY&index=12&list=PLUl4u3cNGP62K2DjQLRxDNRi0z2IRWnNh)
        - [साइड-चैनल अटैक](https://www.youtube.com/watch?v=PuVMkSEcPiI&index=15&list=PLUl4u3cNGP62K2DjQLRxDNRi0z2IRWnNh)

- ### कचरा संग्रहण
    - [पायथन में जीसी (वीडियो)](https://www.youtube.com/watch?v=iHVs_HkjdmI)
    - [डीप डाइव जावा: कचरा संग्रह अच्छा है!](https://www.infoq.com/presentations/garbage-collection-benefits)
    - [डीप डाइव पायथन: सीपीथॉन में कचरा संग्रह (वीडियो)](https://www.youtube.com/watch?v=P-8Z0-MhdQs&list=PLdzf4Clw0VbOEWOS_sLhT_9zaiQDrS5AR&index=3)

- ### समानांतर प्रोग्रामिंग
    - [कोर्सेरा (स्काला)](https://www.coursera.org/learn/parprog1/home/week/1)
    - [उच्च प्रदर्शन समानांतर कंप्यूटिंग के लिए कुशल पायथन (वीडियो)](https://www.youtube.com/watch?v=uY85GkaYzBk)

- ### मैसेजिंग, सीरियलाइज़ेशन और क्यूइंग सिस्टम
    - [बचत](https://thrift.apache.org/)
        - [ट्यूटोरियल](http://thrift-tutorial.readthedocs.io/en/latest/intro.html)
    - [प्रोटोकॉल बफ़र्स](https://developers.google.com/protocol-buffers/)
        - [ट्यूटोरियल](https://developers.google.com/protocol-buffers/docs/tutorials)
    - [जीआरपीसी] (http://www.grpc.io/)
        - [Java Developers के लिए gRPC 101 (वीडियो)](https://www.youtube.com/watch?v=5tmPvSe7xXQ&list=PLcTqM9n_dieN0k1nSeN36Z_ppKnvMJoly&index=1)
    - [रेडिस] (http://redis.io/)
        - [ट्यूटोरियल] (http://try.redis.io/)
    - [अमेज़ॅन एसक्यूएस (कतार)] (https://aws.amazon.com/sqs/)
    - [अमेज़ॅन एसएनएस (पब-सब)](https://aws.amazon.com/sns/)
    - [RabbitMQ](https://www.rabbitmq.com/)
        - [आरंभ करें](https://www.rabbitmq.com/getstarted.html)
    - [अजवाइन](http://www.celeryproject.org/)
        - [अजवाइन के साथ पहला कदम](http://docs.celeryproject.org/en/latest/getting-started/first-steps-with-celery.html)
    - [ZeroMQ](http://zeromq.org/)
        - [परिचय - मैनुअल पढ़ें](http://zeromq.org/intro:read-the-manual)
    - [एक्टिवएमक्यू] (http://activemq.apache.org/)
    - [काफ्का](http://kafka.apache.org/documentation.html#introduction)
    - [MessagePack](http://msgpack.org/index.html)
    - [एव्रो](https://avro.apache.org/)

- ### ए*
    - [एक खोज एल्गोरिथम](https://en.wikipedia.org/wiki/A*_search_algorithm)
    - [ए* पाथफाइंडिंग (E01: एल्गोरिथम स्पष्टीकरण) (वीडियो)](https://www.youtube.com/watch?v=-L-WgKMFuhE)

- ### फास्ट फूरियर ट्रांसफॉर्म
    - [फूरियर ट्रांसफॉर्म के लिए एक इंटरएक्टिव गाइड](https://betterexplained.com/articles/an-interactive-guide-to-the-fourier-transform/)
    - [फूरियर रूपांतरण क्या है? इसका उपयोग किस लिए किया जाता है?](http://www.askamathematician.com/2012/09/q-what-is-a-fourier-transform-what-is-it-used-for/)
    - [फूरियर रूपांतरण क्या है? (वीडियो)](https://www.youtube.com/watch?v=Xxut2PN-V8Q)
    - [फूट डालो और जीतो: एफएफटी (वीडियो)](https://www.youtube.com/watch?v=iTMn0Kt18tg&list=PLUl4u3cNGP6317WaSNfmCvGym2ucw3oGp&index=4)
    - [एफएफटी को समझना](http://jakevdp.github.io/blog/2013/08/28/understanding-the-fft/)

- ### ब्लूम फ़िल्टर
    - एम बिट्स और के हैशिंग फ़ंक्शन के साथ ब्लूम फ़िल्टर को देखते हुए, सम्मिलन और सदस्यता परीक्षण दोनों ओ (के) हैं
    - [ब्लूम फिल्टर (वीडियो)](https://www.youtube.com/watch?v=-SuTGoFYjZs)
    - [ब्लूम फिल्टर | विशाल डेटासेट का खनन | स्टैनफोर्ड यूनिवर्सिटी (वीडियो)](https://www.youtube.com/watch?v=qBTdukbzc78)
    - [ट्यूटोरियल](http://billmill.org/bloomfilter-tutorial/)
    - [ब्लूम फ़िल्टर ऐप कैसे लिखें](http://blog.michaelschmatz.com/2016/04/11/how-to-write-a-bloom-filter-cpp/)

- ### हाइपरलॉग लॉग
    - [केवल 1.5KB मेमोरी का उपयोग करके एक अरब विशिष्ट वस्तुओं की गणना कैसे करें](http://highscalability.com/blog/2012/4/5/big-data-counting-how-to-count-a-billion-distinct -ऑब्जेक्ट्स-us.html)

- ### इलाके-संवेदनशील हैशिंग
    - दस्तावेजों की समानता निर्धारित करने के लिए प्रयुक्त
    - MD5 या SHA के विपरीत जिनका उपयोग यह निर्धारित करने के लिए किया जाता है कि क्या 2 दस्तावेज़/स्ट्रिंग बिल्कुल समान हैं
    - [सिम्हाशिंग (उम्मीद है) मेड सिंपल](http://ferd.ca/simhashing-hopefully-made-simple.html)

- ### वैन एम्दे बोस पेड़
    - [फूट डालो और जीतो: वैन एम्दे बोस ट्री (वीडियो)](https://www.youtube.com/watch?v=hmReJCupbNU&list=PLUl4u3cNGP6317WaSNfmCvGym2ucw3oGp&index=6)
    - [एमआईटी व्याख्यान नोट्स](https://ocw.mit.edu/courses/electrical-engineering-and-computer-science/6-046j-design-and-analysis-of-algorithms-spring-2012/lecture-notes /MIT6_046JS12_lec15.pdf)

- ### संवर्धित डेटा संरचनाएं
    - [सीएस 61बी लेक्चर 39: ऑगमेंटिंग डेटा स्ट्रक्चर](https://archive.org/details/ucberkeley_webcast_zksIj9O8_jc)

- ### संतुलित खोज पेड़
    - कम से कम एक प्रकार के संतुलित बाइनरी ट्री को जानें (और जानें कि इसे कैसे लागू किया जाता है):
    - "संतुलित खोज वृक्षों में, AVL और 2/3 वृक्ष अब अप्रचलित हैं, और लाल-काले वृक्ष अधिक लोकप्रिय प्रतीत होते हैं।
        एक विशेष रूप से दिलचस्प स्व-व्यवस्थित डेटा संरचना स्प्ले ट्री है, जो रोटेशन का उपयोग करती है
        किसी भी एक्सेस की गई कुंजी को रूट पर ले जाने के लिए।" - स्कीना
    - इनमें से मैंने एक स्प्ले ट्री लगाने का फैसला किया। मैंने जो पढ़ा है, उससे आप लागू नहीं करेंगे a
        आपके साक्षात्कार में संतुलित खोज वृक्ष। लेकिन मैं एक को कोडिंग करने के लिए एक्सपोजर चाहता था
        और चलो इसका सामना करते हैं, स्प्ले ट्री मधुमक्खी के घुटने हैं। मैंने बहुत सारे लाल-काले पेड़ कोड पढ़े हैं
        - स्प्ले ट्री: सम्मिलित करें, खोजें, कार्यों को हटाएं
        यदि आप लाल/काले पेड़ को लागू करना समाप्त कर देते हैं तो इन्हें आजमाएं:
        - खोज और सम्मिलन कार्य, हटाना छोड़ना
    - मैं बी-ट्री के बारे में अधिक जानना चाहता हूं क्योंकि यह बहुत बड़े डेटा सेट के साथ इतने व्यापक रूप से उपयोग किया जाता है
    - [सेल्फ बैलेंसिंग बाइनरी सर्च ट्री](https://en.wikipedia.org/wiki/Self-balancing_binary_search_tree)

    - **एवीएल पेड़**
        - प्रयोग में:
            मैं जो कह सकता हूं, उससे व्यवहार में इनका अधिक उपयोग नहीं किया जाता है, लेकिन मैं देख सकता था कि वे कहाँ होंगे:
            एवीएल पेड़ ओ (लॉग एन) खोज, सम्मिलन और हटाने का समर्थन करने वाली एक और संरचना है। यह अधिक कठोर है
            लाल-काले पेड़ों की तुलना में संतुलित, धीमी प्रविष्टि और हटाने के लिए अग्रणी लेकिन तेजी से पुनर्प्राप्ति। यह बनाता है
            डेटा संरचनाओं के लिए आकर्षक जिसे एक बार बनाया जा सकता है और पुनर्निर्माण के बिना लोड किया जा सकता है, जैसे भाषा
            शब्दकोश (या प्रोग्राम डिक्शनरी, जैसे असेंबलर या दुभाषिया के ऑपकोड)
        - [MIT AVL ट्री / AVL सॉर्ट (वीडियो)](https://www.youtube.com/watch?v=FNeL18KsWPc&list=PLUl4u3cNGP61Oq3tWYp6V_F-5jb5L2iHb&index=6)
       - [एवीएल पेड़ (वीडियो)](https://www.coursera.org/learn/data-structs/lecture/Qq5E0/avl-trees)
        - [एवीएल ट्री इंप्लीमेंटेशन (वीडियो)](https://www.coursera.org/learn/data-structs/lecture/PKEBC/avl-tree-implementation)
        - [स्प्लिट एंड मर्ज](https://www.coursera.org/learn/data-structures/lecture/22BgE/split-and-merge)

    - **स्प्ले ट्री**
        - प्रयोग में:
            स्प्ले ट्री आमतौर पर कैश, मेमोरी एलोकेटर, राउटर, कचरा संग्रहकर्ता के कार्यान्वयन में उपयोग किया जाता है,
            डेटा संपीड़न, रस्सियों (लंबे पाठ स्ट्रिंग्स के लिए प्रयुक्त स्ट्रिंग का प्रतिस्थापन), Windows NT में (वर्चुअल मेमोरी में,
            नेटवर्किंग और फाइल सिस्टम कोड) आदि
        - [सीएस 61बी: स्प्ले ट्रीज़ (वीडियो)](https://archive.org/details/ucberkeley_webcast_G5QIXywcJlY)
        - एमआईटी व्याख्यान: स्प्ले पेड़:
            - बहुत मैथली हो जाता है, लेकिन आखिरी 10 मिनट जरूर देखें।
            - [वीडियो](https://www.youtube.com/watch?v=QnPl_Y6EqMo)

    - **लाल/काले पेड़**
        - ये एक 2-3 पेड़ का अनुवाद हैं (नीचे देखें)।
        - प्रयोग में:
            लाल-काले पेड़ प्रविष्टि समय, विलोपन समय और खोज समय के लिए सबसे खराब स्थिति की गारंटी देते हैं।
            यह न केवल उन्हें समय-संवेदी अनुप्रयोगों जैसे रीयल-टाइम अनुप्रयोगों में मूल्यवान बनाता है,
            लेकिन यह उन्हें अन्य डेटा संरचनाओं में मूल्यवान बिल्डिंग ब्लॉक बनाता है जो सबसे खराब स्थिति की गारंटी प्रदान करते हैं;
            उदाहरण के लिए, कम्प्यूटेशनल ज्यामिति में उपयोग की जाने वाली कई डेटा संरचनाएं लाल-काले पेड़ों पर आधारित हो सकती हैं, और
            वर्तमान लिनक्स कर्नेल में प्रयुक्त पूर्णतः फेयर शेड्यूलर लाल-काले पेड़ों का उपयोग करता है। जावा के संस्करण 8 में,
            संग्रह हैश मैप को इस तरह संशोधित किया गया है कि लिंक्डलिस्ट का उपयोग करने के बजाय समान तत्वों को खराब के साथ संग्रहीत करने के लिए
            हैशकोड, एक लाल-काले पेड़ का उपयोग किया जाता है
        - [अदुनी - एल्गोरिथम - लेक्चर 4 (लिंक जंप टू स्टार्टिंग पॉइंट) (वीडियो)](https://youtu.be/1W3x0f_RmUo?list=PLFDnELG9dpVxQCxuD-9BSy2E7BWY3t5Sm&t=3871)
        - [अदुनी - एल्गोरिदम - व्याख्यान 5 (वीडियो)](https://www.youtube.com/watch?v=hm2GHwyKF1o&list=PLFDnELG9dpVxQCxuD-9BSy2E7BWY3t5Sm&index=5)
        - [रेड-ब्लैक ट्री](https://en.wikipedia.org/wiki/Red%E2%80%93ब्लैक_ट्री)
        - [एन इंट्रोडक्शन टू बाइनरी सर्च एंड रेड ब्लैक ट्री](https://www.topcoder.com/thrive/articles/An%20Introduction%20to%20Binary%20Search%20and%20Red-Black%20Trees)

    - **2-3 पेड़ खोजें**
        - प्रयोग में:
            धीमी खोजों की कीमत पर 2-3 पेड़ों में तेजी से सम्मिलित होते हैं (चूंकि ऊंचाई एवीएल पेड़ों की तुलना में अधिक है)।
        - आप 2-3 पेड़ का प्रयोग बहुत ही कम करेंगे क्योंकि इसके कार्यान्वयन में विभिन्न प्रकार के नोड्स शामिल हैं। इसकी जगह लोग लाल काले पेड़ों का इस्तेमाल करते हैं।
        - [23-वृक्ष अंतर्ज्ञान और परिभाषा (वीडियो)](https://www.youtube.com/watch?v=C3SsdUqasD4&list=PLA5Lqm4uh9Bbq-E0ZnqTIa8LRaL77ica6&index=2)
        - [23-ट्री का बाइनरी व्यू](https://www.youtube.com/watch?v=iYvBtGKsqSg&index=3&list=PLA5Lqm4uh9Bbq-E0ZnqTIa8LRaL77ica6)
        - [2-3 पेड़ (छात्र पाठ) (वीडियो)](https://www.youtube.com/watch?v=TOb1tuEZ2X4&index=5&list=PLUl4u3cNGP6317WaSNfmCvGym2ucw3oGp)

    - **2-3-4 पेड़ (उर्फ 2-4 पेड़)**
        - प्रयोग में:
            प्रत्येक 2-4 पेड़ के लिए, समान क्रम में डेटा तत्वों के साथ संबंधित लाल-काले पेड़ होते हैं। सम्मिलन और विलोपन
            2-4 पेड़ों पर संचालन भी लाल-काले पेड़ों में रंग-फ्लिपिंग और घुमाव के बराबर है। इससे 2-4 पेड़ बन जाते हैं
            लाल-काले पेड़ों के पीछे के तर्क को समझने के लिए महत्वपूर्ण उपकरण, और यही कारण है कि कई परिचयात्मक एल्गोरिथम ग्रंथ परिचय देते हैं
            लाल-काले पेड़ों के ठीक पहले 2-4 पेड़, भले ही **2-4 पेड़ अक्सर व्यवहार में उपयोग नहीं किए जाते**।
        - [सीएस 61बी व्याख्यान 26: संतुलित खोज पेड़ (वीडियो)](https://archive.org/details/ucberkeley_webcast_zqrqYXkth6Q)
        - [नीचे ऊपर 234-पेड़ (वीडियो)](https://www.youtube.com/watch?v=DQdMYevEyE4&index=4&list=PLA5Lqm4uh9Bbq-E0ZnqTIa8LRaL77ica6)
        - [ऊपर से नीचे 234-पेड़ (वीडियो)](https://www.youtube.com/watch?v=2679VQ26Fp4&list=PLA5Lqm4uh9Bbq-E0ZnqTIa8LRaL77ica6&index=5)

    - **N-ary (K-ary, M-ary) पेड़**
        - नोट: एन या के शाखा कारक है (अधिकतम शाखाएं)
        - बाइनरी ट्री एक 2-एरी ट्री है, ब्रांचिंग फैक्टर के साथ = 2
        - 2-3 पेड़ हैं 3-आर्य
        - [के-आरी ट्री](https://en.wikipedia.org/wiki/K-ary_tree)

    - **बी-पेड़**
        - मजेदार तथ्य: यह एक रहस्य है, लेकिन बी बोइंग, बैलेंस्ड या बायर (सह-आविष्कारक) के लिए खड़ा हो सकता है।
        - प्रयोग में:
            बी-पेड़ व्यापक रूप से डेटाबेस में उपयोग किए जाते हैं। अधिकांश आधुनिक फाइल सिस्टम बी-पेड़ (या वेरिएंट) का उपयोग करते हैं। निम्न के अलावा
            डेटाबेस में इसका उपयोग, बी-पेड़ का उपयोग फाइल सिस्टम में भी किया जाता है ताकि मनमाने ढंग से त्वरित यादृच्छिक पहुंच की अनुमति मिल सके
            किसी विशेष फ़ाइल में ब्लॉक करें। मूल समस्या फ़ाइल ब्लॉक i एड्रेस को डिस्क ब्लॉक में बदल रही है
            (या शायद एक सिलेंडर-हेड-सेक्टर के लिए) पता
        - [बी-ट्री](https://en.wikipedia.org/wiki/B-tree)
        - [बी-ट्री डेटास्ट्रक्चर](http://btechsmartclass.com/data_structures/b-trees.html)
        - [बी-पेड़ों का परिचय (वीडियो)](https://www.youtube.com/watch?v=I22wEC1tTGo&list=PLA5Lqm4uh9Bbq-E0ZnqTIa8LRaL77ica6&index=6)
        - [बी-ट्री डेफिनिशन एंड इंसर्शन (वीडियो)](https://www.youtube.com/watch?v=s3bCdZGrgpA&index=7&list=PLA5Lqm4uh9Bbq-E0ZnqTIa8LRaL77ica6)
        - [बी-ट्री डिलीशन (वीडियो)](https://www.youtube.com/watch?v=svfnVhJOfMc&index=8&list=PLA5Lqm4uh9Bbq-E0ZnqTIa8LRaL77ica6)
        - [MIT 6.851 - मेमोरी पदानुक्रम मॉडल (वीडियो)](https://www.youtube.com/watch?v=V3omVLzI0WE&index=7&list=PLUl4u3cNGP61hsJNdULdudlRL493b-XZf)
                - कैशे-अनभिज्ञ बी-पेड़ों को शामिल करता है, बहुत ही रोचक डेटा संरचनाएं
                - पहले 37 मिनट बहुत तकनीकी हैं, छोड़े जा सकते हैं (बी ब्लॉक आकार, कैश लाइन आकार है)


- ### के-डी पेड़
    - एक आयत या उच्च आयाम वाली वस्तु में अंकों की संख्या खोजने के लिए बढ़िया
    - k-निकटतम पड़ोसियों के लिए एक अच्छा फिट
    - [केएनएन के-डी ट्री एल्गोरिथम (वीडियो)](https://www.youtube.com/watch?v=Y4ZgLlDfKDg)

- ### सूचियां छोड़ें
    - "ये कुछ हद तक एक पंथ डेटा संरचना के हैं" - स्कीना
    - [रैंडमाइज़ेशन: स्किप लिस्ट (वीडियो)](https://www.youtube.com/watch?v=2g9OSRKJuzM&index=10&list=PLUl4u3cNGP6317WaSNfmCvGym2ucw3oGp)
    - [एनिमेशन और थोड़ा और विवरण के लिए](https://en.wikipedia.org/wiki/Skip_list)

- ### नेटवर्क प्रवाह
    - [फोर्ड-फुलकरसन 5 मिनट में — स्टेप बाय स्टेप उदाहरण (वीडियो)](https://www.youtube.com/watch?v=Tl90tNtKvxs)
    - [फोर्ड-फुलकर्सन एल्गोरिथम (वीडियो)](https://www.youtube.com/watch?v=v1VgJmkEJW0)
    - [नेटवर्क फ़्लो (वीडियो)](https://www.youtube.com/watch?v=2vhN4Ice5jI)

- ### अलग सेट और संघ खोजें
    - [यूसीबी 61बी - डिसजॉइंट सेट; छँटाई और चयन (वीडियो)](https://archive.org/details/ucberkeley_webcast_MAEGXTwmUsI)
    - [सेजविक एल्गोरिथम - यूनियन-फाइंड (6 वीडियो)](https://www.coursera.org/learn/algorithms-part1/home/week/1)

- ### फास्ट प्रोसेसिंग के लिए गणित
    - [पूर्णांक अंकगणित, करात्सुबा गुणन (वीडियो)](https://www.youtube.com/watch?v=eCaXlAaN2uE&index=11&list=PLUl4u3cNGP61Oq3tWYp6V_F-5jb5L2iHb)
    - [चीनी अवशेष प्रमेय (क्रिप्टोग्राफी में प्रयुक्त) (वीडियो)](https://www.youtube.com/watch?v=ru7mWZJlRQg)

- ### ट्रीप
    - बाइनरी सर्च ट्री और ढेर का संयोजन
    - [ट्रीप](https://en.wikipedia.org/wiki/Treap)
    - [डेटा संरचनाएं: समझाया गया जाल (वीडियो)](https://www.youtube.com/watch?v=6podLUYinH8)
    - [सेट ऑपरेशंस में एप्लिकेशन](https://www.cs.cmu.edu/~scandal/papers/treaps-spaa98.pdf)

- ### रैखिक प्रोग्रामिंग (वीडियो)
    - [रैखिक प्रोग्रामिंग](https://www.youtube.com/watch?v=M4K6HYLHREQ)
    - [न्यूनतम लागत ढूँढना](https://www.youtube.com/watch?v=2ACJ9ewUC6U)
    - [अधिकतम मूल्य ढूँढना](https://www.youtube.com/watch?v=8AA_81xI3ik)
    - [पायथन के साथ रैखिक समीकरण हल करें - सिम्पलेक्स एल्गोरिथम](https://www.youtube.com/watch?v=44pAWI7v5Zk)

- ### ज्यामिति, उत्तल पतवार (वीडियो)
    - [ग्राफ Alg. IV: ज्यामितीय एल्गोरिदम का परिचय - व्याख्यान 9](https://youtu.be/XIAQRlNkJAw?list=PLFDnELG9dpVxQCxuD-9BSy2E7BWY3t5Sm&t=3164)
    - [ज्यामितीय एल्गोरिदम: ग्राहम और जार्विस - व्याख्यान 10](https://www.youtube.com/watch?v=J5aJEcOr6Eo&index=10&list=PLFDnELG9dpVxQCxuD-9BSy2E7BWY3t5Sm)
    - [फूट डालो और जीतो: उत्तल हल, माध्यिका खोज](https://www.youtube.com/watch?v=EzeYI7p9MjU&list=PLUl4u3cNGP6317WaSNfmCvGym2ucw3oGp&index=2)

- ### डिस्क्रीट मैथ
    - [कंप्यूटर साइंस 70, 001 - स्प्रिंग 2015 - असतत गणित और संभाव्यता सिद्धांत](http://www.infocobuild.com/education/audio-video-courses/computer-science/cs70-spring2015-berkeley.html)
    - [शाई सिमोंसन द्वारा असतत गणित (19 वीडियो)](https://www.youtube.com/playlist?list=PLWX710qNZo_sNlSWRMVIh6kfTjolNaZ8t)
    - [आईआईटी रोपड़ एनपीटीईएल द्वारा असतत गणित](https://nptel.ac.in/courses/106/106/106106183/)

---

## कुछ विषयों पर अतिरिक्त विवरण

    मैंने इन्हें ऊपर प्रस्तुत किए गए कुछ विचारों को सुदृढ़ करने के लिए जोड़ा, लेकिन उन्हें शामिल नहीं करना चाहता था
    ऊपर क्योंकि यह बहुत अधिक है। किसी विषय पर इसे ज़्यादा करना आसान है।
    आप इस सदी में काम पर रखना चाहते हैं, है ना?

- **ठोस**
    - [ ] [बॉब मार्टिन सॉलिड प्रिंसिपल्स ऑफ़ ऑब्जेक्ट ओरिएंटेड एंड एजाइल डिज़ाइन (वीडियो)](https://www.youtube.com/watch?v=TMuno5RZNeE)
    - [ ] एस - [एकल उत्तरदायित्व सिद्धांत](http://www.oodesign.com/single-responsibility-principle.html) | [प्रत्येक वस्तु के लिए एकल जिम्मेदारी](http://www.javacodegeeks.com/2011/11/solid-single-responsibility-principle.html)
        - [अधिक स्वाद](https://docs.google.com/open?id=0ByOwmqah_nuGNHEtcU5OekdDMkk)
    - [ ] ओ - [खुला/बंद सिद्धांत](http://www.oodesign.com/open-close-principle.html) | [उत्पादन स्तर पर वस्तुएं विस्तार के लिए तैयार हैं लेकिन संशोधन के लिए नहीं](https://en.wikipedia.org/wiki/Open/closed_principle)
        - [अधिक स्वाद](http://docs.google.com/a/cleancoder.com/viewer?a=v&pid=explorer&chrome=true&srcid=0BwhCYaYDn8EgN2M5MTkwM2EtNWFkZC00ZTI3LWFjZTUtNTFhZGZiYhlUzODc)
    - [ ] एल - [लिस्कोव प्रतिस्थापन सिद्धांत](http://www.oodesign.com/liskov-s-substitute-principle.html) | [आधार वर्ग और व्युत्पन्न वर्ग 'आईएस ए' सिद्धांत का पालन करते हैं](http://stackoverflow.com/questions/56860/what-is-the-liskov-substitute-principle)
        - [अधिक स्वाद](http://docs.google.com/a/cleancoder.com/viewer?a=v&pid=explorer&chrome=true&srcid=0BwhCYaYDn8EgNzAzZjA5ZmItNjU3NS00MzQ5LTkwYjMtMDJhNDU5ZTMlh&hl&hl)
    - [ ] मैं - [इंटरफ़ेस अलगाव सिद्धांत] (http://www.oodesign.com/interface-segregation-principle.html) | ग्राहकों को उन इंटरफेस को लागू करने के लिए मजबूर नहीं किया जाना चाहिए जिनका वे उपयोग नहीं करते हैं
        - [5 मिनट में इंटरफ़ेस अलग करने का सिद्धांत (वीडियो)](https://www.youtube.com/watch?v=3CtAfl7aXAQ)
        - [अधिक स्वाद](http://docs.google.com/a/cleancoder.com/viewer?a=v&pid=explorer&chrome=true&srcid=0BwhCYaYDn8EgOTViYjJhYzMtMzYxMC00MzFjLWJjMzYtOGJiMDc5N2JkYm)
    - [ ] डी - [निर्भरता उलटा सिद्धांत] (http://www.oodesign.com/dependency-inversion-principle.html) | वस्तुओं की संरचना में निर्भरता कम करें।
        - [निर्भरता उलटा सिद्धांत क्यों है और यह महत्वपूर्ण क्यों है](http://stackoverflow.com/questions/62539/what-is-the-dependency-inversion-principle-and-why-is-it-important)
        - [अधिक स्वाद](http://docs.google.com/a/cleancoder.com/viewer?a=v&pid=explorer&chrome=true&srcid=0BwhCYaYDn8EgMjdlMWIzNGUtZTQ0NC00ZjQ5LTkwYzQtZjRhMDRlNTQ3ZGMz&hl=hi
 - **संघ-ढूंढें**
    - [अवलोकन](https://www.coursera.org/learn/data-structs/lecture/JssSY/overview)
    - [बेवकूफ कार्यान्वयन](https://www.coursera.org/learn/data-structs/lecture/EM5D0/naive-implementations)
    - [पेड़](https://www.coursera.org/learn/data-structures/lecture/Mxu0w/trees)
    - [यूनियन बाय रैंक](https://www.coursera.org/learn/data-structures/lecture/qb4c2/union-by-rank)
    - [पथ संपीड़न](https://www.coursera.org/learn/data-structs/lecture/Q9CVI/path-compression)
    - [विश्लेषण विकल्प](https://www.coursera.org/learn/data-structs/lecture/GQQLN/analysis-Optional)

- **अधिक गतिशील प्रोग्रामिंग** (वीडियो)
    - [6.006: डायनेमिक प्रोग्रामिंग I: फिबोनाची, सबसे छोटे रास्ते](https://www.youtube.com/watch?v=r4-cftqTcdI&ab_channel=MITOpenCourseWare)
    - [6.006: डायनामिक प्रोग्रामिंग II: टेक्स्ट जस्टिफिकेशन, ब्लैकजैक](https://www.youtube.com/watch?v=KLBCUx1is2c&ab_channel=MITOpenCourseWare)
    - [6.006: डीपी III: कोष्ठक, संपादित दूरी, नॅप्सैक](https://www.youtube.com/watch?v=TDo3r5M1LNo&ab_channel=MITOpenCourseWare)
    - [6.006: डीपी IV: गिटार फिंगरिंग, टेट्रिस, सुपर मारियो ब्रदर्स] (https://www.youtube.com/watch?v=i9OAOk0CUQE&ab_channel=MITOpenCourseWare)
    - [6.046: डायनामिक प्रोग्रामिंग और उन्नत डीपी](https://www.youtube.com/watch?v=Tw1k46ywN6E&index=14&list=PLUl4u3cNGP6317WaSNfmCvGym2ucw3oGp)
    - [6.046: डायनामिक प्रोग्रामिंग: ऑल-पेयर्स शॉर्टेस्ट पाथ्स](https://www.youtube.com/watch?v=NzgFUwOaoIw&list=PLUl4u3cNGP6317WaSNfmCvGym2ucw3oGp&index=15)
    - [6.046: डायनामिक प्रोग्रामिंग (छात्र पाठ)](https://www.youtube.com/watch?v=krZI60lKPek&list=PLUl4u3cNGP6317WaSNfmCvGym2ucw3oGp&index=12)

- **उन्नत ग्राफ़ प्रोसेसिंग** (वीडियो)
    - [तुल्यकालिक वितरित एल्गोरिदम: समरूपता-ब्रेकिंग। सबसे छोटे रास्ते फैले पेड़](https://www.youtube.com/watch?v=mUBmcbbJNf4&list=PLUl4u3cNGP6317WaSNfmCvGym2ucw3oGp&index=27)
    - [एसिंक्रोनस डिस्ट्रिब्यूटेड एल्गोरिथम: सबसे छोटे पथ फैले पेड़](https://www.youtube.com/watch?v=kQ-UQAzcnzA&list=PLUl4u3cNGP6317WaSNfmCvGym2ucw3oGp&index=28)
- एमआईटी **संभाव्यता** (मैथी, और धीरे-धीरे जाएं, जो मैथी चीजों के लिए अच्छा है) (वीडियो):
    - [MIT 6.042J - प्रायिकता परिचय](https://www.youtube.com/watch?v=SmFwFdESMHI&index=18&list=PLB7540DEDD482705B)
    - [MIT 6.042J - सशर्त संभावना](https://www.youtube.com/watch?v=E6FbvM-FGZ8&index=19&list=PLB7540DEDD482705B)
    - [एमआईटी 6.042जे - इंडिपेंडेंस](https://www.youtube.com/watch?v=l1BCv3qqW4A&index=20&list=PLB7540DEDD482705B)
    - [MIT 6.042J - रैंडम वैरिएबल](https://www.youtube.com/watch?v=MOfhhFaQdjw&list=PLB7540DEDD482705B&index=21)
    - [MIT 6.042J - उम्मीद I](https://www.youtube.com/watch?v=gGlMSe7uEkA&index=22&list=PLB7540DEDD482705B)
    - [MIT 6.042J - उम्मीद II](https://www.youtube.com/watch?v=oI9fMUqgfxY&index=23&list=PLB7540DEDD482705B)
    - [MIT 6.042J - बड़े विचलन](https://www.youtube.com/watch?v=q4mwO2qS2z4&index=24&list=PLB7540DEDD482705B)
    - [MIT 6.042J - रैंडम वॉक](https://www.youtube.com/watch?v=56iFMY8QW2k&list=PLB7540DEDD482705B&index=25)

- [साइमनसन: सन्निकटन एल्गोरिदम (वीडियो)](https://www.youtube.com/watch?v=oDniZCmNmNw&list=PLFDnELG9dpVxQCxuD-9BSy2E7BWY3t5Sm&index=19)

- **स्ट्रिंग मिलान**
    - राबिन-कार्प (वीडियो):
        - [राबिन कार्प्स एल्गोरिथम](https://www.coursera.org/lecture/data-structs/rabin-karps-algorithm-c0Qkw)
        - [प्रीकंप्यूटिंग](https://www.coursera.org/learn/data-structs/lecture/nYrc8/optimization-precomputation)
        - [ऑप्टिमाइज़ेशन: क्रियान्वयन और विश्लेषण](https://www.coursera.org/learn/data-structs/lecture/h4ZLc/optimization-implementation-and-analysis)
        - [टेबल डबलिंग, कार्प-राबिन](https://www.youtube.com/watch?v=BRO7mVIFt08&list=PLUl4u3cNGP61Oq3tWYp6V_F-5jb5L2iHb&index=9)
        - [रोलिंग हैश, अमूर्त विश्लेषण](https://www.youtube.com/watch?v=w6nuXg0BISo&list=PLUl4u3cNGP61Oq3tWYp6V_F-5jb5L2iHb&index=32)
    - नुथ-मॉरिस-प्रैट (केएमपी):
        - [टी द नुथ-मॉरिस-प्रैट (केएमपी) स्ट्रिंग मैचिंग एल्गोरिथम](https://www.youtube.com/watch?v=5i7oKodCRJo)
    - बॉयर-मूर स्ट्रिंग सर्च एल्गोरिथम
        - [बॉयर-मूर स्ट्रिंग सर्च एल्गोरिथम](https://en.wikipedia.org/wiki/Boyer%E2%80%93Moore_string_search_algorithm)
        - [उन्नत स्ट्रिंग खोज बॉयर-मूर-हॉर्सपूल एल्गोरिदम (वीडियो)](https://www.youtube.com/watch?v=QDZpzctPf10)
    - [पाठ्यक्रम: स्ट्रिंग्स पर एल्गोरिदम](https://www.coursera.org/learn/algorithms-on-strings/home/week/1)
        - बहुत अच्छी शुरुआत होती है, लेकिन जब तक यह केएमपी से आगे निकल जाता है तब तक यह जरूरत से ज्यादा जटिल हो जाता है
        - कोशिशों की अच्छी व्याख्या
        - छोड़ा जा सकता है
- **क्रमबद्ध करना**

    - स्टैनफोर्ड छँटाई पर व्याख्यान:
        - [व्याख्यान 15 | प्रोग्रामिंग एब्स्ट्रैक्शन (वीडियो)](https://www.youtube.com/watch?v=ENp00xylP7c&index=15&list=PLFE6E58F856038C69)
        - [व्याख्यान 16 | प्रोग्रामिंग एब्स्ट्रैक्शन (वीडियो)](https://www.youtube.com/watch?v=y4M9IVgrVKo&index=16&list=PLFE6E58F856038C69)
    - शाई सिमोंसन, [Aduni.org](http://www.aduni.org/):
        - [एल्गोरिदम - छँटाई - व्याख्यान 2 (वीडियो)](https://www.youtube.com/watch?v=odNJmw5TOEE&list=PLFDnELG9dpVxQCxuD-9BSy2E7BWY3t5Sm&index=2)
        - [एल्गोरिदम - सॉर्टिंग II - लेक्चर 3 (वीडियो)](https://www.youtube.com/watch?v=hj8YKFTFKEE&list=PLFDnELG9dpVxQCxuD-9BSy2E7BWY3t5Sm&index=3)
    - स्टीवन स्कीएना छँटाई पर व्याख्यान:
        - [CSE373 2020 - मर्जसॉर्ट/क्विकसॉर्ट (वीडियो)](https://www.youtube.com/watch?v=jUf-UQ3a0kg&list=PLOtl7M3yp-DX6ic0HGT0PUX_wiNmkWkXx&index=8)
        - [CSE373 2020 - लीनियर सॉर्टिंग (वीडियो)](https://www.youtube.com/watch?v=0ksyQKmre84&list=PLOtl7M3yp-DX6ic0HGT0PUX_wiNmkWkXx&index=9)

## वीडियो श्रृंखला

वापस बैठो और आनंद लो।

- [व्यक्तिगत गतिशील प्रोग्रामिंग समस्याओं की सूची (प्रत्येक संक्षिप्त है)](https://www.youtube.com/playlist?list=PLrmLmBdmIlpsHaNTPP_jHHDx_os9ItYXr)

- [x86 आर्किटेक्चर, असेंबली, एप्लिकेशन (11 वीडियो)](https://www.youtube.com/playlist?list=PL038BE01D3BAEFDB0)

- [MIT 18.06 रैखिक बीजगणित, वसंत 2005 (35 वीडियो)](https://www.youtube.com/playlist?list=PLE7DDD91010BC51F8)

- [उत्कृष्ट - एमआईटी कैलकुलस पर दोबारा गौर किया गया: सिंगल वेरिएबल कैलकुलस](https://www.youtube.com/playlist?list=PL3B08AE665AB9002A)

- [एल्गोरिदम डिज़ाइन मैनुअल से स्कीएना व्याख्यान - CSE373 2020 - एल्गोरिदम का विश्लेषण (26 वीडियो)](https://www.youtube.com/watch?v=22hwcnXIGgk&list=PLOtl7M3yp-DX6ic0HGT0PUX_wiNmkWkXx&index=1)

- [यूसी बर्कले 61बी (स्प्रिंग 2014): डेटा संरचनाएं (25 वीडियो)](https://archive.org/details/ucberkeley-webcast-PL-XXv-cvA_iAlnI-BQr9hjqADPBtujFJd)

- [यूसी बर्कले 61बी (पतन 2006): डेटा संरचनाएं (39 वीडियो)](https://archive.org/details/ucberkeley-webcast-PL4BBB74C7D2A1049C)

- [यूसी बर्कले 61सी: मशीन संरचनाएं (26 वीडियो)](https://archive.org/details/ucberkeley-webcast-PL-XXv-cvA_iCl2-D-FS5mk0jFF6cYSJs_)

- [OOSE: UML और Java का उपयोग करने वाला सॉफ़्टवेयर डेवलपर (21 वीडियो)](https://www.youtube.com/playlist?list=PLJ9pm_Rc9HesnkwKlal_buSIHA-jTZMpO)

- [MIT 6.004: संगणना संरचनाएं (49 वीडियो)](https://www.youtube.com/playlist?list=PLDSlqjcPpoL64CJdF0Qee5oWqGS6we_Yu)

- [कार्नेगी मेलन - कंप्यूटर आर्किटेक्चर लेक्चर (39 वीडियो)](https://www.youtube.com/playlist?list=PL5PHm2jkkXmi5CxxI7b3JCL1TWybTDtKq)

- [MIT 6.006: एल्गोरिदम का परिचय (47 वीडियो)](https://www.youtube.com/watch?v=HtSuA80QTyo&list=PLUl4u3cNGP61Oq3tWYp6V_F-5jb5L2iHb&nohtml5=False)

- [MIT 6.033: कंप्यूटर सिस्टम इंजीनियरिंग (22 वीडियो)](https://www.youtube.com/watch?v=zm2VP0kHl1M&list=PL6535748F59DCA484)

- [MIT 6.034 आर्टिफिशियल इंटेलिजेंस, फॉल 2010 (30 वीडियो)](https://www.youtube.com/playlist?list=PLUl4u3cNGP63gFHB6xb-kVBiQHYe_4hSi)

- [MIT 6.042J: कंप्यूटर साइंस के लिए गणित, फॉल 2010 (25 वीडियो)](https://www.youtube.com/watch?v=L3LMbpZIKhQ&list=PLB7540DEDD482705B)

- [MIT 6.046: एल्गोरिदम का डिज़ाइन और विश्लेषण (34 वीडियो)](https://www.youtube.com/watch?v=2P-yW7LQr08&list=PLUl4u3cNGP6317WaSNfmCvGym2ucw3oGp)

- [MIT 6.824: डिस्ट्रिब्यूटेड सिस्टम्स, स्प्रिंग 2020 (20 वीडियो)](https://www.youtube.com/watch?v=cQP8WApzIQQ&list=PLrw6a1wE39_tb2fErI4-WkMbsvGQk9_UB)

- [MIT 6.851: उन्नत डेटा संरचनाएं (22 वीडियो)](https://www.youtube.com/watch?v=T0yzrZL1py0&list=PLUl4u3cNGP61hsJNdULdudlRL493b-XZf&index=1)

- [MIT 6.854: उन्नत एल्गोरिदम, स्प्रिंग 2016 (24 वीडियो)](https://www.youtube.com/playlist?list=PL6ogFv-ieghdoGKGg2Bik3Gl1glBTEu8c)

- [हार्वर्ड COMPSCI 224: उन्नत एल्गोरिदम (25 वीडियो)](https://www.youtube.com/playlist?list=PL2SOU6wwxB0uP4rJgf5ayhHWgw7akUWSf)

- [MIT 6.858 कंप्यूटर सिस्टम सुरक्षा, फॉल 2014](https://www.youtube.com/watch?v=GqmQg-cszw4&index=1&list=PLUl4u3cNGP62K2DjQLRxDNRi0z2IRWnNh)
- [स्टैनफोर्ड: प्रोग्रामिंग प्रतिमान (27 वीडियो)](https://www.youtube.com/playlist?list=PL9D558D49CA734A02)

- [क्रिस्टोफ पार द्वारा क्रिप्टोग्राफी का परिचय](https://www.youtube.com/playlist?list=PL6N5qY2nvvJE8X75VkXglSrVhLv1tVcfy)
    - [स्लाइड और समस्या सेट के साथ पाठ्यक्रम वेबसाइट] (http://www.crypto-textbook.com/)

- [खनन बड़े पैमाने पर डेटासेट - स्टैनफोर्ड यूनिवर्सिटी (94 वीडियो)](https://www.youtube.com/playlist?list=PLLssT5z_DsK9JDLcT8T62VtzwyW9LNepV)

- [शारदा हर्के द्वारा ग्राफ सिद्धांत (67 वीडियो)](https://www.youtube.com/user/DrSaradaHerke/playlists?shelf_id=5&view=50&sort=dd)

## कंप्यूटर विज्ञान पाठ्यक्रम

- [ऑनलाइन सीएस पाठ्यक्रम की निर्देशिका](https://github.com/open-source-society/computer-science)
- [सीएस पाठ्यक्रमों की निर्देशिका (कई ऑनलाइन व्याख्यान के साथ)](https://github.com/prakhar1989/awesome-courses)

## एल्गोरिदम कार्यान्वयन

- [प्रिंसटन विश्वविद्यालय द्वारा एकाधिक एल्गोरिदम कार्यान्वयन](https://algs4.cs.princeton.edu/code)


## कागजात

- [क्लासिक पेपर पसंद हैं?](https://www.cs.cmu.edu/~crary/819-f09/)
- [1978: अनुक्रमिक प्रक्रियाओं का संचार](http://spinroot.com/courses/summer/Papers/hoare_1978.pdf)
    - [गो में लागू](https://godoc.org/github.com/thomas11/csp)
- [2003: द गूगल फाइल सिस्टम](http://static.googleusercontent.com/media/research.google.com/en//archive/gfs-sosp2003.pdf)
    - 2012 में कोलोसस द्वारा प्रतिस्थापित
- [2004: MapReduce: बड़े समूहों पर सरलीकृत डेटा प्रोसेसिंग]( http://static.googleusercontent.com/media/research.google.com/en//archive/mapreduce-osdi04.pdf)
    - ज्यादातर क्लाउड डेटाफ्लो द्वारा प्रतिस्थापित किया गया?
- [2006: बिगटेबल: संरचित डेटा के लिए एक वितरित भंडारण प्रणाली](https://static.googleusercontent.com/media/research.google.com/en//archive/bigtable-osdi06.pdf)
- [2006: लूजली-कपल्ड डिस्ट्रिब्यूटेड सिस्टम्स के लिए चब्बी लॉक सर्विस](https://research.google.com/archive/chubby-osdi06.pdf)
- [2007: डायनमो: अमेज़ॅन का अत्यधिक उपलब्ध की-वैल्यू स्टोर] (http://s3.amazonaws.com/AllThingsDistributed/sosp/amazon-dynamo-sosp2007.pdf)
    - डायनमो पेपर ने नोएसक्यूएल क्रांति की शुरुआत की
- [2007: प्रत्येक प्रोग्रामर को मेमोरी के बारे में क्या पता होना चाहिए (बहुत लंबा, और लेखक कुछ वर्गों को छोड़ने के लिए प्रोत्साहित करता है)](https://www.akkadia.org/drepper/cpuemory.pdf)
- 2012: एड्रेस सैनिटाइज़र: एक तेज़ पता सैनिटी चेकर:
    - [कागज](http://static.googleusercontent.com/media/research.google.com/en//pubs/archive/37752.pdf)
    - [वीडियो] (https://www.usenix.org/conference/atc12/technical-sessions/presentation/serebryany)
- 2013: स्पैनर: Google का वैश्विक रूप से वितरित डेटाबेस:
    - [कागज](http://static.googleusercontent.com/media/research.google.com/en//archive/spanner-osdi2012.pdf)
    - [वीडियो] (https://www.usenix.org/node/170855)
- [2015: Google पर सतत पाइपलाइन](http://static.googleusercontent.com/media/research.google.com/hi//pubs/archive/43790.pdf)
- [2015: बड़े पैमाने पर उच्च उपलब्धता: विज्ञापनों के लिए Google के डेटा इन्फ्रास्ट्रक्चर का निर्माण](https://static.googleusercontent.com/media/research.google.com/en//pubs/archive/44686.pdf)
- [2015: डेवलपर्स कैसे कोड की खोज करते हैं: एक केस स्टडी](http://static.googleusercontent.com/media/research.google.com/en//pubs/archive/43835.pdf)
- अधिक पेपर: [1,000 पेपर](https://github.com/0voice/computer_expert_paper)

## लाइसेंस

[CC-BY-SA-4.0](./LICENSE.txt)
